#!/bin/bash

VERSION="1"

ME=$0
CMD=$1
MY_NAME="$(basename $0)"

YASS_OPTIONS=" --sleep 1000 --log 1 "
RUNDIR="/usr/local/ave_rsa"
PKGDIR="/usr/local/ave_rsa_pkg"

YASS_CLIENT_BIN="$RUNDIR/client/yass3client"
YASS_WEB_ROOT="$RUNDIR/web/"
YASS_SQL_ROOT="$RUNDIR/sql/"
UPD_SCRIPT="$RUNDIR/run-updates.php"

SOFTWAREPKG=`ls -a $PKGDIR/yass3*.bin | tail -n 1`
    
LEGACYDATA_DIR="/usr/local/ave_hotel_json"
LEGACYDEFAULTDATA_DIR="/usr/local/ave_rsa/web/hotel/json"

WWWFINAL="/var/www/ave_rsa/web"


chmod -R 777 $YASS_WEB_ROOT/hotel
chmod 777 $PKGDIR

touch $YASS_WEB_ROOT/post-extract-runned.txt

rm /etc/rc2.d/S99yass
ln -s $YASS_WEB_ROOT/yass-rc2.sh /etc/rc2.d/S99yass

#RUN UPDATES
php -f $UPD_SCRIPT

