<?php

if(!@$_GET['generate']) {
    header('Content-Type: application/json');
    $fname = "/tmp/yassAlert.json";
    if(file_exists($fname) && is_file($fname)){
        echo file_get_contents($fname);
    }
    die;
}

require_once(realpath($_SERVER['DOCUMENT_ROOT']).'/include/config.php');
require_once(DIR_CLS . 'class.app.php');

$oApp = new app(TRUE, PERMESSO_NESSUNO);
$oApp->esegui();

/*********************************************************************************************************/
function backend_azioni_check_new_alert(&$oApp) {
    $allarmi = array();

    header('Content-Type: application/json');

    $oElencoAllarmi = new elencologallarme($oApp, FALSE, ' ORDER BY data DESC');
    $passLastCheck = @$_REQUEST['lastCheck'];
    if(!$passLastCheck) {
        $passLastCheck = date('Y-m-d H:i:s', strtotime('-1 day'));
    }
    
    $oElencoAllarmi->caricaSoloAllarmiTecniciAttivi($passLastCheck);

    $allarmi['nuovi_allarmi'] = array();
    if (!$oElencoAllarmi->isEmpty()) {
        foreach ($oElencoAllarmi->getElenco() as $oLogAllarme) {

            $messaggio = 'atrMappa.name+' - '+atrDispositivo.name+' - '+atrSottoTipoDispositivo.descrizione';
            $id = 'ip_supervisore+'-'+atrMappa.id+'-'+atrDispositivo.id+'-'+atrSottoTipoDispositivo.descrizione';

            $allarmi['nuovi_allarmi'][] = array(
                'ip'=> $oLogAllarme->get('Dispositivo@@getoggetto+descrizione') . " (" . $oLogAllarme->get('Supervisore@@getoggetto+descrizione') . ")",
                'data_ora'=>$oLogAllarme->get('data'),
                'id'=>$id,
                'messaggio'=>$messaggio
            );
        }
    }
    $allarmi['lastCheck'] = date('Y-m-d H:i:s');
    return json_encode($allarmi);
}
?>