<?php
require_once(realpath($_SERVER['DOCUMENT_ROOT']).'/include/config.php');
require_once(DIR_CLS . 'class.app.php');
	
$oApp = new app(TRUE, PERMESSO_NESSUNO);
$oApp->esegui();

/*********************************************************************************************************/
function backend_azioni_getrelatedselects(&$oApp) {
	extract($_GET);
	
	$aId = explode('-', $valoricorrelati);
	
	$idCorrente = 0;
	$successivo = FALSE;
	foreach ($aId as $i) {
		if ($successivo) {
			$idCorrente = $i;
			break;
		}
		if ($i == $$nome) {
			$successivo = TRUE;
		}
	}
	
	$oDb = $oApp->get('oDb');
	$aOption = array();
	
	if (isset($id_nazione_nascita)) $id_nazione = $id_nazione_nascita;
	if (isset($id_nazione_residenza)) $id_nazione = $id_nazione_residenza;
	if (isset($id_nazione_domicilio)) $id_nazione = $id_nazione_domicilio;
	
	if (isset($id_provincia_nascita)) $id_provincia = $id_provincia_nascita;
	if (isset($id_provincia_residenza)) $id_provincia = $id_provincia_residenza;
	if (isset($id_provincia_domicilio)) $id_provincia = $id_provincia_domicilio;
	
	if (isset($id_provincia_attivita)) $id_provincia = $id_provincia_attivita;
	
	
	if (isset($id_provincia)){
		if(is_numeric($id_provincia)){
			$sql = 'SELECT * FROM comuni WHERE id_provincia='.num2str($id_provincia).' ORDER BY desc_comune';
			$rows = $oDb->eseguiselect($sql);
			if(!empty($rows)){
				foreach ($rows as $r) {
					$aOption[$r['id_comune']] = $r['desc_comune'];
				}
			}
		
		}
	}
	
	if (isset($id_nazione) && !isset($id_provincia)){
		if(is_numeric($id_nazione)){
			if ($id_nazione == NAZIONI_ID_ITALIA) {
				$sql = 'SELECT * FROM province ORDER BY desc_provincia';
				$rows = $oDb->eseguiselect($sql);
				if(!empty($rows)){
					foreach ($rows as $r) {
						$aOption[$r['id_provincia']] = $r['desc_provincia'];
					}
				}
			}
		}
	}

	if (isset($filtro_id_regione)){
		if(is_numeric($filtro_id_regione)){
			$sql = 'SELECT * FROM province WHERE id_regione='.num2str($filtro_id_regione).' ORDER BY desc_provincia';
			$rows = $oDb->eseguiselect($sql);
			if(!empty($rows)){
				foreach ($rows as $r) {
					$aOption[$r['id_provincia']] = $r['desc_provincia'];
				}
			}
		}
	}

    if (isset($id_tipo_dispositivo)){
        if(is_numeric($id_tipo_dispositivo)){
            $sql = 'SELECT * FROM supervisore_tipo_visualizzazione WHERE id_tipo_dispositivo='.num2str($id_tipo_dispositivo).' ORDER BY ordine';
            $rows = $oDb->eseguiselect($sql);
            if(!empty($rows)){
                foreach ($rows as $r) {
                    $aOption[$r['id']] = $r[$_SESSION['LINGUA_NAVIGAZIONE']];
                }
            }
        }
    }

	$tipo_supervisore = '';

    if (isset($id_supervisore_origine)) {
		$id_supervisore = $id_supervisore_origine;
		$tipo_supervisore = 'origine';
    }
    if (isset($id_supervisore_destinazione)) {
		$id_supervisore = $id_supervisore_destinazione;
		$tipo_supervisore = 'destinazione';
	}

	if (isset($id_dispositivo_origine)) {
		$id_dispositivo = $id_dispositivo_origine;
	}

	if (isset($id_dispositivo_destinazione)) {
		$id_dispositivo = $id_dispositivo_destinazione;
	}

    if (isset($id_supervisore) && !isset($id_dispositivo)){
        if(is_numeric($id_supervisore)) {
			$oO = new supervisore($oApp, $id_supervisore);

			if($oO->id_tipo_dispositivo >= 0) {
				$rows = $oO->getArrayElencoDispositiviByIdSupervisore($oO->getId(), $tipo_supervisore);
				if(!empty($rows)){
					foreach ($rows as $r) {
						$aOption[$r['id']] = $r['descrizione'];
					}
				}
			} else if($oO->id_tipo_dispositivo == -1) {
				for ($counterCentralina = 1; $counterCentralina <= 32; $counterCentralina ++) {
					for ($counterLoop = 1; $counterLoop <= 4; $counterLoop ++) {
						$aOption[($counterCentralina * 100) + $counterLoop] = "Dev: " . $counterCentralina . " - Loop: " . $counterLoop;
					}
				}
			}
        }
    } elseif (isset($id_dispositivo)){
        if(is_numeric($id_dispositivo)) {
			
			$oO = new dispositivo($oApp, $id_dispositivo);

			$rows = $oO->getArrayElencoSottoTipoDispositiviByIdTipoDispositivo($oO->get('id_tipo_dispositivo'));

            if(!empty($rows)){
                foreach ($rows as $r) {
                    $aOption[$r['id']] = $r['sotto_tipo_dispositivo'];
                }
            }
        }
    }

	foreach ($aOption as $id => $value) {
		if (is_numeric($id)) {
			$selezionato = ((int)$idCorrente == $id);
		} else {
			$selezionato = ($idCorrente === $id);
		}
		echo '<option value="'.$id.'"'.(($selezionato)?' selected="selected"':'').'>'.$value.'</option>';
	}
}
?>