<?php

if(!@$_GET['generate']) {
    header('Content-Type: application/json');
    $fname = "/tmp/yassStatus.json";
    if(file_exists($fname) && is_file($fname)){
        echo file_get_contents($fname);
    }
    die;
}

require_once(realpath($_SERVER['DOCUMENT_ROOT']).'/include/config.php');
require_once(DIR_CLS . 'class.app.php');
	
$oApp = new app(TRUE, PERMESSO_NESSUNO);
$oApp->sezione(SEZIONE_SUPERVISORI);
$oApp->esegui();

/*********************************************************************************************************/
function backend_dashboard_ajax_status(&$oApp) {
    $result = [];

    header('Content-Type: application/json');
    $oDb = $oApp->get('oDb');
    $rows = $oDb->eseguiselect('select * from supervisore where id_status = 1');
    
    $result['threads_status'] = explode("\n", shell_exec('ps H -C yass3client -o comm'));

    foreach($rows as $idx => $row) {
        $rows[$idx]['thread_name_r'] = substr("R." . $row['id_supervisore'] . "." .  $row['descrizione'], 0, 15);
        $rows[$idx]['thread_name_p'] = substr("P." . $row['id_supervisore'] . "." .  $row['descrizione'], 0, 15);
        
        $rows[$idx]['thread_exists_r'] = in_array($rows[$idx]['thread_name_r'], $result['threads_status']) !== false;
        $rows[$idx]['thread_exists_p'] = in_array($rows[$idx]['thread_name_p'], $result['threads_status']) !== false;
        
        // $rows[$idx]['devices'] = $oDb->eseguiselect('select * from dispositivo where id_supervisore = ' . $row['id_supervisore']);
        // $rows[$idx]['maps'] = $oDb->eseguiselect('select * from mappa where id_supervisore = ' . $row['id_supervisore']);
    }

    $result['supervisor_raw_data'] = $rows;
    $alive = shell_exec("ps aux | grep -v grep |grep yass3client | awk {'print $9'} | tail -n 1 ");
    $result['server_running'] = $alive != "";
    $result['server_time'] = $alive;

    echo json_encode($result);
    die;
}
?>