<?php
require_once(realpath($_SERVER['DOCUMENT_ROOT']).'/include/config.php');
require_once(DIR_CLS . 'class.app.php');
	
$oApp = new app(TRUE);
$oApp->esegui();

/*********************************************************************************************************/
function backend_relay_azioni_modifica(&$oApp) {
    unset($_POST['evento_origine']);
    unset($_POST['comando_destinazione']);

    $oO = new relay($oApp, readPostParam('id_relay_post_encoded', TRUE));
    $redirect = URL_BACKEND.$oO->get('class_url').'modifica.php?oggetto='.$oO->get('classe').'&id_oggetto='.writeGetParam($oO->getId());

    $oSottoTipoDispositivoOrigine = new sottotipodispositivo($oApp, readPostParam('id_sotto_tipo_dispositivo_origine'));
    $oSottoTipoDispositivoOrigine->set('posizione_dato', 'origine');
    $ret = $oSottoTipoDispositivoOrigine->isFormValido($_POST, 'inserisci');
    if ($ret === TRUE) {
        $oSottoTipoDispositivoDestinazione = new sottotipodispositivo($oApp, readPostParam('id_sotto_tipo_dispositivo_destinazione'));
        $oSottoTipoDispositivoDestinazione->set('posizione_dato', 'destinazione');
        $ret = $oSottoTipoDispositivoDestinazione->isFormValido($_POST, 'inserisci');
        if ($ret === TRUE) {
            $oSottoTipoDispositivoOrigine->initByRecord($_POST);
            $oSottoTipoDispositivoDestinazione->initByRecord($_POST);
            $_POST['evento_origine'] = $oO->encodaEventoOrigineBySottoTipoDispositivo($oSottoTipoDispositivoOrigine);
            $_POST['comando_destinazione'] = $oO->encodaComandoDestinazioneBySottoTipoDispositivo($oSottoTipoDispositivoDestinazione);

            $ret = $oO->isFormValido($_POST, 'inserisci');
            if ($ret === TRUE) {
                $oO->initByRecord($_POST);
                $ret = $oO->modifica();
                if ($ret === TRUE) {
                    $oApp->redirect($redirect, $oApp->getMsgSuccesso('MODIFICA_OK'), MESSAGGIO_SUCCESSO);
                } else {
                    die('2');
                    $oApp->redirect($redirect, $oApp->getMsgErrore('MODIFICA_ERRORE'), MESSAGGIO_ERRORE);
                }
            } else {
                die('3');
                $oApp->redirect($redirect, $ret, MESSAGGIO_ERRORE);
            }
        } else {
            die('4');
            $oApp->redirect($redirect, $ret, MESSAGGIO_ERRORE);
        }
    } else {
        die('4');
        $oApp->redirect($redirect, $ret, MESSAGGIO_ERRORE);
    }
}
?>