<?php
require_once(realpath($_SERVER['DOCUMENT_ROOT']).'/include/config.php');
require_once(DIR_CLS . 'class.app.php');
	
$oApp = new app(TRUE);
$oApp->sezione(SEZIONE_RELAY);
$oApp->disegna(TEMPLATE_STANDARD);

/*********************************************************************************************************/
function backend_relay_elenco(&$oApp) {
    $oApp->apriWidget(
        'elenco_regole_relay', 
        $oApp->getEtichetta('TABELLA_ELENCO_REGOLE_RELAY') 
            . bottone($oApp, 'BOTTONE_RELAY_SOSPENDI_TUTTI', strtolower('BOTTONE_RELAY_SOSPENDI_TUTTI'))
            . bottone($oApp, 'BOTTONE_RELAY_ATTIVA_TUTTI', strtolower('BOTTONE_RELAY_ATTIVA_TUTTI'))
            . bottone($oApp, 'BOTTONE_RELAY_CREA', strtolower('BOTTONE_RELAY_CREA'), FALSE, FALSE, FALSE), 
        FALSE, FALSE, FALSE, FALSE
    );


    $oElenco = new elencorelay($oApp, TRUE);
    $oElenco->setNomeElenco('elenco_regole_relay_backend');

    $aCampi = array();

    $aCampi[] = 'SupervisoreOrigine@@getoggetto+denominazioneTabella';
    $aCampi[] = 'DispositivoOrigine@@getoggetto+denominazioneTabella';
    $aCampi[] = 'SottoTipoDispositivoOrigine@@getoggetto+denominazioneTabella';
    $aCampi[] = 'evento_origine';

    $aCampi[] = 'SupervisoreDestinazione@@getoggetto+denominazioneTabella';
    $aCampi[] = 'DispositivoDestinazione@@getoggetto+denominazioneTabella';
    $aCampi[] = 'SottoTipoDispositivoDestinazione@@getoggetto+denominazioneTabella';
    $aCampi[] = 'comando_destinazione';

    $aCampi[] = 'status';
    $aCampi[] = 'azioni';
    $oElenco->setCampiInteresse($aCampi);
    $oElenco->stampa('tabella', STYLE_DATATABLE_BASIC);
    $oApp->chiudiWidget();

}
?>