<?php
require_once(realpath($_SERVER['DOCUMENT_ROOT']).'/include/config.php');
require_once(DIR_CLS . 'class.app.php');

//$oApp = new app(TRUE);
$oApp = new app(TRUE, PERMESSO_NESSUNO);
$oApp->sezione(SEZIONE_SISTEMA);
$oApp->disegna(TEMPLATE_LOGIN);

/*********************************************************************************************************/
function backend_sistema_modo(&$oApp) {
    $mode = $oApp->loadMode();
    $isLegacy = $mode == 'legacy';
    $isYass = $mode == 'yass3';

    $_SESSION['MODO_OPERATIVO_PRIMO_CARICAMENTO_EFFETTUATO'] = true;

    $sql = " update parametri set valore = 'no' where chiave = 'LOGGED_SERVER_MODE' ";
    $oApp->oDb->eseguiupdate($sql);
    $sql = " update parametri set valore = 'undefined' where chiave = 'SERVER_MODE' ";
    $oApp->oDb->eseguiupdate($sql);

    ?>
    
    <div class="row">
        <div class="col-lg-3 col-sm-12"></div>
        <div class="col-lg-6 col-sm-12">
            <div style="height: 60px;"></div>
            <div class="row">
                <div class="col-sm-7">
                    <?php
                    /*
                    if($isLegacy) {
                        ?>
                            <img src="/hotel/images/DominaLogo.png" style="width: 280px;" />
                        <?php
                    } 
                    if($isYass) {
                        ?>
                            <img src="/img/dominaplus.png"  style="width: 200px;" />
                        <?php
                    }*/

                    ?>
                    <p style="color: white; font-size: 36px; ">53WBS-HUB</p>
                </div>
                <div class="col-sm-5">
                    <img src="/img/logoAVEnoScritte.jpg" style="width: 50px;" class="pull-right" />
                </div>
            </div>
            <div style="height: 10px;"></div>
        </div>
        <div class="col-lg-3 col-sm-12"></div>
    </div>    
    <div style="height: 48px;"></div>
    
    <?php
    $oApp->apriWidget('selezione_modo', $oApp->getEtichetta('TABELLA_SELEZIONE_MODO'), FALSE, FALSE, FALSE, FALSE);
    ?>
        <div class="row">
            <div class="col-lg-12 col-sm-12">
                <center><h5><?=utf8_encode($oApp->getEtichetta('TABELLA_SELEZIONE_MODO_DESCRIZIONE'))?></h5></center>
            </div>
            <div class="col-lg-12 col-sm-12">
                <br><hr>
            </div>
        </div>
        <div class="row">
            <div class="col ">
                <center><button style="width: 100%" id="btnSelectLegacyMode" class="btn btn-secondary "><?=utf8_encode($oApp->getEtichetta('TABELLA_SELEZIONE_MODO_LEGACY'))?></button></center>
            </div>
            <div class="col ">
                <center><button style="width: 100%" id="btnSelectYass3Mode" class="btn btn-secondary "><?=utf8_encode($oApp->getEtichetta('TABELLA_SELEZIONE_MODO_YASS3'))?></button></center>
            </div>
            <?php
                if($mode != 'undefined' && false) {
                    ?>
                        <div class="col ">
                            <center><button style="width: 100%" id="btnSelectUndefinedMode" class="btn btn-warning "><?=utf8_encode($oApp->getEtichetta('TABELLA_SELEZIONE_MODO_INDEFINITO'))?></button></center>
                        </div>
                    <?php
                }
            ?>

        </div> 
        <div class="row">
            <div class="col" style="text-align: center; margin-top: 24px;">
                <?php
                    $ver = getVersion();
                    
                    if($ver['summary']) {
                        ?> <b class="text-success">Ver. <?=$ver['summary']?></b> <?php
                    } else {
                        ?> <b class="text-danger">Unknown Version</b> <?php
                    }
                    print "(" . $ver['full'] . ")";
                ?>
            </div>
        </div>
  
        <script>
            document.addEventListener("DOMContentLoaded", function() {
                function selectMode(mode) {
                    jQuery.post("/azioni/selezione_modo.php", { 
                        'selectMode': mode
                    }) .done(function( data ) {
                        if(data == 'ok') {
                            window.location.href = "/";
                        } else {
                            alert('Error');
                        }
                    });
                }
                jQuery('#btnSelectLegacyMode').click(function(){
                    selectMode('legacy');
                });
                jQuery('#btnSelectYass3Mode').click(function(){
                    selectMode('yass3');
                });
                jQuery('#btnSelectUndefinedMode').click(function(){
                    selectMode('undefined');
                });
            });

        </script>
        
    <?php
    $oApp->chiudiWidget();
}
?>

<div class="text-center">
    &emsp;<?php
    $nLingue = count(unserialize(LINGUE_ATTIVE));
    foreach (unserialize(LINGUE_ATTIVE) as $lingua) {
       ?>
        <a class="" href="<?=URL_AZIONI?>lang.php?l=<?=$lingua?>">
            <img src="/img/<?=$lingua?>.png" style="height: 24px;">
            <!--<br><?=$GLOBALS['LINGUE_NOMI'][$lingua]?>-->
        </a>&emsp;
       <?php
    }
    ?>
</div> 
