<?php
require_once(realpath($_SERVER['DOCUMENT_ROOT']).'/include/config.php');
require_once(DIR_CLS . 'class.app.php');
	
$oApp = new app(TRUE);
$oApp->sezione(SEZIONE_SUPERVISORI);
$oApp->disegna(TEMPLATE_STANDARD);

/*********************************************************************************************************/
function backend_supervisore_elenco(&$oApp) {
    $oApp->apriWidget(
        'elenco_supervisori', 
        $oApp->getEtichetta('TABELLA_ELENCO_SUPERVISORI') . bottone($oApp, 'BOTTONE_SUPERVISORE_CREA', strtolower('BOTTONE_SUPERVISORE_CREA'), FALSE, FALSE, FALSE), 
        FALSE, FALSE, FALSE, FALSE
    );


    $oElencoSupervisore = new elencosupervisore($oApp, TRUE, ' ORDER BY a.ordine');
    $oElencoSupervisore->setNomeElenco('elenco_supervisore_backend');
    $oElencoSupervisore->setPerOggetti('totale_supervisori', $oElencoSupervisore->getTotaleElenco());

    $aCampi = array();
    $aCampi[] = 'id_supervisore';
    $aCampi[] = 'ip';
    $aCampi[] = 'descrizione';
    $aCampi[] = 'tipo_dispositivo_img';
    $aCampi[] = 'tipo_visualizzazione';
    $aCampi[] = 'status';
    if ($oApp->is(UTENTE_TIPO_ID_SUPERADMIN)) $aCampi[] = 'ordine_select';
    if ($oApp->is(UTENTE_TIPO_ID_SUPERADMIN)) $aCampi[] = 'azioni';
    $oElencoSupervisore->setCampiInteresse($aCampi);
    $oElencoSupervisore->stampa('tabella', STYLE_DATATABLE_BASIC);
    $oApp->chiudiWidget();
}
?>