<?php
require_once(realpath($_SERVER['DOCUMENT_ROOT']).'/include/config.php');
require_once(DIR_CLS . 'class.app.php');
	
$oApp = new app(TRUE);
$oApp->esegui();

/*********************************************************************************************************/
function backend_utenti_utenti_azioni_elimina(&$oApp) {
	$oUtente = new utente($oApp, readGetParam('id_oggetto', TRUE));
	
	$id_tipo_utente_loggato = $oApp->getIdTipoUtenteLoggato();
	$id_tipo_utente = $oUtente->get("id_utente_tipo");
	
	if ($oUtente->get("is_eliminabile")) {
		if($oApp->getIdUtenteLoggato() != $oUtente->getId() && $id_tipo_utente <= $id_tipo_utente_loggato){
			$oApp->redirect(URL_BACKEND.$oUtente->get('class_url'), $oApp->getMsgErrore('OPERAZIONE_NON_PERMESSA'), MESSAGGIO_ERRORE);
		}
	} else {
        $oApp->redirect(URL_BACKEND.$oUtente->get('class_url'), $oApp->getMsgErrore('OPERAZIONE_NON_PERMESSA'), MESSAGGIO_ERRORE);
	}
	
	$ret = $oUtente->elimina();
    if ($ret === TRUE) {
    	if ($id_tipo_utente_loggato == UTENTE_TIPO_ID_UTENTE) {
			$oApp->redirect(URL_AZIONI.'logout.php', $oApp->getMsgSuccesso('ELIMINAZIONE_OK'), MESSAGGIO_SUCCESSO);
    	} else {
			$oApp->redirect(URL_BACKEND.$oUtente->get('class_url').(($oUtente->isCandidato())?'candidati.php':''), $oApp->getMsgSuccesso('ELIMINAZIONE_OK'), MESSAGGIO_SUCCESSO);
    	}
	} else {
		$oApp->redirect(URL_BACKEND.$oUtente->get('class_url').(($oUtente->isCandidato())?'candidati.php':''), $oApp->getMsgErrore('ELIMINAZIONE_ERRORE'), MESSAGGIO_ERRORE);
	}
}
?>