<?php
require_once(realpath($_SERVER['DOCUMENT_ROOT']).'/include/config.php');
require_once(DIR_CLS . 'class.app.php');
	
$oApp = new app(TRUE);
$oApp->esegui();

/*********************************************************************************************************/
function backend_utenti_utenti_azioni_modifica(&$oApp) {
	$oO = new utente($oApp, readPostParam('id_utente_post_encoded', TRUE));
	
	$redirect = $oO->get('class_url');
	$redirectErrore = $oO->get('class_url').'modifica.php';
	
	// se l'utente non e' modificabile rimando indietro
	if (!$oO->get("is_modificabile")) {
		$oApp->redirect(URL_BACKEND.$redirect, $oApp->getMsgErrore('OPERAZIONE_NON_PERMESSA'), MESSAGGIO_ERRORE);
		die();
	}
	
	// se l'utente che prova a modificare e' di tipo visaulizzazione o funzionario
	// testo se l'id che modificano e' il loro. 
	if($oApp->getIdTipoUtenteLoggato() == UTENTE_TIPO_ID_UTENTE){
		// cambio il redirect
		$redirect .= 'profilo.php';
		$redirectErrore = $redirect;
		
		if (readPostParam('id_utente_post_encoded', TRUE) != $oApp->getIdUtenteLoggato()) {
			// se no rimando indietro
			$oApp->redirect(URL_BACKEND.$redirect, $oApp->getMsgErrore('OPERAZIONE_NON_PERMESSA'), MESSAGGIO_ERRORE);
			die('aaa');
		}

		//faccio l'unset di alcuni campi che potrebbero essere forzati
		unset($_POST['id_utente_tipo']);
		unset($_POST['checkbox_elenco_permessi_utente_singolo']);
	}
	
	/*
	if ($id_tipo_utente_loggato == UTENTE_TIPO_ID_TITOLARE) {
		// se l'id che stà cambiando è il suo 
		if ($_POST['id_utente'] == $oApp->getIdUtenteLoggato()) {
			// cambio il redirect
			$redirect .= 'profilo.php';
			$redirectErrore = $redirect;
			//faccio il controllo di alcuni campi che potrebbero essere forzati
			$_POST['id_utente_tipo'] = UTENTE_TIPO_ID_TITOLARE;
		}
	}
	*/
	$ret = $oO->isFormValido($_POST, 'modifica');
	if ($ret === TRUE) {
		$oO->initByRecord($_POST);
		$ret = $oO->modifica();
		if ($ret === TRUE) {
			$oApp->redirect(URL_BACKEND.$redirect, $oApp->getMsgSuccesso('MODIFICA_OK'), MESSAGGIO_SUCCESSO);
		} else {
			$oApp->redirect(URL_BACKEND.$redirect, $oApp->getMsgErrore('MODIFICA_ERRORE'), MESSAGGIO_ERRORE);
		}
	} else {
		$oApp->redirect(URL_BACKEND.$redirectErrore, $ret, MESSAGGIO_ERRORE);
	}
}
?>