<?php 
	if (session_status() == PHP_SESSION_NONE) {session_start();}

	require_once "../yassintegration.php";
	checkLoginAndRedirect();

	//if (!isSet($_SESSION["logged"])) header("location: index.php"); 
?>

<?php
	$doc_root  = preg_replace("!${_SERVER['SCRIPT_NAME']}$!", '', $_SERVER['SCRIPT_FILENAME']);
	if(!file_exists($doc_root."/hotel/json/hotelinfo.json"))
	{
		$fileDst=fopen($doc_root."/hotel/json/hotelinfo.json","w");
		if ($fileDst!=null) fputs($fileDst,json_encode(array()));
		fclose($fileDst);
	}
	if (!file_exists($doc_root."/hotel/json/images/"))
	{
	    mkdir($doc_root."/hotel/json/images/", 0777);
	}
	if (!file_exists($doc_root."/hotel/json/images/hotelinfo/"))
	{
	    mkdir($doc_root."/hotel/json/images/hotelinfo/", 0777);

	    if (file_exists($doc_root."/hotel/images/hotelinfo/"))
	    {
	    	if ($dh = opendir($doc_root."/hotel/images/hotelinfo/"))
	    	{
		    	while ($file = readdir($dh))
		    	{
		            if (( $file != '.' ) && ( $file != '..' ))
		            {
			            if (!is_dir($doc_root."/hotel/images/hotelinfo/".$file)) 
			            {
			                copy($doc_root."/hotel/images/hotelinfo/".$file, $doc_root."/hotel/json/images/hotelinfo/".$file); 
			            }
			        } 
		        }
		    }
	    }
	}
?>

  <link rel="stylesheet" href="../js/fancybox-2.1.7/jquery.fancybox.css">
  <style type="text/css">
  .btn-primary { background-color: #333; }


	.h3, h3 {clear: left; display: inline-block; float: left; font-size: 17px; margin: 30px 0 10px; text-align: left; }
  	.h2, h2 {background: #333 none repeat scroll 0 0; border-radius: 22px 22px 0 0; color: #fff; left: 0; padding: 30px 0; position: absolute; top: -20px; width: 100%; }
  	.box-roomnumber {background: #fff none repeat scroll 0 0; border: 3px solid #fff; border-radius: 25px; box-sizing: border-box; left: 3%; margin: 0; padding: 100px 20px 20px; position: relative; top: 20px; width: 94%; }
  	.box-roomnumber-number {font-size: 20px; font-weight: bold; width: 90px; text-align: center; }
	.btn {font-size: 16px; font-weight: normal; line-height: 16px; padding: 6px 10px 4px; text-transform: uppercase; }
	.alertmsg {position: absolute; top: 0; left: 0; bottom: 0; right: 0; background: rgba(0, 0, 0, 0.90); color: #fff;  }
	.alertmsg span {display: inline-block; font-size: 20px; width: 200px; top: 50%; position: absolute ; left: 50%; margin: -20px 0 0 -100px; }

	.new-tr td {background: #d4ffbe none repeat scroll 0 0; display: none; }
	
	#editBox > h1 {font-size: 22px; margin: 10px 0 20px; }
	#tbl1 img {max-height: 80px; max-width: 150px; cursor: pointer; }

	.img-preview { text-align: center; margin: 30px auto; }
	.img-preview img {border: 1px solid #ccc; border-radius: 3px; margin: auto; padding: 6px; text-align: center; }


  </style>


  <div class="box-roomnumber">
  	<h2></h2>
  	<h3></h3>
  	<div id="tbl1"></div>
  	<button class="btn btn-primary btn-add"></button>
  </div>
  <div id="editBox" style="display: none;">
  	<h1>Inserisci/modifica</h1>
  	<form method="post" enctype="multipart/form-data" action="hotelinfo-save.php" id="formUploadImage">
  		<input type="hidden" name="action" value="edit">
  		<input type="hidden" name="id" value="">
  		<input type="hidden" name="forcereload" value="1">
		<div class="form-group text-left">
			<label for="titolo">Titolo</label>
			<input type="text" name="name" class="form-control" id="titolo" placeholder="Titolo">
		</div>
  		
  		<div class="form-group text-left">
  			<label for="description">Descrizione</label>
  			<textarea name="text" id="description" class="form-control" ></textarea>
  		</div>
  		<div class="form-group text-left">  		
   			<label for="filepath">File immagine</label>
    		<input type="file" name="fileToUpload" id="filepath">
    		<p class="help-block">ATTENZIONE: Utilizzare solo file .jpg con dimensione 300x168 px</p>
  			<div class="img-preview"></div>
  		</div>
	
  		
  		<div>

  			<input type="submit" name="Salva" class="btn btn-default" value="Salva">
  		</div>

  	</form>
	  <script>
	  	var editMode = false;
		$(function(){

			window.URL = window.URL || window.webkitURL;

			$("#formUploadImage").submit( function( e ) {
				var form = this;
				e.preventDefault(); 
				var fileInput = $(this).find("input[type=file]")[0],
					file = fileInput.files && fileInput.files[0];
				if( file ) {
					var img = new Image();
					img.src = window.URL.createObjectURL( file );

					img.onload = function() {
						var width = img.naturalWidth,
							height = img.naturalHeight;

						window.URL.revokeObjectURL( img.src );

						if( width == 300 && height == 168 ) {
							form.submit();
						}
						else {
							alert("ATTENZIONE: E' stato caricato un file con dimensione " + width + "x" + height + ". Utilizzare solo file .jpg con dimensione 300x168 px");
						}
					};
				}
				else {
					if (!editMode) 
					{
						alert("ATTENZIONE: caricare un file immagine valido");
					}
					else {
						form.submit();
					}
				}
			});
		})	  
	  
	  </script>
  </div>


<script type="text/javascript" src="../js/jquery.tabledit.min.js"></script>
<script type="text/javascript" src="../js/fancybox-2.1.7/jquery.fancybox.pack.js"></script>
<script type="text/javascript">
	var doRedirect=false;

	var benvenuto;
	var inserirenumero;
	var accedi;
	var stanza;
	var ipaddress;
	var currentlang="<?php echo $adminlang; ?>";

	function setLabel(lang)
	{
		if (lang=="it")
		{
			benvenuto="Configurazione Hotel Info";
			inserirenumero="Aggiungi, modifica ed elimina le informazioni hotel";
			accedi="salva";
			nome="Nome";
			aggiungi="Aggiungi";
		}
		else
		{
			benvenuto="Hotel Info configuration";
			inserirenumero="Insert, edit and delete hotel information";
			accedi="save";
			nome="Name";			
			aggiungi="Add";
		}

		$(".box-roomnumber h2").html(benvenuto);
		$(".box-roomnumber h3").html(inserirenumero);
		$(".box-roomnumber .btn-add").html(aggiungi).click(function(){
			$(this).hide(); 
			$(".new-tr td").show();
			$(".new-tr button.tabledit-edit-button").click();
			editMode = false;
		});
	}

	function escapeHtml(unsafe)
	{
		if(unsafe != null)
		{
			return unsafe
		         .replace(/&/g, "&amp;")
		         .replace(/</g, "&lt;")
		         .replace(/>/g, "&gt;")
		         .replace(/"/g, "&quot;")
		         .replace(/'/g, "&#039;");
		}
	    
 	}

	var xxx;
	$(document).ready(function() {
		

		setLabel(currentlang);
		var x = $('#tbl1');
		x.append("<table class=\"table table-striped table-bordered\"><thead><tr><td>#</td><td class=\"nome\">"+nome+"</td><td></td></tr></thead><tbody></tbody></table>");
		
		$.ajaxSetup({ cache: false });	
		$.getJSON( "../json/hotelinfo.json", function( data ) {
			var lastid = 0;
			$(data).each(function(index, el) {	
				var img="../json/"+el.imgpath
				if (img=="") img="../images/img-nd.jpg";
				x.find("tbody").append("<tr data-text=\""+escapeHtml(el.text)+"\" data-title=\""+escapeHtml(el.name)+"\"><td>"+el.id+"</td><td>"+escapeHtml(el.name)+"</td><td><img src=\""+img+"\"></td></tr>");
				lastid=el.id;
			});		
			
			$("#tbl1 img").click(function(){
			  $(this).closest("tr").find(".tabledit-edit-button").click();
			})

			x.find("tbody").append("<tr class=\"new-tr\"><td>"+(parseInt(lastid)+1)+"</td><td></td></tr>");
			var tt = $('#tbl1 table').Tabledit({
			    url: 'hotelinfo-save.php',
			    columns: {
			        identifier: [0, 'id'],
			        editable: [[1, 'name']]
			    },
			    onDraw: function(data, textStatus, jqXHR) {			    	
					$("button.tabledit-edit-button").unbind("click").click(function(){

						editMode = true;
					  
				   		id=$(this).closest("tr").attr("id");
				   		//name=$(this).closest("tr").find("input[name=name]").val();
				   		name=$(this).closest("tr").data("title");
						text=$(this).closest("tr").data("text");
						imgsrc=$(this).closest("tr").find("img").attr("src");

						$(this).closest("tr").find("input[name=name]").val(name)

						$.fancybox("#editBox",{
						  width: "70%", 
						  height: "80%",
						  autoSize:false,
						  beforeShow: function(){
						    var x=$(".fancybox-inner #editBox");
						    x.find("input[name=id]").val(id);
						    if(name!=undefined && name!="undefined") {
						    	x.find("input[name=name]").val(name);
						    }
						    else {
						    	x.find("input[name=name]").val("");
						    }
						    if(text!=undefined) {
						    	x.find("textarea[name=text]").val(text);
						    }
						    else {
						    	x.find("textarea[name=text]").val("");
						    }
						    if (imgsrc!=undefined) {
						    	x.find(".img-preview").html("<img src=\""+imgsrc+"\">");
						    }
						    else {
						    	x.find(".img-preview").html("");
						    }
						  },
						  afterClose: function(){
						  	console.log("closed");
						  	if ($(".new-tr:visible").length>0) 
							{
						  		$(".btn-add").show();
						  		$(".new-tr td").hide();
						  	}

						  	$(tt).find('td.tabledit-edit-mode').each(function() {
                    // Get input element.
                    var $input = $(this).find('.tabledit-input');
                    // Get span text.
                    var text = $(this).find('.tabledit-span').text();

                    // Set input/select value with span text.
                    if ($input.is('select')) {
                        $input.find('option').filter(function() {
                            return $.trim($(this).text()) === text;
                        }).attr('selected', true);
                    } else {
                        $input.val(text);
                    }

                    // Get table row.
		                var $tr = $(this).parent('tr');
		                // Disable identifier.
		                $(this).parent('tr').find('.tabledit-input.tabledit-identifier').prop('disabled', true);
		                // Hide and disable input element.
		                $(this).find('.tabledit-input').blur().hide().prop('disabled', true);
		                // Show span element.
		                $(this).find('.tabledit-span').show();
		                // Add "view" class and remove "edit" class in td element.
		                $(this).addClass('tabledit-view-mode').removeClass('tabledit-edit-mode');
		                // Update toolbar buttons.
		                if (true/*settings.editButton*/) {
		                    $tr.find('button.tabledit-save-button').hide();
		                    $tr.find('button.tabledit-edit-button').removeClass('active').blur();
		                }
                  });
						  }
						})
			  
					})
		    	},
			    onSuccess: function(data, textStatus, jqXHR) {
			        console.log('onSuccess(data, textStatus, jqXHR)');
			        console.log(data);
			        console.log(data.val);			        
			        if (data.val=="add" || data.val=="delete") window.location.reload();
			        //console.log(textStatus);
			        //console.log(jqXHR);

			    },
			    onFail: function(jqXHR, textStatus, errorThrown) {
			        console.log('onFail(jqXHR, textStatus, errorThrown)');
			        console.log(jqXHR);
			        console.log(textStatus);
			        console.log(errorThrown);
			        $('#myModal .modal-title').html("Error");
			        $('#myModal .modal-body').html(jqXHR.responseText);
			        $('#myModal').modal('show');
			    },
			    onAjax: function(action, serialize) {
			        console.log('onAjax(action, serialize)');
			        console.log(action);
			        console.log(serialize);
			    }
			});
			//$("#tbl1 tr:last").find("td").eq(0).css("color","#d4ffbe");
			$("#tbl1 tr:last").find("td").eq(1).find("input").val("").attr("placeholder",aggiungi+" "+nome);

		});
		

		

	});
</script>