<?php 
	include "decryptFunctions.php"; /*VER10*/
	
	if (session_status() == PHP_SESSION_NONE) {session_start();}

	require_once "../yassintegration.php";
	checkLoginAndRedirect();

	//if (!isSet($_SESSION["logged"])) header("location: index.php"); 
?>

  <style type="text/css">
  .btn-primary { background-color: #333; }


	.h3, h3 {clear: left; display: inline-block; float: left; font-size: 17px; margin: 30px 0 10px; text-align: left; }
  	.h2, h2 {background: #333 none repeat scroll 0 0; border-radius: 22px 22px 0 0; color: #fff; left: 0; padding: 30px 0; position: absolute; top: -20px; width: 100%; }
  	.box-roomnumber {background: #fff none repeat scroll 0 0; border: 3px solid #fff; border-radius: 25px; box-sizing: border-box; left: 3%; margin: 0; padding: 100px 20px 20px; position: relative; top: 20px; width: 94%; }
  	.box-roomnumber-number {font-size: 20px; font-weight: bold; width: 90px; text-align: center; }
	.btn {font-size: 16px; font-weight: normal; line-height: 16px; padding: 6px 10px 4px; text-transform: uppercase; }
	.alertmsg {position: absolute; top: 0; left: 0; bottom: 0; right: 0; background: rgba(0, 0, 0, 0.90); color: #fff;  }
	.alertmsg span {display: inline-block; font-size: 20px; width: 200px; top: 50%; position: absolute ; left: 50%; margin: -20px 0 0 -100px; }

	
	.new-tr td {background: #d4ffbe none repeat scroll 0 0; display: none; }
  </style>

	
  <div class="box-roomnumber">
  	<h2></h2>
  	<h3></h3>
  	<div id="tbl1"></div>
  	<button class="btn btn-primary btn-add"></button>

  </div>

<script type="text/javascript" src="../js/jquery.tabledit.min.js"></script>
<script type="text/javascript">
	var doRedirect=false;

	var benvenuto;
	var inserirenumero;
	var accedi;
	var stanza;
	var ipaddress;
	var password;
	var currentlang="<?php echo $adminlang; ?>";

	function setLabel(lang)
	{
		if (lang=="it")
		{
			benvenuto="Configurazione Stanze";
			inserirenumero="Inserire il numero di stanza e indirizzo ip";
			accedi="salva";
			stanza="Stanza";
			ipaddress="Indirizzo IP";
			password="Password";
			aggiungi="Aggiungi";
		}
		else
		{
			benvenuto="Rooms configuration";
			inserirenumero="Insert room number and ip address";
			accedi="save";
			stanza="Room";
			ipaddress="IP Address";
			password="Password";
			aggiungi="Add";
		}

		$(".box-roomnumber h2").html(benvenuto);
		$(".box-roomnumber h3").html(inserirenumero);
		$(".box-roomnumber .btn-add").html(aggiungi+" "+stanza).click(function(){$(this).hide(); $(".new-tr td").show();});
	}

	var xxx;
	$(document).ready(function() {
		setLabel(currentlang);
		var x = $('#tbl1');
		x.append("<table class=\"table table-striped table-bordered\"><thead><tr><td>#</td><td class=\"stanza\">"+stanza+"</td><td class=\"idpaddress\">"+ipaddress+"</td><td class=\"password\">"+password+"</td></tr></thead><tbody></tbody></table>");
		
		$.ajaxSetup({ cache: false });	
		$.getJSON( "../json/rooms.json", function( data ) {
			var maxid=0;
			$(data).each(function(index, el) {
				console.log(el);
				
				x.find("tbody").append("<tr><td>"+el.id+"</td><td roomNumberAttribute=\""+el.roomnumber+"\">"+el.roomnumber+"</td><td>"+el.ipaddress+"</td><td>"+el.password+"</td></tr>"); /*VER10*/
				if (maxid < parseInt(el.id)) maxid=el.id;
			});		
			x.find("tbody").append("<tr class=\"new-tr\"><td>"+(parseInt(maxid)+1)+"</td><td></td><td></td><td></td></tr>");
			$('#tbl1 table').Tabledit({
			    url: 'rooms-save.php',
			    columns: {
			        identifier: [0, 'id'],
			        editable: [[1, 'roomnumber'], [2, 'ipaddress'], [3, 'password']]
			    },			   
			    onSuccess: function(data, textStatus, jqXHR) {
			        console.log('onSuccess(data, textStatus, jqXHR)');
			        console.log(data);
			        console.log(data.val);			        
			        if (data.val=="add" || data.val=="delete") window.location.reload();
			        //console.log(textStatus);
			        //console.log(jqXHR);

			    },
			    onFail: function(jqXHR, textStatus, errorThrown) {
			        /*
			        console.log('onFail(jqXHR, textStatus, errorThrown)');
			        console.log(jqXHR);
			        console.log("RT: "+jqXHR.responseText);
			        console.log(textStatus);
			        console.log(errorThrown);
			        */
			        $('#myModal .modal-title').html("Error");
			        $('#myModal .modal-body').html(jqXHR.responseText);
			        $('#myModal').modal('show');

			    },
			    onAjax: function(action, serialize) {
			        console.log('onAjax(action, serialize)');
			        console.log(action);
			        console.log(serialize);
			    }
			});
			//$("#tbl1 tr:last").find("td").eq(0).css("color","#d4ffbe");
			$("#tbl1 tr:last").find("td").eq(1).find("input").val("").attr("placeholder",aggiungi+" "+stanza);
			$("#tbl1 tr:last").find("td").eq(2).find("input").val("").attr("placeholder",aggiungi+" "+ipaddress);
			$("#tbl1 tr:last").find("td").eq(3).find("input").val("").attr("placeholder",aggiungi+" "+password);
			$("#tbl1 .tabledit-edit-button").after('<button type="button" class="tabledit-custom-button btn btn-sm btn-default" style="float: none;"><span class="glyphicon glyphicon-share-alt"></span></button>');

			$("#tbl1 .tabledit-custom-button").click(function(){
				console.log("clicked");
				id=$(this).closest("tr").attr("id");
				var roomNumber=$(this).closest("tr")[0].firstChild.nextSibling.innerText; /*VER10*/
				ip=$(this).closest("tr").find("input[name=ipaddress]").val();
				var defPassword="password";
				/*VER10*/
				<?php
					$file=fopen("../json/settings.json","rb");
					if($file!=NULL)
					{
						$jsonContent=fgets($file);
						fclose($file);
						$obj=json_decode($jsonContent,true);
						$password=cypher_decypher("cifra",$obj[3]["value"]);
						echo "defPassword=\"".$password."\";\n";
					}					
				?>
				$.ajax( "http://"+ip+"/_TS01/clearSessions.php?password="+defPassword);
				$.ajax( "replaceRoomPassword.php?room="+roomNumber+"&password="+defPassword); /*VER10*/
				setTimeout("location.reload()",1000);
				/*******/
			});
		});
		

		

	});
	var aaa;
</script>