<?
function cors() {

    // Allow from any origin
    if (isset($_SERVER['HTTP_ORIGIN'])) {
        // Decide if the origin in $_SERVER['HTTP_ORIGIN'] is one
        // you want to allow, and if so:
        header("Access-Control-Allow-Origin: {$_SERVER['HTTP_ORIGIN']}");
        header('Access-Control-Allow-Credentials: true');
        header('Access-Control-Max-Age: 86400');    // cache for 1 day
    }

    // Access-Control headers are received during OPTIONS requests
    if ($_SERVER['REQUEST_METHOD'] == 'OPTIONS') {

        if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_METHOD']))
            // may also be using PUT, PATCH, HEAD etc
            header("Access-Control-Allow-Methods: GET, POST, OPTIONS");         

        if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']))
            header("Access-Control-Allow-Headers: {$_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']}");

        exit(0);
    }

    //echo "You have CORS!";
}

cors();

$class="OH";
if (isset($_GET["vert"])) $class="OV";
?>
<?php
	$doc_root  = preg_replace("!${_SERVER['SCRIPT_NAME']}$!", '', $_SERVER['SCRIPT_FILENAME']);
	if(!file_exists($doc_root."/hotel/json/hotelinfo.json"))
	{
		$fileDst=fopen($doc_root."/hotel/json/hotelinfo.json","w");
		if ($fileDst!=null) fputs($fileDst,json_encode(array()));
		fclose($fileDst);
	}
	if (!file_exists($doc_root."/hotel/json/images/"))
	{
	    mkdir($doc_root."/hotel/json/images/", 0777);
	}
	if (!file_exists($doc_root."/hotel/json/images/hotelinfo/"))
	{
	    mkdir($doc_root."/hotel/json/images/hotelinfo/", 0777);

	    if (file_exists($doc_root."/hotel/images/hotelinfo/"))
	    {
	    	if ($dh = opendir($doc_root."/hotel/images/hotelinfo/"))
	    	{
		    	while ($file = readdir($dh))
		    	{
		            if (( $file != '.' ) && ( $file != '..' ))
		            {
			            if (!is_dir($doc_root."/hotel/images/hotelinfo/".$file)) 
			            {
			                copy($doc_root."/hotel/images/hotelinfo/".$file, $doc_root."/hotel/json/images/hotelinfo/".$file); 
			            }
			        } 
		        }
		    }
	    }
	}
?>
<!DOCTYPE html>
<html>
<head>
  <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">     
  <meta name="apple-mobile-web-app-capable" content="yes" />
  <meta name="apple-mobile-web-app-status-bar-style" content="black" />
  <link rel="apple-touch-icon" href="public/images/logo-ave.png" />
  <link rel="stylesheet" href="js/masterslider/style/masterslider.css">
  <link rel="stylesheet" href="js/masterslider/skins/default/style.css">
  <link rel="stylesheet" href="js/fancybox-2.1.7/jquery.fancybox.css">

  <title>Domina Plus &ndash; Gestione TS01</title>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
  <style type="text/css">
  	body {margin: 5px 0 0; font-family: sans-serif;}	
  	.ms-layer.ms-caption {color: #fff; text-shadow: 0 0 3px #000; text-align: center; }
  	.ms-layer.ms-caption2 { display: none; background-color: rgba(255, 255, 255, 0.69); color: #000; line-height: 1.4 !important; padding: 7px !important; text-align: justify; text-shadow: none; font-size: 12px !important; }
  	/*.ms-layer.ms-caption::after {background: #026d80 none repeat scroll 0 0; border-radius: 60px; content: "i"; display: inline-block; padding: 1px; position: absolute; width: 20px; }*/

  	.OH .ms-skin-default .ms-nav-next { right: -40px;}
  	.OH .ms-skin-default .ms-nav-prev { left: -40px;}
  	.OH .external-caption { display: none; }
  	.external-caption { display: none; color: #fff; font-size: 13px; padding: 10px; }

  	.OV .ms-captiontit { display: none; }
  	.int-loading {display:none;text-align: center; vertical-align: middle; position: absolute; top: 0; background: #000; left: 0; right: 0; bottom: 0; color: #eee; }

  	.OH .external-caption h3 {display: none; }
  	.OH	.external-caption {color: #fff; font-size: 11px; line-height: 1.2; padding: 0 10px; }
  </style>
</head>
<body class="<? echo $class; ?>">
<div class="int-loading"></div>
<div class="master-slider ms-skin-default" id="masterslider"></div> 
<div class="external-caption"></div> 

</body>
</html>
<script type="text/javascript" src="js/jquery-3.1.1.min.js"></script>
<script type="text/javascript" src="js/masterslider/masterslider.min.js"></script>
<script type="text/javascript" src="js/fancybox-2.1.7/jquery.fancybox.pack.js"></script>
<script type="text/javascript">

	var benvenuto;
	var inserirenumero;
	var accedi;
	var stanza;
	var ipaddress;

	var descriptionArray = [];

	function setLabel(lang)
	{
		if (lang=="it")
		{
			benvenuto="Configurazione Hotel Info";
			inserirenumero="Aggiungi, modifica ed elimina le informazioni hotel";
			accedi="salva";
			nome="Nome";
			aggiungi="Aggiungi";
		}
		else
		{
			benvenuto="Hotel Info configuration";
			inserirenumero="Insert, edit and delete hotel information";
			accedi="save";
			nome="Name";			
			aggiungi="Add";
		}

		$(".box-roomnumber h2").html(benvenuto);
		$(".box-roomnumber h3").html(inserirenumero);
		$(".box-roomnumber .btn-add").html(aggiungi).click(function(){
			$(this).hide(); 
			$(".new-tr td").show();
			$(".new-tr button.tabledit-edit-button").click();
		});
	}

	$(document).ready(function() {

		setLabel("it");
		var x = $('#masterslider');

		$.ajaxSetup({ cache: false });	
		$.getJSON( "json/hotelinfo.json", function( data ) {
			var cnt = 0;
			$(data).each(function(index, el) {	
				var img=el.imgpath
				if (img=="") img="images/img-nd.jpg";
				x.append("<div class=\"ms-slide\" data-effect=\"fade\" data-duration=\"500\" data-delay=\"0\" ><img src=\"js/masterslider/style/blank.gif\" data-src=\"json/"+img+"\" alt=\""+el.name+"\" /><div class=\"ms-layer ms-caption ms-captiontit\" style=\"top:10px; left:10px;\">"+el.name+"</div><div class=\"ms-layer ms-caption ms-caption2\" style=\"bottom:0px; left:0px;\">"+el.text+"</div></div>");
				descriptionArray[cnt++] = { caption: el.name, text: el.text }
			});		

			var slider = new MasterSlider();
    		slider.setup('masterslider' , {
	            width:299,    // slider standard width
	            height:170,   // slider standard height	    
	            heightLimit:170,
	            autoHeight:true,
	            view:"basic",
	            speed: 75
	        });
	    	slider.api.addEventListener(MSSliderEvent.CHANGE_END , function(){
			   // dispatches when the slider's current slide change ends.
			   console.log("stop: "+slider.api.index());

			   $(".external-caption").html("<h3>"+descriptionArray[slider.api.index()].caption+"</h3><p>"+descriptionArray[slider.api.index()].text+"</p>");
			   $(".external-caption").fadeIn(500);
			});

			slider.api.addEventListener(MSSliderEvent.CHANGE_START , function(){
			   console.log("start: "+slider.api.index());
			   $(".external-caption").fadeOut("slow");
			});
	    	// adds Arrows navigation control to the slider.
		    slider.control('arrows',{autohide:false});			
		});
		

		

	});
</script>