<!DOCTYPE html>
<html>
<head>
  <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">     
  <meta name="apple-mobile-web-app-capable" content="yes" />
  <meta name="apple-mobile-web-app-status-bar-style" content="black" />
  <link rel="apple-touch-icon" href="public/images/logo-ave.png" />
  <title>Domina Plus &ndash; Gestione TS01</title>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
  <style type="text/css">
  	body {background: url("images/sf_body.jpg"); font-family: arial; margin: 0; text-align: center;}
  	h1 { margin: 0 }
  	h1 img { width: 100%; }
  	.box-roomnumber {border: 3px solid #E5001C; background: #fff none repeat scroll 0 0; border-radius: 25px; left: 50%; margin: -142px 0 0 -153px; padding: 20px; position: absolute; top: 50%; width: 260px; }
  	.box-roomnumber-number {font-size: 20px; font-weight: bold; width: 90px; text-align: center; }
	.btn {font-size: 16px; font-weight: normal; line-height: 16px; padding: 6px 10px 4px; text-transform: uppercase; background-color: #333; color: #fff; }
	.alertmsg {position: absolute; top: 0; left: 0; bottom: 0; right: 0; background: rgba(0, 0, 0, 0.90); color: #fff;  }
	.alertmsg span {display: inline-block; font-size: 20px; width: 200px; top: 50%; position: absolute ; left: 50%; margin: -20px 0 0 -100px; }

	.box-languages {bottom: -36px; left: 0; position: absolute; text-align: center; width: 100%; }
	.box-languages img {height: 20px; margin: 0 3px; width: 30px; cursor: pointer; }
	
	.version {bottom: -30px; color: #b1b1b1; font-size: 11px; right: 0; position: absolute; }
  </style>
</head>
<body>
  <div class="box-roomnumber">
  	<h1><img src="images/logo-ave-color.png"></h1>
  	<h2></h2>
  	<h3></h3>
  	<input type="text" class="box-roomnumber-number" name="">
  	<button class="btn btn-accedi"></button>
  	<div class="box-languages">
	  	<img class="btn-it" src="images/it.gif" onclick="setLabel('it');">
		<img class="btn-en" src="images/en.png" onclick="setLabel('en');">
	</div>
	<div class="version">Ver. <?php require("ver.txt"); ?></div>
  </div>
</body>
</html>
<script type="text/javascript" src="js/jquery-3.1.1.min.js"></script>
<script type="text/javascript">
	var doRedirect=false;

	var benvenuto;
	var inserirenumero;
	var accedi;
	var stanzanontrovata;

	function setLabel(lang)
	{
		if (lang=="it")
		{
			benvenuto="Benvenuto";
			inserirenumero="Inserire il numero di stanza";
			accedi="accedi";
			stanzanontrovata="Stanza non trovata";
		}
		else
		{
			benvenuto="Welcome";
			inserirenumero="Insert room number";
			accedi="enter";
			stanzanontrovata="Room not available";
		}

		$(".box-roomnumber h2").html(benvenuto);
		$(".box-roomnumber h3").html(inserirenumero);
		$(".box-roomnumber .btn-accedi").html(accedi);
	}

	$(document).ready(function() {
		$("html").click(function(event) {
			event.stopPropagation();
			event.preventDefault();
		});
		setLabel("it");
		$.ajaxSetup({ cache: false });
		
		$(".box-roomnumber .btn-accedi").click(function(event) {
			
			$.getJSON( "json/rooms.json", function( data ) {	
				//console.log(data);
				var link="";
				$(data).each(function(index, el) {
					if (el.roomnumber==$("input.box-roomnumber-number").val())
						link ="http://"+el.ipaddress+"/_TS01/"
				});			
				if (link!="")
					window.location=link;
				else
					{
						$("body").append("<div class=\"alertmsg\"><span>"+stanzanontrovata+"</span></div>")
						$(".alertmsg").delay(2000).slideUp();
					}
			});
		});

		$("input.box-roomnumber-number").keypress(function(e) {
		    if(e.which == 13) {
				$(".box-roomnumber .btn-accedi").click();
		    }
		});


	});
</script>