<?php
class elencodispositivo extends elenco {
	
public $type = false;
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getSqlToLoad($completo = TRUE, $elencoId = FALSE, $id = FALSE, $whereClauses = FALSE) {

	$sql = 'SELECT a.*,
	               b.descrizione AS status,
	               c.'.$_SESSION['LINGUA_NAVIGAZIONE'].' AS tipo_dispositivo,
	               c.codice_tipo_dispositivo AS codice_tipo_dispositivo,
	               c.icona,
	               c.mostra_in_dashboard
				FROM dispositivo AS a
				INNER JOIN status AS b ON a.id_status = b.id_status
				INNER JOIN dispositivo_tipo_dispositivo AS c ON a.id_tipo_dispositivo = c.id_tipo_dispositivo
				WHERE b.id_status != '.STATUS_ELIMINATO;

	if($this->type) {
		$sql .= ' AND c.usabile_come_' . $this->type . ' = 1';
	}

	if ($elencoId !== FALSE) $sql .= ((stripos($sql, 'WHERE') !== FALSE)?' AND ':' WHERE ') . 'id_dispositivo IN (' . implode(',', $elencoId).')';
	if ($id !== FALSE) $sql .= ((stripos($sql, 'WHERE') !== FALSE)?' AND ':' WHERE ') . 'id_dispositivo = ' . num2Str($id);
	if ($whereClauses !== FALSE) $sql .= ((stripos($sql, 'WHERE') !== FALSE)?' AND ':' WHERE ') . $whereClauses;

	return $sql;   
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function caricaPerSupervisore($oSupervisore) {
    instance_of($oSupervisore, 'supervisore');
    parent::carica(' a.id_supervisore = '.num2Str($oSupervisore->getId()), TRUE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function caricaPerMappa($oMappa) {
    instance_of($oMappa, 'mappa');
    $oSupervisore = new supervisore($this->oApp, $oMappa->get('id_supervisore'));
    parent::carica(' a.id_supervisore='.num2Str($oSupervisore->getId()).' AND a.mappe LIKE '.stripcslashesandquote('%;'.$oMappa->get('codice_mappa').';%'), TRUE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
}
?>