<?php
class elencorelay extends elenco {
	
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getSqlToLoad($completo = TRUE, $elencoId = FALSE, $id = FALSE, $whereClauses = FALSE) {
	$sql = 'SELECT 
				a.*, 
				b.descrizione AS status,
				sup_orig.id_tipo_dispositivo as tipo_supervisore_origine,
				sup_dest.id_tipo_dispositivo as tipo_supervisore_destinazione
			FROM relay AS a

			LEFT JOIN supervisore AS sup_orig on sup_orig.ip = a.ip_supervisore_origine
			LEFT JOIN supervisore AS sup_dest on sup_dest.ip = a.ip_supervisore_destinazione
			
			INNER JOIN status AS b ON a.id_status = b.id_status
			WHERE b.id_status != '.STATUS_ELIMINATO;
	
	if ($elencoId !== FALSE) $sql .= ((stripos($sql, 'WHERE') !== FALSE)?' AND ':' WHERE ') . 'id_relay IN (' . implode(',', $elencoId).')';
	if ($id !== FALSE) $sql .= ((stripos($sql, 'WHERE') !== FALSE)?' AND ':' WHERE ') . 'id_relay = ' . num2Str($id);
	if ($whereClauses !== FALSE) $sql .= ((stripos($sql, 'WHERE') !== FALSE)?' AND ':' WHERE ') . $whereClauses;
	
	return $sql;   
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function caricaSoloAttivi() {
    parent::carica(' b.id_status = '.STATUS_ATTIVO, TRUE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function caricaSoloSospesi() {
    parent::carica(' b.id_status = '.STATUS_SOSPESO, TRUE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function caricaAbbinamentoReparti() {
    parent::carica(' b.id_status = '.STATUS_ATTIVO.' AND a.id_dispositivo_origine < 1000000 AND RIGHT(a.id_dispositivo_origine, 1) = 3', TRUE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
}
?>