<?php
class stampaoggetto {
  	private $tipo;
	private $oggetto;
	
	private $style;
  
	private $nomeElencoPadre;
  
/*********************************************************************************************************/
/*********************************************************************************************************/
public function stampaoggetto($tipo, $oggetto) {
    $this->tipo   = $tipo;
	$this->oggetto = $oggetto;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function setNomeElencoPadre($nomeElenco) {
    $this->nomeElencoPadre = $nomeElenco;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function stampa($campiInteresse, $array_confronto, $primoOggetto, $numeroOggetto) {
	$this->apriElemento($primoOggetto, $numeroOggetto);
    
	$primoElemento = TRUE;
	foreach($campiInteresse as $campo) {
	  	$this->stampaElemento($campo, $array_confronto, $primoElemento, $numeroOggetto);
	  	$primoElemento = FALSE;
	}
	
    $this->chiudiElemento($primoOggetto, $numeroOggetto);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
private function apriElemento($primoOggetto, $numeroOggetto) {
    switch ($this->tipo) {
	  	case 'JSON':
				if (!$primoOggetto) {
					echo ','; 
				}				
				echo '{';
			break;
	  	case 'elenco':
	  	case 'menu':
	  		echo '<li>';
		    break;
	  	case 'tabella':
		    //echo '<tr oggetto="'.get_class($this->oggetto).'" id="'.$this->oggetto->getId().'" class="status-'.str_replace(' ','-',$this->oggetto->get('status')).(($this->oggetto instanceof logallarme)?(($this->oggetto->getIdStatus() == STATUS_ALLARME_ATTIVO)?' allarme-'.strtolower($this->oggetto->get('tipo_allarme')):' text-success'):'').'">';
		    echo '<tr oggetto="'.get_class($this->oggetto).'" id="'.$this->oggetto->getId().'" class="status-'.str_replace(' ','-',$this->oggetto->get('status')).(($this->oggetto instanceof logallarme)?' allarme-'.strtolower($this->oggetto->get('tipo_allarme_css')):'').'">';
		    break;
		case 'checkbox_no_fieldset_inline':
			if (!$primoOggetto && $numeroOggetto % 6 == 0) echo '</div><div class="row-fluid">';	
			break;
        case 'box_abbinamento_reparti':
            echo '<div class="row mb-2 box-abbinamento-reparti">';
            echo '<div class="col-xl-12">';
            echo '<div class="row">';
            break;
    }
}
/*********************************************************************************************************/
/*********************************************************************************************************/
private function chiudiElemento($primoOggetto, $numeroOggetto) {
    switch ($this->tipo) {
	  	case 'JSON':
				echo '}';
			break;
	  	case 'elenco':
	  	case 'menu':
	  		echo '</li>';
		    break;
	  	case 'tabella':
		    echo '</tr>';
		    break;
		case 'autocomplete':
		    echo "\n";
		    break;
        case 'box_abbinamento_reparti':
            echo '</div>';
            echo '</div>';
            echo '</div>';
            break;
    }
}
/*********************************************************************************************************/
/*********************************************************************************************************/
private function stampaElemento($campo, $array_confronto, $primoElemento, $numeroOggetto) {
	$metodo = 'get'.$campo;
	
	if (method_exists($this->oggetto, $metodo)) {
		$valore = $this->oggetto->$metodo($campo);
		if ($valore=='') {
			$valore = '---';
		}
	} else {
		$metodo = 'get';
		if (method_exists($this->oggetto, $metodo)) {
			$valore = $this->oggetto->$metodo($campo);

			if ($valore=='') {
				$valore = '---';
			}
		} else {
		  	$valore = '***non esiste il metodo***<br />$'.get_class($this->oggetto).'->$metodo()<br />****************';
		}
	}
	
	if (strpos($metodo, 'Data') !== FALSE) {
	  	$valore = $this->formattaDate($valore);
	}

    switch ($this->tipo) {
		case 'JSON':
				if (!$primoElemento) {
					echo ','; 
				}
				echo '"'.$campo.'":';
				if ($valore == 'false' || $valore == 'true' || (is_numeric($valore) && $campo != 'title')) {
					echo $valore;
				} else {
					echo '"'.$valore.'"';
				}
			break;
	  	case 'elenco':
		    echo '<span class="'.$campo.'">' . $valore . '</span>';
		    break;
	  	case 'menu':
		    echo '<a href="'.$id = $this->oggetto->getId().'">' . $valore . '</a>';
		    break;
		case 'tabella':
			echo '<td class="'.$campo.((in_array($campo, unserialize(DATATABLE_CAMPI_CENTRALI)))?' text-center':'').'" rel="'.$campo.'">' . $valore . '</td>';
		    break;
		case 'checkbox':
		case 'checkbox_no_fieldset':
			$id = $this->oggetto->getId();
			if (is_array($array_confronto)) {
			  	foreach($array_confronto as $e) {
			    	if ($e->getId() == $id) {
			      		$check = 'checked="checked"';
			      		break;
			    	}
			  	}
			}
			
			 echo '<div class="control-group">';
				 echo '<label class="control-label" for="checkbox_'.$this->nomeElencoPadre.'_'.$id.'">'.$valore.'</label>';
				 echo '<div class="controls">';
					echo '<input class="span12" type="checkbox" id="checkbox_'.$this->nomeElencoPadre.'_'.$id.'" value="'.$id.'" name="checkbox_'.$this->nomeElencoPadre.'[]"'.((isset($check))?$check:'').' />';
				 echo '</div>';
			 echo '</div>';
			
		    //echo '<label for="checkbox_'.$this->nomeElencoPadre.'_'.$id.'">';
		    //echo '<input type="checkbox" id="checkbox_'.$this->nomeElencoPadre.'_'.$id.'" value="'.$id.'" name="checkbox_'.$this->nomeElencoPadre.'[]"'.((isset($check))?$check:'').' />'.$valore;
		    //echo '</label>';
		    
		    break;

		case 'checkbox_text_no_fieldset':
			$id = $this->oggetto->getId();
			$codice_agenzia = '';
			if (is_array($array_confronto)) {
			  	foreach($array_confronto as $e) {
			    	if ($e->getId() == $id) {
			      		$check = 'checked="checked"';
						$codice_agenzia = $e->get('codice_agenzia');
			      		break;
			    	}
			  	}
			}
			 echo '<div class="control-group">';
				 echo '<label class="control-label" for="checkbox_'.$this->nomeElencoPadre.'_'.$id.'">'.$valore.'</label>';
				 echo '<div class="controls">';
					echo '<input class="span12" type="checkbox" id="checkbox_'.$this->nomeElencoPadre.'_'.$id.'" value="'.$id.'" name="checkbox_'.$this->nomeElencoPadre.'[]"'.((isset($check))?$check:'').' />';
					echo '<input style="margin-left: 25px;" type="text" id="text_'.$this->nomeElencoPadre.'_'.$id.'" value="'.$codice_agenzia.'" name="text_'.$this->nomeElencoPadre.'_'.$id.'">';
				 echo '</div>';
			 echo '</div>';
			
		    break;
			
		case 'checkbox_no_fieldset_2_colonne':			
			$id = $this->oggetto->getId();
			if (is_array($array_confronto)) {
			  	foreach($array_confronto as $e) {
			    	if ($e->getId() == $id) {
			      		$check = 'checked="checked"';
			      		break;
			    	}
			  	}
			}
			
			 echo '<div class="control-group span6 no-margin" style="margin: 0px">';
				 echo '<label class="control-label" for="checkbox_'.$this->nomeElencoPadre.'_'.$id.'">'.$valore.'</label>';
				 echo '<div class="controls pull-right">';
					echo '<input class="span12" type="checkbox" id="checkbox_'.$this->nomeElencoPadre.'_'.$id.'" value="'.$id.'" name="checkbox_'.$this->nomeElencoPadre.'[]"'.((isset($check))?$check:'').' />';
				 echo '</div>';
			 echo '</div>';
			
		    break;
		
		case 'checkbox_no_fieldset_inline':
			$id = $this->oggetto->getId();
			if (is_array($array_confronto)) {
			  	foreach($array_confronto as $e) {
			    	if ($e->getId() == $id) {
			      		$check = 'checked="checked"';
			      		break;
			    	}
			  	}
			}
			echo 	'<label class="checkbox span2 inline">
						<input type="checkbox" name="checkbox_'.$this->nomeElencoPadre.'[]" id="checkbox_'.$this->nomeElencoPadre.'_'.$id.'" value="'.$id.'"'.((isset($check))?$check:'').' id_oggetto_get_encoded="'.writeGetParam($id).'" id_oggetto_post_encoded="'.writeGetParam($id).'">
						'.$valore.' 
					</label>';
				
			break;
		
		case 'radio':
		    $id = $this->oggetto->getId();
			if (is_array($array_confronto)) {
			  	foreach($array_confronto as $e) {
			    	if ($e->getId() == $id) {
			      		$check = 'checked="checked"';
			      		break;
			    	}
			  	}
			}
			
		    echo '<label for="radio_'.$this->nomeElencoPadre.'_'.$id.'">';
		    echo '<input type="radio" id="radio_'.$this->nomeElencoPadre.'_'.$id.'" value="'.$id.'" name="radio_'.$this->nomeElencoPadre.'"'.((isset($check))?$check:'').' />'.$valore;
		    echo '</label>';
		    break;
		    
		case 'select':
		    echo '<option class="'.$campo.'" value="'.$valore.'">' . $valore . '</option>';
		    break;

		case 'autocomplete':
			if (!$primoElemento) {
				echo '|'; 
			}
		    echo $valore;
		    break;
		    
		case 'select_id':
		case 'select_id_no_fieldset':
			echo '<option class="'.$campo.'" value="'.$this->oggetto->getId().'">' . $valore . '</option>';
		    break;
			
			
			
		case 'galleria_immagini_backend':	
			if ($numeroOggetto != 0 && $numeroOggetto % 4 == 0) {
				echo '</div>';
				echo '<div class="row-fluid">';
			} 
			echo '<div class="span3 box-galleria">';
				echo $this->oggetto->get('immagine_backend');
				/*
				echo '<div class="row-fluid" style="margin-top: 10px;">';
					echo '<div class="span8">';
						echo $this->oggetto->get('edit_titolo');
					echo '</div>';
					if ($this->oggetto->get('oggetto') !== 'offerta' || $this->oggetto->get('oOggetto')->isModificabileDaUtenteLoggato()) {
						echo '<div class="span4">';
							echo $this->oggetto->get('ordine_select');
						echo '</div>';
					}
				echo '</div>';
				*/
				
				if ($this->oggetto->get('oggetto') !== 'offerta' || $this->oggetto->get('oOggetto')->isModificabileDaUtenteLoggato()) {
					echo '<div class="row-fluid" style="margin-top: 10px;">';
						/*
						echo '<div class="span6">';					
							echo $this->oggetto->get('privata_pubblica');
						echo '</div>';
						*/
						/*
						echo '<div class="span3" id="box-immagine_principale">';				
							echo $this->oggetto->get('principale',FALSE);
						echo '</div>';
						*/
						echo '<div class="span4">';
							echo $this->oggetto->get('ordine_select');
						echo '</div>';
						echo '<div class="span3 pull-right">';				
							echo $this->oggetto->get('elimina',FALSE);
						echo '</div>';
					echo '</div>';
				}
			echo '</div>'; 
			break;

		case 'box_abbinamento_reparti':
			$background = 'primary';
			$text = 'white';
			
			if (stripos($campo, 'elimina') !== FALSE) $background = 'danger';
			
			if (stripos($campo, 'destinazione') !== FALSE) $background = 'secondary';

			if (stripos($campo, 'time') !== FALSE) {
				$background = 'light';
				$text = 'black';
			}
			
			

            echo '<div class="col-xl-'.(($campo == 'elimina_no_etichetta' || strcmp($campo, 'time_from') == 0 || strcmp($campo, 'time_to') == 0)?'1':'3').' px-1">';
				echo '<div class=" text-'. $text . ' bg-'.$background.' text-center abbinamento-reparti-box">';
					echo '<div class=""><div class="row">';

						if($background != 'danger' && $background != 'light') {
							if($background == 'primary') {
								$idTipoDis = $this->oggetto->getOSupervisoreOrigine()->get("id_tipo_dispositivo");
							} else {
								$idTipoDis = $this->oggetto->getOSupervisoreDestinazione()->get("id_tipo_dispositivo");
							}
							echo '<div clas="col">
								' . ($background == 'secondary' ? '&emsp;<i class="fa fa-arrow-right"></i>' : '') . '&emsp;
								<img height="50" style="margin-top: -9px; margin-bottom: -9px;" src="'.URL_IMG.(($idTipoDis == TIPO_DISPOSITIVO_ID_WS)?'ws.png':'ts01.png').'">
								&emsp;' . ($background == 'primary' ? '<i class="fa fa-arrow-right"></i>&emsp;' : '') . '
								</div>';
						}
						if(strcmp($campo, 'time_from') == 0 || strcmp($campo, 'time_to') == 0)
						{
							echo '<div class="col"><img height="20" style="margin-right: 5px;" src="'.URL_IMG.((strcmp($campo, 'time_from') == 0) ? 'time_from.png' : 'time_to.png').'" />';
							$seconds = intval($valore);
							if($seconds < 0)
							{
								echo '--:--</div>';
							}
							else
							{
								$hh = floor($seconds / 3600) . '';
								$mm = floor(($seconds % 3600) / 60) . '';
								echo str_pad($hh, 2, '0', STR_PAD_LEFT) . ':' . str_pad($mm, 2, '0', STR_PAD_LEFT) . '</div>';
							}
						}
						else if(strcmp($campo, 'time_mode') == 0 && strlen($valore) > 20)
						{
							$str = '<div class="row w-100 mx-0 align-items-center" style="justify-content: space-evenly !important;">';
							$arr_day = $this->oggetto->getArrayDow();
							$arr_month = $this->oggetto->getArrayMonth();
							if ($valore[4] == '*') {
								$str .= '<div class="col-6 mx-0 px-0">';
								$str .= '<div class="col-2 ml-3 mr-2 px-0 imgDoW"></div>';
								$str .= '<div class="col-10 mx-0 px-0" style="text-align: left; text-transform: uppercase;">'.($_SESSION['LINGUA_NAVIGAZIONE'] == 'it_IT' ? 'Tutti' : 'All').'</div>';
								$str .= '</div>';
							}
							else {
								$str .= '<div class="col-6 mx-0 px-0">';
								$str .= '<div class="col-2 ml-3 mr-2 px-0 imgDoW"></div>';
								$str .= '<div class="col-10 mx-0 px-0" style="text-align: left; text-transform: uppercase;">'.substr($arr_day[intval($valore[4])]['descrizione'], 0, 3).'</div>';
								$str .= '</div>';
							}
							if ($valore[11] == '*')
							{
								$str .= '<div class="col-6 mx-0 px-0">';
								$str .= '<div class="col-2 ml-3 mr-2 px-0 imgMonth"></div>';
								$str .= '<div class="col-10 px-0" style="text-align: left; text-transform: uppercase;">'.($_SESSION['LINGUA_NAVIGAZIONE'] == 'it_IT' ? 'Tutti' : 'All').'</div>';
								$str .= '</div>';
							}
							else {
								$str .= '<div class="col-6 mx-0 px-0">';
								$str .= '<div class="col-2 ml-3 mr-2 px-0 imgDoW"></div>';
								$str .= '<div class="col-10 px-0" style="text-align: left; text-transform: uppercase;">'.substr($arr_month[intval($valore[11].$valore[12])]['descrizione'], 0, 3).'</div>';
								$str .= '</div>';
							}
							$str .= '</div>';
							echo $str;
						}
						else
						{
							echo '<div class="col">' . $valore . '</div>';
						}
						
					echo '</div></div>';
				echo '</div>';
            echo '</div>';


            break;

    }
}
/*********************************************************************************************************/
/*********************************************************************************************************/
private function formattaDate($data) {
    $retVal = $data;
	if ($data == '0000-00-00') {
	  	$retVal = 'n.d.';
	} elseif (ereg("^[0-9]{4}-[0-9]{2}-[0-9]{2}$", $data) !== FALSE) {
	  	$a = explode('-', $data);
	  	$retVal = $a[2].'/'.$a[1].'/'.$a[0];
	} elseif (ereg("^[0-9]{4}\.[0-9]{2}\.[0-9]{2}\.[0-9]{2}\.[0-9]{2}\.[0-9]{2}$$", $data) !== FALSE) {
	  	$a = explode('.', $data);
	  	$retVal = $a[3].':'.$a[4].':'.$a[5].' '.$a[2].'/'.$a[1].'/'.$a[0];
	} 
    return $retVal;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function setStyle($style) {
	$this->style = $style;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
}
?>