<?php
class tipodispositivo extends oggetto {

    protected $id_tipo_dispositivo;
    protected $ordine;
    protected $tipo_dispositivo;
    protected $codice_tipo_dispositivo;
    protected $codice_tipo_dispositivo_esadecimale;
    protected $icona;
    protected $mostra_in_dashboard;
    protected $usabile_come_origine;
    protected $usabile_come_destinazione;

    protected $class_action_url = '---';
	protected $class_url = '---';
	protected $nome_tabella = 'dispositivo_tipo_dispositivo';
	protected $classe = 'dispositivo_tipo_dispositivo';

/*********************************************************************************************************/
public function inserisci() {
    TO_NOT_IMPLEMENT(__METHOD__);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function modifica() {
    TO_NOT_IMPLEMENT(__METHOD__);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getMostraNascondi() {
    if ((bool)$this->mostra_in_dashboard) {
        $id = 'BOTTONE_TIPO_DISPOSITIVO_MOSTRA_DASHBOARD';
        return bottone($this->oApp, strtoupper($id), strtolower($id), $this, FALSE, TRUE);
    } else {
        $id = 'BOTTONE_TIPO_DISPOSITIVO_NASCONDI_DASHBOARD';
        return bottone($this->oApp, strtoupper($id), strtolower($id), $this, FALSE, TRUE);
    }
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function nascondi() {
    $sql = 'UPDATE dispositivo_tipo_dispositivo SET mostra_in_dashboard=0 WHERE id_tipo_dispositivo='.num2Str($this->id_tipo_dispositivo);
    return $this->oDb->eseguiupdate($sql);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function mostra() {
    $sql = 'UPDATE dispositivo_tipo_dispositivo SET mostra_in_dashboard=1 WHERE id_tipo_dispositivo='.num2Str($this->id_tipo_dispositivo);
    return $this->oDb->eseguiupdate($sql);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function setModeRSA() {
    $this->oDb->disattivaAutocommit();
    $this->oDb->iniziaTransazione();

    $sql = 'UPDATE dispositivo_tipo_dispositivo SET mostra_in_dashboard=0';
    $ret = $this->oDb->eseguiupdate($sql);
    if ($ret === TRUE) {
        $sql = 'UPDATE dispositivo_tipo_dispositivo SET mostra_in_dashboard=1 WHERE id_tipo_dispositivo='.num2Str(TIPO_DISPOSITIVO_ID_ALLARME_TECNICO);
        $ret = $this->oDb->eseguiupdate($sql);
        if ($ret === TRUE) {
            $this->oDb->confermaTransazione();
            $this->oDb->attivaAutocommit();
            return TRUE;
        }
    }
    $this->oDb->annullaTransazione();
    $this->oDb->attivaAutocommit();
    return FALSE;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
}
?>