<?php
define('CHARSET', 'utf-8');
define('NL', "\r\n");
define('TAB', "\t");
define('BR','<br/>');
define('HR','<hr/>');
define('SP','&nbsp;');

/*********************************************************************************************************/
// INIZIO COSTANTI PER LA LINGUA
/*********************************************************************************************************/
define('LINGUA_NAVIGAZIONE', 'it_IT');
$lingue_attive = array();
$lingue_attive[] = 'it_IT';
$lingue_attive[] = 'en_UK';
//$lingue_attive[] = 'de_DE';
//$lingue_attive[] = 'ru_RU';
//$lingue_attive[] = 'fr_FR';
define('LINGUE_ATTIVE',serialize($lingue_attive));
setlocale(LC_TIME, 'ita', 'it_IT');
date_default_timezone_set('Europe/Rome');
$GLOBALS['LINGUE_NOMI']['it_IT'] = 'Italiano';
$GLOBALS['LINGUE_NOMI']['en_UK'] = 'English';

define('ITALIANO', 'it_IT');
define('INGLESE', 'en_UK');
/*********************************************************************************************************/
// FINE COSTANTI PER LA LINGUA
/*********************************************************************************************************/

if (array_key_exists('SCRIPT_FILENAME', $_SERVER) ) {
	define('PAGE_NAME', basename($_SERVER['SCRIPT_FILENAME'], '.php'));
} elseif (array_key_exists('PATH_TRANSLATED', $_SERVER) ) {
	define('PAGE_NAME', basename($_SERVER['PATH_TRANSLATED'], '.php'));
} else {
	die('config.php.inc: non riesco a definiere la costante PAGE_NAME');
}

//*************************************************************************************************************
// INIZIO PATH ASSOLUTI
//*************************************************************************************************************
define('BASE_PATH', str_replace(array('/web','/frontend'), array('',''), str_replace('\\', '/', realpath($_SERVER['DOCUMENT_ROOT']))).'/');

// path primo livello
define('DIR_DATA', BASE_PATH . 'data/');
define('DIR_IMMAGINI', DIR_DATA . 'immagini/');
define('DIR_WEB', BASE_PATH . 'web/');
define('DIR_LOG', BASE_PATH . 'log/');

// path secondo livello
define('DIR_INC', DIR_WEB . 'include/');
define('DIR_CSS', DIR_WEB . 'css/');
define('DIR_JS', DIR_WEB . 'javascript/');

// path inclusioni
define('DIR_CLS', DIR_INC . 'classi/');
define('DIR_EXT', DIR_INC . 'esterne/');
define('DIR_LIB', DIR_INC . 'lib/');
define('DIR_HTM', DIR_INC . 'html/');
define('DIR_WDG', DIR_HTM . 'widgets/');
define('DIR_MSG', DIR_INC . 'txt/');
define('DIR_EMAIL_TEMPLATE', DIR_INC . 'email_template/');

// path risorse
/*
define('DIR_CANDIDATURE', DIR_DATA . 'candidature/');
define('DIR_CMS', DIR_DATA . 'cms/');
define('DIR_CONTENUTI', DIR_CMS . 'contenuti/');
define('DIR_FASE', DIR_DATA . 'fase/');
define('DIR_IMMAGINI_CMS', DIR_IMMAGINI . 'cms/');
*/

// path log
define('DIR_LOG_APACHE', DIR_LOG . 'apache/');
define('DIR_LOG_APPL', DIR_LOG . 'applicazione/');
define('DIR_LOG_PHP', DIR_LOG . 'php/');
define('DIR_LOG_MYSQL', DIR_LOG . 'mysql/');
define('DIR_LOG_BATCH', DIR_LOG . 'batch/');

// path web
define('DIR_AZIONI', DIR_WEB . 'azioni/');
define('DIR_BACKEND', DIR_WEB . 'backend/');
define('DIR_AZIONI_BACKEND', DIR_BACKEND . 'azioni/');
define('DIR_FRONTEND', DIR_WEB . 'frontend/');
define('DIR_AZIONI_FRONTEND', DIR_FRONTEND . 'azioni/');
define('DIR_FRONTEND_INCLUDE', DIR_FRONTEND . 'helpers/');
define('DIR_IMMAGINI_WEB', DIR_WEB . 'img/');
define('DIR_PDF', DIR_BACKEND . 'pdf/');
define('DIR_PDF_INC', DIR_PDF . 'classi/');
define('DIR_PDF_INC_STAMPE', DIR_PDF . 'include/');
//*************************************************************************************************************
// FINE PATH ASSOLUTI
//*************************************************************************************************************

//*************************************************************************************************************
// INIZIO URL
//*************************************************************************************************************
define('BASE_URL', DOMINIO);

// TODO ELIMINARE define('URL_IMG', DOMINIO . 'img/');
// TODO ELIMINARE define('URL_FAV', URL_IMG . 'favicon/');
define('URL_AZIONI', DOMINIO . 'azioni/');
define('URL_FRONTEND', DOMINIO);
// TODO ELIMINARE define('URL_AZIONI_FRONTEND', DOMINIO . 'azioni/');
define('URL_BACKEND', DOMINIO . 'backend/');
define('URL_AZIONI_BACKEND', URL_BACKEND . 'azioni/');

define('URL_CSS', DOMINIO . 'css/');
define('URL_JSC', DOMINIO . 'js/');
define('URL_IMG', DOMINIO . 'img/');
define('URL_AUDIO', DOMINIO . 'audio/');
//*************************************************************************************************************
// FINE URL
//*************************************************************************************************************

//********************************************************************************
// INIZIO PARAMETRI PER EMAIL
//********************************************************************************
// TODO ELIMINARE define('TESTO_INTRO', '&Egrave; giunta la seguente richiesta di contatti:');
// TODO ELIMINARE define('TESTO_SALUTO', 'Cordiali saluti');
// TODO ELIMINARE define('CAMPI_ESCLUSI', serialize(array('')));

// TODO ELIMINARE define('SFONDO_DISPARI', '#FFFFFF');
// TODO ELIMINARE define('SFONDO_PARI', '#D3E7D4');
// TODO ELIMINARE define('COLORE_TESTO', '#216811');

// TODO ELIMINARE define('EMAIL_TEMPLATE_CONTATTI', DIR_EMAIL_TEMPLATE.'template_email.html');
//********************************************************************************
// FINE PARAMETRI PER EMAIL
//********************************************************************************

//*************************************************************************************************************
// INIZIO PARAMETRI PER IL LOG DELLE OPERAZIONI
//*************************************************************************************************************
define('LOG_FILL_LINE', str_pad('', 100, '*'));
define('LOG_BREAK_LINE', '');
define('LOG_PAD_LINE', 70);
//*************************************************************************************************************
// FINE PARAMETRI PER IL LOG DELLE OPERAZIONI
//*************************************************************************************************************

//*************************************************************************************************************
// INIZIO PARAMETRI SELECT MODE PER DB
//*************************************************************************************************************
define('CLASS_DB_SELECT_MODE_STANDARD', 1);
define('CLASS_DB_SELECT_MODE_SINGLE_ROW', 2);
define('CLASS_DB_SELECT_MODE_SINGLE_VALUE', 3);
define('CLASS_DB_SELECT_MODE_SINGLE_COLUMN', 4);
//*************************************************************************************************************
// FINE PARAMETRI SELECT MODE PER DB
//*************************************************************************************************************

//*************************************************************************************************************
// INIZIO PARAMETRI TEMPLATE
//*************************************************************************************************************
define('TEMPLATE_LOGIN', 'login');
define('TEMPLATE_STANDARD', 'standard');
// TODO ELIMINARE define('TEMPLATE_LOGIN_GESTIONALE', 'login');
// TODO ELIMINARE define('TEMPLATE_GESTIONALE', 'backend');
// TODO ELIMINARE define('TEMPLATE_STANDARD', 'backend_no_right_bars');
// TODO ELIMINARE define('TEMPLATE_ESTERNO', 'esterno');
// TODO ELIMINARE define('TEMPLATE_HOME', 'home');
// TODO ELIMINARE define('TEMPLATE_NO_LOGGATO', 'esterna');
//*************************************************************************************************************
// FINE PARAMETRI TEMPLATE
//*************************************************************************************************************

//*************************************************************************************************************
// INIZIO PARAMETRI STILI OGGETTI BOOTSTRAP
//*************************************************************************************************************
define('STYLE_DATATABLE_BASIC', 'table datatables_base');
define('STYLE_DATATABLE_FILTRO_COLONNE', 'datatables_filtro_colonne');
define('STYLE_TABLE_HOVER', 'table-hover');
define('STYLE_TABLE_STRIPED', 'table table-striped');

$aA = array();
$aA[] = 'azioni';
$aA[] = 'modifica';
$aA[] = 'accetta_variazione';
$aA[] = 'crea_candidatura';
$aA[] = 'rifiuta_variazione';
$aA[] = 'recupera_permesso_ferie';
$aA[] = 'bottone_impegno_comune';
$aA[] = 'bottone_incarico_cooperativa';
$aA[] = 'link_modifica';
$aA[] = 'elimina';
$aA[] = 'elimina_no_etichetta';
$aA[] = 'azioni_censimento';
$aA[] = 'dettaglio_archivio';
$aA[] = 'compila_report';
$aA[] = 'conferma_report';
$aA[] = 'cambia_assegnazione';
$aA[] = 'attiva_sospendi';
$aA[] = 'accetta_non_conformita';
$aA[] = 'rifiuta_non_conformita';
$aA[] = 'sospendi';
$aA[] = 'cancella';
$aA[] = 'archivia';
$aA[] = 'inserisci_report';
$aA[] = 'togli_assegnazione';
$aA[] = 'preview';
$aA[] = 'checkbox';
$aA[] = 'radio';
$aA[] = 'modifica_impostazioni_giornale';
$aA[] = 'attiva_sospendi_mezze';
$aA[] = 'attiva_sospendi_mezze_segreteria';
//$aA[] = 'ordine_select';
$aA[] = 'configura';
$aA[] = 'visualizza_pdf';
$aA[] = 'invia_sollecito';
$aA[] = 'contatta_via_mail';
$aA[] = 'feedback';
$aA[] = 'report_emozioni';
$aA[] = 'vedi_dispositivi';
$aA[] = 'mostra_nascondi';
$aA[] = 'risolto_decoded';

define('DATATABLE_CAMPI_CENTRALI', serialize($aA));
//*************************************************************************************************************
// FINE PARAMETRI STILI OGGETTI BOOTSTRAP
//*************************************************************************************************************


//*************************************************************************************************************
// INIZIO PARAMETRI SEZIONI GESTIONALE
//*************************************************************************************************************
define('SEZIONE_FRONTEND','frontend');
define('SEZIONE_UTENTI', 'utenti');
define('SEZIONE_SUPERVISORI', 'supervisori');
define('SEZIONE_SISTEMA', 'sistema');
define('SEZIONE_INFORMZIONI', 'informazioni');
define('SEZIONE_STATISTICHE', 'statistiche');
define('SEZIONE_RELAY', 'relay');
define('SEZIONE_ABBINAMENTO', 'abbinamento');
define('SEZIONE_ANTINCENDIO', 'antincendio');


// TODO ELIMINARE define('SEZIONE_HOME', 'home');
// TODO ELIMINARE define('SEZIONE_SISTEMA', 'sistema');
// TODO ELIMINARE define('SEZIONE_CMS', 'cms');
// TODO ELIMINARE define('SEZIONE_TEATRI', 'teatri');
// TODO ELIMINARE define('SEZIONE_SPETTACOLO', 'spettacolo');
// TODO ELIMINARE define('SEZIONE_COUPON', 'coupon');
// TODO ELIMINARE define('SEZIONE_STATISTICHE', 'statistiche');

//*************************************************************************************************************
// FINE PARAMETRI SEZIONI GESTIONALE
//*************************************************************************************************************

//*************************************************************************************************************
// INIZIO PARAMETRI SITO PUBBLICO
//*************************************************************************************************************



// TODO ELIMINARE define('NUMERO_OFFERTE_AGENZIE_HOMEPAGE', 9);
// TODO ELIMINARE define('NUMERO_AGENZIE_ELENCO_HOMEPAGE', 9);
// TODO ELIMINARE define('NUMERO_OFFERTE_ULTIME_FOOTER', 3);
// TODO ELIMINARE define('NUMERO_OFFERTE_ELENCO', 30);
//*************************************************************************************************************
// FINE PARAMETRI SITO PUBBLICO
//*************************************************************************************************************


//*************************************************************************************************************
// INIZIO PERMESSI STANDARD
//*************************************************************************************************************

define('PERMESSO_NESSUNO', 'nessuno');
define('PERMESSO_LOGGATO', 'nessuno');
define('UTENTE_TIPO_ID_SUPERADMIN', 1);
define('UTENTE_TIPO_ID_ADMIN', 2);
define('UTENTE_TIPO_ID_SEGRETERIA', 3);
define('UTENTE_TIPO_ID_UTENTE', 4);
//*************************************************************************************************************
// FINE PERMESSI STANDARD
//*************************************************************************************************************

//*************************************************************************************************************
// INIZIO ELENCO STATUS
//*************************************************************************************************************
define('STATUS_ATTIVO', 1);
define('STATUS_ELIMINATO', 2);
define('STATUS_IN_AGGIORNAMENTO',3);
define('STATUS_NON_VALIDA',4);
define('STATUS_SOSPESO',5);
define('STATUS_OFFLINE',6);
define('STATUS_ALLARME_ATTIVO',7);
define('STATUS_ALLARME_RISOLTO',8);
//*************************************************************************************************************
// FINE ELENCO STATUS
//*************************************************************************************************************

//*************************************************************************************************************
// INIZIO ID CANALI CMS
//*************************************************************************************************************
// TODO ELIMINARE define('CMS_ID_CANALE_NEWS', 1);
// TODO ELIMINARE define('CMS_ID_CANALE_HOMEPAGE', 2);

// TODO ELIMINARE define('CMS_ID_CONTENUTO_CONTATTI', 1);
// TODO ELIMINARE define('CMS_ID_CONTENUTO_TESTO_HOMEPAGE', 2);

//*************************************************************************************************************
// FINE ID CANALI CMS
//*************************************************************************************************************
define('aFILTRI_RICERCA', serialize(array('candidatura')));
define('aCLASSI_DA_NON_AUTOLOAD', serialize(array('fpdf','')));
define('aATTRIBUTI_DA_NON_SERIALIZZARE',serialize(array('oDb','oApp','oUtente','aMsg','aEtichette','htmlHead','htmlBody','htmlJscript')));
define('aSESSO', serialize(array('M' => 'maschio', 'F' => 'femmina')));
define('aTIPI_DIZIONARIO', serialize(array('diz_stringa','diz_descrizione','diz_editor')));
define('TIPO_DIZIONARIO_STRINGA', 'diz_stringa');
define('TIPO_DIZIONARIO_DESCRIZIONE', 'diz_descrizione');
define('TIPO_DIZIONARIO_EDITOR', 'diz_editor');
define('aMESI', serialize(array('Gennaio','Febbraio','Marzo','Aprile','Maggio','Giugno','Luglio','Agosto','Settembre','Ottobre','Novembre','Dicembre')));

//*************************************************************************************************************
// INIZIO STILI MESSAGGI ERRORE
//*************************************************************************************************************
define('aTIPI_MESSAGGI_ERRORE', serialize(array('alert-warning','alert-success','alert-info','alert-danger','alert-primary','alert-secondary','alert-dark','alert-light')));
define('MESSAGGIO_WARNING', 'alert-warning');
define('MESSAGGIO_SUCCESSO', 'alert-success');
define('MESSAGGIO_INFO', 'alert-info');
define('MESSAGGIO_ERRORE', 'alert-danger');
define('MESSAGGIO_PRIMARIO', 'alert-primary');
define('MESSAGGIO_SECONDARIO', 'alert-secondary');
define('MESSAGGIO_SCURO', 'alert-dark');
define('MESSAGGIO_LIGHT', 'alert-light');
//*************************************************************************************************************
// FINE STILI MESSAGGI ERRORE
//*************************************************************************************************************


//*************************************************************************************************************
// INIZIO PARAMETRI IMMAGINI
//*************************************************************************************************************
$aImmaginiDimensioni = array();
$aImmaginiDimensioni['100x100'] = array('x'=>100,'y'=>100,'thumb'=>FALSE, 'watermark_logo'=>FALSE, 'watermark_scritta'=>FALSE, 'font_size'=> 10);
$aImmaginiDimensioni['270x200'] = array('x'=>270,'y'=>200,'thumb'=>TRUE, 'watermark_logo'=>FALSE, 'watermark_scritta'=>FALSE, 'font_size'=> 20);
$aImmaginiDimensioni['400x400'] = array('x'=>270,'y'=>200,'thumb'=>FALSE, 'watermark_logo'=>FALSE, 'watermark_scritta'=>FALSE, 'font_size'=> 30);
$aImmaginiDimensioni['647x293'] = array('x'=>647,'y'=>293,'thumb'=>TRUE, 'watermark_logo'=>FALSE, 'watermark_scritta'=>FALSE, 'font_size'=> 50);
$aImmaginiDimensioni['870x8700'] = array('x'=>870,'y'=>8700,'thumb'=>FALSE, 'watermark_logo'=>FALSE, 'watermark_scritta'=>FALSE, 'font_size'=> 50);
define('IMMAGINI_DIMENSIONI', serialize($aImmaginiDimensioni));
define('IMMAGINI_DIMENSIONE_MINORE', '100x100');
define('IMMAGINI_DIMENSIONE_MAGGIORE', '870x8700');
define('IMMAGINI_DIMENSIONE_SLIDER', '647x293');
define('IMMAGINI_DEFAULT_BACKEND', '400x400');
define('IMMAGINI_DEFAULT_FRONTEND', '400x400');
define('IMMAGINI_SEGNAPOSTO_DIMENSIONI','%%DIMENSIONE%%');

//ELENCO ESTENSIONI AMMESSE IN UPLOAD MULTIPLO DI IMMAGINI  
$aImmaginiEstensioniAmmesse = array('jpg', 'jpeg', 'gif', 'png'); 
define('IMMAGINI_ESTENSIONI_AMMESSE', serialize($aImmaginiEstensioniAmmesse));
define("MAX_FILE_PIXEL_LATO_PIU_CORTO",144);
//*************************************************************************************************************
// FINE PARAMETRI IMMAGINI
//*************************************************************************************************************

//*************************************************************************************************************
// INIZIO PARAMETRI DOCUMENTI
//*************************************************************************************************************
//ELENCO ESTENSIONI AMMESSE IN UPLOAD DOCUMENTI   
$aDocumentiEstensioniAmmesse = array('pdf', 'doc', 'docx', 'odt', 'xls', 'xlsx', 'jpg', 'jpeg'); 
define('DOCUMENTI_ESTENSIONI_AMMESSE', serialize($aDocumentiEstensioniAmmesse));
//*************************************************************************************************************
// FINE PARAMETRI DOCUMENTI
//*************************************************************************************************************


//*************************************************************************************************************
// INCLUSIONE DELLE LIBRERIE 
//*************************************************************************************************************
require_once(DIR_LIB . 'lib.debug.php');
require_once(DIR_LIB . 'lib.generali.php');
require_once(DIR_LIB . 'lib.output.php');
require_once(DIR_LIB . 'lib.html.php');

//*************************************************************************************************************

//*************************************************************************************************************
// DIMENSINE MAX DEI FILE CARICATI
// SE SI DECIDE DI AUMENTARLO, RICORDARSI DI CAMBIARE ANCHE IL VALORE NEL PHP.INI
//*************************************************************************************************************
define("MAX_SIZE_FILE_UPLOAD",4194304); //4MB
define("MAX_SIZE_FILE_UPLOAD_PER_JS",MAX_SIZE_FILE_UPLOAD/1024); //COSTANTE USATA DAL JS
//*************************************************************************************************************
//*************************************************************************************************************

define('APP_VERSION', 20);

define('NAZIONI_ID_ITALIA', 195);
define('CREAZIONE_UTENTE_ID_UTENTE_CREATORE_ANONIMO', 9999999);
define('CREAZIONE_UTENTE_ID_PROVENIENZA_ESTERNA', 2);
define('UTENTE_REGISTRAZIONE_INVIA_EMAIL', TRUE);

define('SOTTO_TIPO_DISPOSITIVO_VIRTUAL_INOLTRO_ID', 29);
define('SOTTO_TIPO_DISPOSITIVO_VIRTUAL_ALL_ID', 30);

define('TIPO_VISUALIZZAZIONE_ID_TS01', 3);

define('TIPO_DISPOSITIVO_ID_WS', 1);
define('TIPO_DISPOSITIVO_ID_TS01', 2);

define('INTERVALLO_CONTROLLO_ALLARMI_IN_SECONDI', 5);
define('INTERVALLO_CONTROLLO_STATO_SUPERVISORE', 2);

define('STAMPA_MAPPE_VUOTE', FALSE);

define('FILE_DASHBOARD_CACHE', '/tmp/yassDashboard-##UTENTE_TIPO_ID##-##LINGUA##.html');
define('CHIAVE_SEGRETA', 'yassChiaveSegreta');


define('TIPO_DISPOSITIVO_ID_ALLARME_TECNICO', 3);

define('ELENCO_ALLARMI_MENU_MAX_ALLARMI', 5);


define('LIPSUM','Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed iaculis iaculis metus a luctus. Aliquam ac nisl porta, lobortis turpis in, porttitor ante. Donec aliquet luctus sem, id auctor mi ultricies et. Nam et tincidunt metus. Sed non neque neque. Nullam consequat elit vel erat luctus molestie. Vivamus vitae lobortis quam. Nunc finibus vitae augue vitae ultricies.<br>Nulla vestibulum, arcu ut porttitor efficitur, arcu nisl varius elit, et venenatis arcu leo eget eros. Fusce euismod gravida nisl, vel faucibus eros aliquet eu. In blandit erat id dui bibendum, sit amet posuere est imperdiet. Nunc quam massa, cursus a luctus ut, commodo ac ipsum. Praesent et felis feugiat, tempor risus et, consectetur dui. Fusce scelerisque purus nisi, nec gravida ante accumsan eu. Duis ac ligula odio. Aenean egestas urna eget libero dictum rutrum. Maecenas elementum suscipit mattis. Suspendisse urna leo, tempor sed laoreet vitae, pretium ut felis. Sed blandit pulvinar luctus.<br>Praesent non ipsum id turpis bibendum vehicula sed non ante. Proin sollicitudin pellentesque ultrices. Phasellus fermentum purus massa, non tincidunt turpis egestas sit amet. Suspendisse congue iaculis accumsan. Donec tristique purus magna, eu dapibus sem finibus eu. Proin tempus finibus dui, eu malesuada quam aliquet sit amet. Nam pretium fermentum augue, sit amet posuere neque imperdiet sed. Proin pharetra metus vel justo ultrices, quis congue nibh fringilla. Donec non elit porttitor, hendrerit justo et, dapibus massa. Fusce tempor consequat mi, eget venenatis justo tincidunt eget.<br>Integer non ante sit amet augue facilisis suscipit. Nam non euismod elit. Morbi vulputate, elit non tincidunt ultrices, arcu dolor tincidunt lacus, et pretium leo sapien in nisi. Duis elementum nulla ipsum, nec lobortis tortor lacinia id. Ut ut tellus sed orci cursus pulvinar. Etiam vulputate fermentum risus, at mollis eros accumsan ut. Donec vitae arcu nibh. Pellentesque ex augue, tincidunt quis sapien pretium, molestie vehicula nibh. Sed feugiat enim et sem pellentesque feugiat.<br>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nunc malesuada augue luctus quam ultricies dictum. In ac diam eget libero scelerisque eleifend eget ut augue. In blandit ex eget neque euismod tempor. In hac habitasse platea dictumst. Nulla ultricies porta mauris, id maximus sem fermentum quis. Fusce lacus massa, laoreet vel erat et, blandit pretium nulla. Curabitur sed venenatis ligula. Proin ultricies, dui sed volutpat rhoncus, diam dui pretium arcu, sed ullamcorper elit lorem et risus. Donec vel finibus lacus. Vestibulum et dapibus ante. Nullam convallis facilisis ipsum.<br>Pellentesque molestie, eros a fermentum feugiat, metus augue condimentum erat, at dapibus ipsum lectus sed tellus. Donec interdum auctor erat ac semper. Fusce suscipit fermentum vestibulum. Vestibulum egestas lectus eu mattis fringilla. In hac habitasse platea dictumst. Ut hendrerit malesuada est, in sagittis augue laoreet et. Nullam in tristique augue. Nulla facilisi. Quisque varius vitae nibh et eleifend. Etiam pretium metus sem, id auctor lorem finibus eget. Donec pulvinar lobortis erat, iaculis scelerisque arcu bibendum ut. Suspendisse consequat cursus feugiat. Pellentesque porta orci sodales nibh laoreet, ac cursus ipsum interdum. Duis fringilla venenatis diam, non posuere magna. Donec ut justo eget ipsum tristique mattis.<br>Sed turpis metus, fringilla euismod nibh sit amet, semper sodales felis. Donec eget nunc sodales elit vulputate consequat in ac orci. Proin elementum neque ut metus ullamcorper, faucibus gravida libero dictum. Vestibulum erat eros, condimentum in mollis ac, venenatis vitae erat. Vestibulum sed justo ac augue porta semper. Curabitur varius venenatis pretium. Aliquam erat volutpat. Donec egestas dignissim faucibus. Curabitur dui mauris, varius vel neque non, pharetra commodo elit. Mauris feugiat tempus nunc, vitae suscipit sapien imperdiet sit amet. Ut fermentum lectus leo, et dapibus eros tristique sit amet. Donec lacinia ligula commodo diam molestie, eget varius diam viverra. In hac habitasse platea dictumst. Nulla a dolor quis risus sollicitudin ullamcorper vitae et risus. Sed enim ipsum, tincidunt ut pretium id, posuere sed lorem.<br>Etiam sit amet eros at velit lacinia porta quis sed lacus. Curabitur hendrerit, ipsum sed lacinia dictum, turpis tellus rutrum ante, non consectetur mauris turpis nec magna. Suspendisse maximus, leo vitae tempor bibendum, mauris urna sodales eros, in dapibus nunc ligula at mi. Integer eget porta elit, in feugiat nibh. Sed ultrices augue eu ex posuere auctor. Morbi viverra nulla sit amet sapien bibendum vehicula. Aenean euismod, risus ut accumsan feugiat, justo tortor facilisis magna, nec lobortis massa tortor in erat. Aliquam nec risus tellus. Quisque at venenatis urna. Vivamus massa nisi, commodo eu auctor nec, dignissim et eros. Donec scelerisque metus eu ligula suscipit, eget dignissim dui commodo. In dignissim dolor id ullamcorper sodales.<br>Nam a quam sit amet est ultrices consectetur ac nec nisi. Maecenas ligula nunc, tempus nec ultricies non, scelerisque ac orci. Donec sed ornare ligula. Sed consequat ipsum a magna gravida, ac tempor dolor malesuada. Aliquam sed ornare purus. Pellentesque sem turpis, interdum eu volutpat nec, euismod a erat. Aliquam euismod turpis quam, a lacinia est ultricies id. Interdum et malesuada fames ac ante ipsum primis in faucibus. Suspendisse volutpat nisl urna, a bibendum nunc feugiat vitae.<br>Donec at laoreet diam. Etiam non hendrerit justo. Curabitur eget semper lectus. Maecenas sit amet velit at libero faucibus pulvinar. Curabitur eget posuere ante. Donec hendrerit accumsan dignissim. Integer sed vulputate elit. Pellentesque eleifend eros mollis sem pulvinar tincidunt. Nam scelerisque molestie malesuada.');
?>