<?php

function isMobile() {
	$useragent = $_SERVER['HTTP_USER_AGENT'];
	
	if(preg_match('/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino/i',$useragent)||preg_match('/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i',substr($useragent,0,4)))
		return true;

	return false;
}

/*********************************************************************************************************/
/*********************************************************************************************************/
function readPostParam($paramName, $encrypted=null){

	$paramValue = "";

	if (isset($_POST[$paramName])) {
		$paramValue = trim(stripcslashes($_POST[$paramName]));
		if ($encrypted && TUTTI_GLI_ID_CRIPTATI) {
			$paramValue = decrypt(CHIAVE_CRIPTAZIONE, $paramValue);
		}
		return $paramValue;
	} else {
		return null;
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function readGetParam($paramName, $encrypted=null){

	$paramValue = "";

	if (isset($_GET[$paramName])) {
		$paramValue = trim(stripcslashes($_GET[$paramName]));
		if ($encrypted && TUTTI_GLI_ID_CRIPTATI) {
			$paramValue = decrypt(CHIAVE_CRIPTAZIONE, base64_decode($paramValue));
		}
		return $paramValue;
	} else {
		return null;
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function writeGetParam($paramValue){
	if (TUTTI_GLI_ID_CRIPTATI) {
		$paramValue = base64_encode(encrypt(CHIAVE_CRIPTAZIONE, $paramValue));
		//TOLGO L'EVENTUALE CARATTERE '=' CHE A VOLTE VIENE MESSO AL TERMINE DELLA STRINGA
		//E CHE NON SERVE A NULLA
		if (substr($paramValue, -1) == '=') $paramValue = substr($paramValue, 0, strlen($paramValue)-1);
	}
	return $paramValue;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function writePostParam($paramValue){
	if (TUTTI_GLI_ID_CRIPTATI) {
		$paramValue = encrypt(CHIAVE_CRIPTAZIONE, $paramValue);
	}
	return $paramValue;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function stripcslashesandquote($str, $trim = TRUE) {
	if ($trim) $str = trim($str);
	$str = stripcslashes($str);
	$str = str_replace('\\', '\\\\', $str);
	$str = str_quoted($str);
	return $str;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function str_quoted( $x ) {
	if (is_null($x)){
		return "''";
	}else{
		return "'" . str_replace ("'", "\'", $x) . "'";
	}
	
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function encrypt($keyword, $value){
   $text = $value;
   $iv_size = mcrypt_get_iv_size(MCRYPT_RIJNDAEL_256, MCRYPT_MODE_ECB);
   $iv = mcrypt_create_iv($iv_size, MCRYPT_RAND);
   $crypttext = mcrypt_encrypt(MCRYPT_RIJNDAEL_256, $keyword, $text, MCRYPT_MODE_ECB, $iv);
   return base64_encode($crypttext);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function decrypt($keyword, $value){
   $crypttext = base64_decode($value);
   $iv_size = mcrypt_get_iv_size(MCRYPT_RIJNDAEL_256, MCRYPT_MODE_ECB);
   $iv = mcrypt_create_iv($iv_size, MCRYPT_RAND);
   $decrypttext = mcrypt_decrypt(MCRYPT_RIJNDAEL_256, $keyword, $crypttext, MCRYPT_MODE_ECB, $iv);
   return trim($decrypttext);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function quoteStr($s){
	return str_replace("'", "''", $s);
}

/*********************************************************************************************************/
function stampasufile($file, $txt, $mode = "ab+") {
  $dataOra = date("d/m/Y - H:i:s");
  
  $f = fopen($file, $mode);
  $retVal = fwrite($f, $dataOra.") ".$txt."\r\n");
  if ($retVal === FALSE) {
  	echo "ERRORE";
  }
  fclose($f);
}
/*********************************************************************************************************/
function salvaFileTabDelimitated($file, $txt, $mode = "ab+") {
  $f = fopen($file, $mode);
  fwrite($f, $txt);
  fclose($f);
}
/*********************************************************************************************************/
function outputFileTabDelimitated($txt) {
	$nomefile = date("YmdHis").trim(substr(microtime(), 2, 9)).".csv";
	
	header("pragma: cache");
    header("pragma: public");
    header("Cache-Control: max-age=0");
    header("Cache-Control: private" , false); // required for certain browsers 
    header("Content-Type: text/csv");
    header("Expires: 0");
    header("Content-Disposition: attachment; filename=\"".basename($nomefile)."\"");
	
	echo $txt;
	flush();
}
/*********************************************************************************************************/
function getmicrotime(){
    list($usec, $sec) = explode(" ",microtime());
    return $usec;
}
/*********************************************************************************************************/
function num2Str($s, $nullo=false) {
	//Mi aspetto che il numero sia in formato italiano (punti come separatori delle migliaia e virgole come decimali)
	
  /*
  if (!is_numeric($s)) {
		if ($nullo) {
			$s="NULL";
			return $s;
		}else{
			return 0;
		}
	}
		
	if (!($s=='')){
		$s=str_replace (".", "", $s);
		$s=str_replace (",", ".", $s);
		return $s;
	}else{
		//SE ZERO E' SIGNIFICATIVO FORZO IL VALORE NULL NEL
		//CAMPO NUMERICO
		if ($nullo) {
			$s="NULL";
			return $s;
		}else{
			return 0;
		}
		
		
	}
  */
  
  if (!($s=='')){
		$s=str_replace (".", "", $s);
		$s=str_replace (",", ".", $s);
    
    if (!is_numeric($s)) {
      if ($nullo) {
			   $s="NULL";  		
  		}else{
  			$s= 0;
  		}
   }
    
		return $s;
	}else{
		//SE ZERO E' SIGNIFICATIVO FORZO IL VALORE NULL NEL
		//CAMPO NUMERICO
		if ($nullo) {
			$s="NULL";
			return $s;
		}else{
			return 0;
		}
		
		
	}
  
  
}
/*********************************************************************************************************/
function decimal2db($decimal) {
	$regEx = '/[0-9,]/';
	if( !preg_match($regEx, $decimal, $matches) ) $decimal = 0.00;
	$decimal=str_replace (".", "", $decimal);
	$decimal=str_replace (",", ".", $decimal);
	return $decimal;
}
/*********************************************************************************************************/
//il parametro filtro indica se la data serve per delle ricerche temporali
function date2db($stringa,$filtro=FALSE) {
	if (empty($stringa)) return '"0000-00-00"';
	if ($stringa == '0000-00-00') return '"0000-00-00"';
	if ($stringa == '00-00-0000') return '"0000-00-00"';
	
	/*
	$regEx = '/^(\d{2}|\d{4})(?:\-)?([0]{1}\d{1}|[1]{1}[0-2]{1})(?:\-)?([0-2]{1}\d{1}|[3]{1}[0-1]{1})(?:\s)?([0-1]{1}\d{1}|[2]{1}[0-3]{1})(?::)?([0-5]{1}\d{1})(?::)?([0-5]{1}\d{1})?$/';
	if( preg_match($regEx, $stringa, $matches) ) return '"'.$stringa.'"';
	
	$regEx = '/^\d{4}[\-\/\s]?((((0[13578])|(1[02]))[\-\/\s]?(([0-2][0-9])|(3[01])))|(((0[469])|(11))[\-\/\s]?(([0-2][0-9])|(30)))|(02[\-\/\s]?[0-2][0-9]))$/';
	if( !preg_match($regEx, $stringa, $matches) ) return '"'.$stringa.'"';
	*/
	
	try {
		$oData = new DateTime($stringa);
		if($filtro){
			return '"'.$oData->format('Ymd').'"';
		}
		else{
			return '"'.$oData->format('Y-m-d').'"';
		}
	} catch (Exception $e) {
		return '"0000-00-00"';
	}
	
}
/*********************************************************************************************************/
function datetime2db($stringa) {
	if (empty($stringa)) return '"0000-00-00 00:00:00"';
	if ($stringa == '00-00-0000 00:00') return '"0000-00-00 00:00:00"';
	if ($stringa == '00-00-0000 00:00:00') return '"0000-00-00 00:00:00"';
	if (strlen($stringa) == 16) $stringa = $stringa . ':00'; 
	
	/*
	$regEx = '/^(\d{2}|\d{4})(?:\-)?([0]{1}\d{1}|[1]{1}[0-2]{1})(?:\-)?([0-2]{1}\d{1}|[3]{1}[0-1]{1})(?:\s)?([0-1]{1}\d{1}|[2]{1}[0-3]{1})(?::)?([0-5]{1}\d{1})(?::)?([0-5]{1}\d{1})?$/';
	if( preg_match($regEx, $stringa, $matches) ) return '"'.$stringa.'"';
	
	$regEx = '/^\d{4}[\-\/\s]?((((0[13578])|(1[02]))[\-\/\s]?(([0-2][0-9])|(3[01])))|(((0[469])|(11))[\-\/\s]?(([0-2][0-9])|(30)))|(02[\-\/\s]?[0-2][0-9]))$/';
	if( !preg_match($regEx, $stringa, $matches) ) return '"'.$stringa.'"';
	*/
	
	try {
		$oData = new DateTime($stringa);
		return '"'.$oData->format('Y-m-d H:i:s').'"';
	} catch (Exception $e) {
		return '"0000-00-00 00:00:00"';
	}
	
}
/*********************************************************************************************************/
function boolean2db($stringa) {
	if ($stringa == 1) return 1;
	return 0; 
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function aggiungizeri($stringa, $numero) {
  while (strlen($stringa) < $numero) {
    $stringa = "0".$stringa;
  }
  return $stringa;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function utf8_strtolower($stringa) {
	return utf8_encode(strtolower(utf8_decode($stringa)));
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function formattaPrezzo($prezzo, $euro = TRUE, $precisione = 2) {
	return (($euro)?'&euro;&nbsp;':'') . number_format(round($prezzo, $precisione), $precisione, ',', '.');
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function formattaPrezzoXml($prezzo, $euro = TRUE, $precisione = 2) {
	return (($euro)?'&#140; ':'') . number_format(round($prezzo, $precisione), $precisione, ',', '.');
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function formattaPrezzoPdf($prezzo, $euro = TRUE, $precisione = 2) {
	return (($euro)?'€ ':'') . number_format(round($prezzo, $precisione), $precisione, ',', '.');
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function formattaNumero($prezzo,$precisione = 2, $nullSignificativo = FALSE) {
	if ($nullSignificativo && is_null($prezzo)) {
		return NULL;
	}
    if (strpos($prezzo, ',')===FALSE){
        //echo 'valore in entrata='.$prezzo.'<br>';
        $prezzo_formattato = number_format($prezzo, 2, ",", "");
        //echo 'valore in uscita='.$prezzo_formattato.'<br>';
    }else{
        $prezzo_formattato = $prezzo;
    }
    
    return $prezzo_formattato;  
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function formattaData($data) {
	$d = new DateTime($data);
	return $d->format('d/m/Y');
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function formattaOra($ora) {
	$hh = substr($ora, 0, 2);
	$mm = substr($ora, 2, 2);
	$ss = substr($ora, 4, 2);
	return $hh.':'.$mm.':'.$ss;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function inviaMail($mittente, $mittente_nome, $destinatario, $oggetto, $testo, $elencoDestinatari = array(), $charset = 'UTF-8', $attachment = FALSE, $bcc = false) {
	if (APP_SVILUPPO) {
		//$destinatario = SENDMAIL_PROVA;
	}
	$mail 			= new PHPMailer();  
	$mail->From     = $mittente;  
	$mail->FromName = $mittente_nome;  
	$mail->AddAddress($destinatario);
	foreach ($elencoDestinatari as $d) {
		$mail->AddAddress($d);
	}
	if (APP_SVILUPPO && SENDMAIL_BCC !== FALSE) {
		$mail->AddBCC(SENDMAIL_BCC);
	}
	if (APP_SVILUPPO && SENDMAIL_BCC2 !== FALSE) {
		$mail->AddBCC(SENDMAIL_BCC2);
	}
	if (APP_SVILUPPO && SENDMAIL_BCC3 !== FALSE) {
		$mail->AddBCC(SENDMAIL_BCC3);
	}
	if (APP_SVILUPPO && SENDMAIL_BCC4 !== FALSE) {
		$mail->AddBCC(SENDMAIL_BCC4);
	}
	if(!empty($bcc)){
		$mail->AddBCC($bcc);
	}
	
	$mail->Subject  = $oggetto;
	$mail->IsHTML(true);  
	$mail->Body     = $testo; 
	$mail->AltBody  = strip_tags(substr($testo,0,stripos($testo,'</head>')));
	$mail->WordWrap = 50;  
	$mail->CharSet = $charset;
	if ($attachment !== FALSE)  $mail->AddAttachment($attachment['path'],$attachment['name']);
	$ret = $mail->Send();
	//echo ':'.$ret.':';
	return $ret;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function parseXml($file_xml, $file_xsl) {
	$xp = new XsltProcessor();
	$xsl = new DOMDocument('1.0', 'UTF-8');
	$xsl->load($file_xsl);
	$xp->importStylesheet($xsl);
	
	$xml_doc = new DOMDocument('1.0', 'UTF-8');
 	$xml_doc->load($file_xml);
	
 	if ($html = $xp->transformToXML($xml_doc)) {
		return $html;
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function xmlentities($str, $sostituisci_amp = FALSE) {
    $xml = array('&#x20AC;','&#34;','&#38;','&#38;','&#60;','&#62;','&#160;','&#161;','&#162;','&#163;','&#164;','&#165;','&#166;','&#167;','&#168;','&#169;','&#170;','&#171;','&#172;','&#173;','&#174;','&#175;','&#176;','&#177;','&#178;','&#179;','&#180;','&#181;','&#182;','&#183;','&#184;','&#185;','&#186;','&#187;','&#188;','&#189;','&#190;','&#191;','&#192;','&#193;','&#194;','&#195;','&#196;','&#197;','&#198;','&#199;','&#200;','&#201;','&#202;','&#203;','&#204;','&#205;','&#206;','&#207;','&#208;','&#209;','&#210;','&#211;','&#212;','&#213;','&#214;','&#215;','&#216;','&#217;','&#218;','&#219;','&#220;','&#221;','&#222;','&#223;','&#224;','&#225;','&#226;','&#227;','&#228;','&#229;','&#230;','&#231;','&#232;','&#233;','&#234;','&#235;','&#236;','&#237;','&#238;','&#239;','&#240;','&#241;','&#242;','&#243;','&#244;','&#245;','&#246;','&#247;','&#248;','&#249;','&#250;','&#251;','&#252;','&#253;','&#254;','&#255;');
    $html = array('&euro;','&quot;','&amp;','&amp;','&lt;','&gt;','&nbsp;','&iexcl;','&cent;','&pound;','&curren;','&yen;','&brvbar;','&sect;','&uml;','&copy;','&ordf;','&laquo;','&not;','&shy;','&reg;','&macr;','&deg;','&plusmn;','&sup2;','&sup3;','&acute;','&micro;','&para;','&middot;','&cedil;','&sup1;','&ordm;','&raquo;','&frac14;','&frac12;','&frac34;','&iquest;','&Agrave;','&Aacute;','&Acirc;','&Atilde;','&Auml;','&Aring;','&AElig;','&Ccedil;','&Egrave;','&Eacute;','&Ecirc;','&Euml;','&Igrave;','&Iacute;','&Icirc;','&Iuml;','&ETH;','&Ntilde;','&Ograve;','&Oacute;','&Ocirc;','&Otilde;','&Ouml;','&times;','&Oslash;','&Ugrave;','&Uacute;','&Ucirc;','&Uuml;','&Yacute;','&THORN;','&szlig;','&agrave;','&aacute;','&acirc;','&atilde;','&auml;','&aring;','&aelig;','&ccedil;','&egrave;','&eacute;','&ecirc;','&euml;','&igrave;','&iacute;','&icirc;','&iuml;','&eth;','&ntilde;','&ograve;','&oacute;','&ocirc;','&otilde;','&ouml;','&divide;','&oslash;','&ugrave;','&uacute;','&ucirc;','&uuml;','&yacute;','&thorn;','&yuml;');
    
	$str = str_replace($html,$xml,$str);
	if ($sostituisci_amp) $str = str_replace(chr(38), '&amp;', $str);
	return $str;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function xmlencode($stringa){
   $retVal = trim($stringa);
   
   //SE CI SONO DEI <BR> LI RIMUOVO
   $retVal = str_replace("<br>", " ", $retVal);
   $retVal = str_replace("<BR>", " ", $retVal);

   //RIMUOVO ALCUNI CARATTERI CHE POSSONO INTERFERIRE CON L'HTMLENTITIES O L'XMLENTITIES
   $retVal = str_replace("&", "e", $retVal);
	
   $retVal = xmlentities(htmlentities($retVal));
   
   return $retVal;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
# Controllo del Codice Fiscale
# Linguaggio: PHP 3
function controllaCodiceFiscale($cf) {
	if (empty($cf)) {
		return FALSE;
	}
	if( strlen($cf) != 16 )
		return FALSE;
	$cf = strtoupper($cf);
	if( ! @ereg("^[A-Z0-9]+$", $cf) ){
		return FALSE;
	}
	$s = 0;
	for( $i = 1; $i <= 13; $i += 2 ){
		$c = $cf[$i];
		if( '0' <= $c && $c <= '9' )
			$s += ord($c) - ord('0');
		else
			$s += ord($c) - ord('A');
	}
	for( $i = 0; $i <= 14; $i += 2 ){
		$c = $cf[$i];
		switch( $c ){
		case '0':  $s += 1;  break;
		case '1':  $s += 0;  break;
		case '2':  $s += 5;  break;
		case '3':  $s += 7;  break;
		case '4':  $s += 9;  break;
		case '5':  $s += 13;  break;
		case '6':  $s += 15;  break;
		case '7':  $s += 17;  break;
		case '8':  $s += 19;  break;
		case '9':  $s += 21;  break;
		case 'A':  $s += 1;  break;
		case 'B':  $s += 0;  break;
		case 'C':  $s += 5;  break;
		case 'D':  $s += 7;  break;
		case 'E':  $s += 9;  break;
		case 'F':  $s += 13;  break;
		case 'G':  $s += 15;  break;
		case 'H':  $s += 17;  break;
		case 'I':  $s += 19;  break;
		case 'J':  $s += 21;  break;
		case 'K':  $s += 2;  break;
		case 'L':  $s += 4;  break;
		case 'M':  $s += 18;  break;
		case 'N':  $s += 20;  break;
		case 'O':  $s += 11;  break;
		case 'P':  $s += 3;  break;
		case 'Q':  $s += 6;  break;
		case 'R':  $s += 8;  break;
		case 'S':  $s += 12;  break;
		case 'T':  $s += 14;  break;
		case 'U':  $s += 16;  break;
		case 'V':  $s += 10;  break;
		case 'W':  $s += 22;  break;
		case 'X':  $s += 25;  break;
		case 'Y':  $s += 24;  break;
		case 'Z':  $s += 23;  break;
		}
	}
	if( chr($s%26 + ord('A')) != $cf[15] )
		return FALSE;
	return TRUE;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
# Controllo della Partita I.V.A.
# Linguaggio: PHP 3
function controllaPartitaIVA($pi) {
	if (empty($pi)) {
		return FALSE;
	}
    if( strlen($pi) != 11 ) {
        return FALSE;
    }
    if( ! preg_match("/^[0-9]+$/", $pi) ) {
        return FALSE;
	}
    $s = 0;
    for( $i = 0; $i <= 9; $i += 2 ) {
        $s += ord($pi[$i]) - ord('0');
    }
    for( $i = 1; $i <= 9; $i += 2 ) {
        $c = 2*( ord($pi[$i]) - ord('0') );
        if( $c > 9 )  {
        	$c = $c - 9;
        }
        $s += $c;
    }
    if( ( 10 - $s%10 )%10 != ord($pi[10]) - ord('0') ) { 
    	return FALSE;;
    }
    return TRUE;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function controllaEmail($email) {
	if (empty($email)) {
		return FALSE;
	}
	if (stripos($email, '@') === FALSE) {
		return FALSE;
	}
	if (stripos($email, '.') === FALSE) {
		return FALSE;
	}
	if (substr_count($email, '@') !== 1) {
		return FALSE;
	}
	if( !preg_match('/^[a-zA-Z0-9][_\\.a-zA-Z0-9-]+@([a-zA-Z0-9][0-9A-Za-z-]+\\.)+([a-zA-Z]{2,4})/', $email, $matches) ) {
		return FALSE;
	}
    return TRUE;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function controllaEmail_CHECKDNS($email) {
	if(preg_match('/^\w[-.\w]*@(\w[-._\w]*\.[a-zA-Z]{2,}.*)$/', $email, $matches)) {
    	if(function_exists('checkdnsrr')) {
        	if(checkdnsrr($matches[1] . '.', 'MX')) return true;
            if(checkdnsrr($matches[1] . '.', 'A')) return true;
        }else{
			if(!empty($matches[1])) {
				$recType = "MX";
                exec("nslookup -type=$recType $matches[1]", $result);
                foreach ($result as $line) {
                	if(eregi("^$matches[1]",$line)) {
						return true;
					}
				}
                return false;
			}
            return false;
		}
	}
    return false;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function controllaCampo(&$ret, &$error, $array, $elencoRegole, $nome_campo, $etichetta, $oOggetto, $aCampi, $post) { //TODO: controllare e gestione lingue
	if (ATTIVA_CONTROLLI_FORM_PHP === FALSE) {
		return TRUE;
	}
	
	if (stripos($nome_campo, '[]') !== FALSE) {
		$nome_campo= str_replace('[]','',$nome_campo);
	}
	
	foreach ($elencoRegole as $regola => $valore_regola) {
		$valore_campo = '';
		if (array_key_exists($nome_campo, $array)) {
			if (is_string($array[$nome_campo])) {
				$valore_campo = trim($array[$nome_campo]);
			} else {
				$valore_campo = $array[$nome_campo];
			}
		}
		
		//echo '|campo='.$nome_campo.'|valore campo='.$valore_campo.'|regola='.$regola.'|valore regola='.$valore_regola.'|ret='.$ret.'|<br>';
		switch ($regola) {
			
			case 'required':
				//tolto empty perchè non gestiva lo zero
				//if ($valore_regola && empty($valore_campo)) {
				if ($valore_regola && ($valore_campo == '' || is_null($valore_campo)) ) {
					$ret = FALSE;
					if (stripos($etichetta, '[]') !== FALSE) {
						$etichetta = str_replace('[]', '', $etichetta);
						$etichetta = str_replace('_', ' ', $etichetta);
						$etichetta = str_replace('checkbox', ' ', $etichetta);
					}
					aggiungiMessaggioErrore($error, $etichetta, '&egrave; obbligatorio');
				}
				
			break;

			case 'minlength':
				if (!empty($valore_campo)) {
					if (strlen(utf8_decode($valore_campo)) < (int)$valore_regola) {
						$ret = FALSE;
						aggiungiMessaggioErrore($error, $etichetta, 'deve essere lungo almeno {0} caratteri', $valore_regola);
					}
				}
			break;

			case 'maxlength':
				if (!empty($valore_campo)) {
					if (strlen(utf8_decode($valore_campo)) > (int)$valore_regola) {
						$ret = FALSE;
						aggiungiMessaggioErrore($error, $etichetta, 'non deve essere pi&ugrave; lungo di {0} caratteri', $valore_regola);
					}
				}
			break;
			
			
			case 'exactlength':
				if (!empty($valore_campo)) {
					if (strlen(utf8_decode($valore_campo)) !== (int)$valore_regola) {
						$ret = FALSE;
						aggiungiMessaggioErrore($error, $etichetta, 'deve essere lungo esattamente {0} caratteri', $valore_regola);
					}
				}
			break;

			case 'email':
				if (!empty($valore_campo)) {
					$r = controllaEmail($valore_campo);
					if ($r === FALSE) {
						$ret = FALSE;
						aggiungiMessaggioErrore($error, $etichetta, 'non &grave; un indirizzo email valido');
					}
				}
			break;
			
			case 'codiceFiscale':
				if (!empty($valore_campo)) {
					$r = controllaCodiceFiscale($valore_campo);
					if ($r === FALSE) {
						$ret = FALSE;
						aggiungiMessaggioErrore($error, $etichetta, 'non &grave; un codice fiscale valido');
					}
				}
			break;
			
			case 'partitaIva':
				if (!empty($valore_campo)) {
					$r = controllaPartitaIVA($valore_campo);
					if ($r === FALSE) {
						$ret = FALSE;
						aggiungiMessaggioErrore($error, $etichetta, 'non &grave; una partita IVA valida');
					}
				}
			break;
			
			case 'partitaIvaOrCodiceFiscale':
				if (!empty($valore_campo)) {
					$r = (controllaCodiceFiscale($valore_campo) || controllaPartitaIVA($valore_campo));
					if ($r === FALSE) {
						$ret = FALSE;
						aggiungiMessaggioErrore($error, $etichetta, 'non &grave; una partita IVA valida oppure un codice fiscale valido');
					}
				}
			break;
			
			case 'equalTo':
				if ($valore_campo !== $array[$valore_regola]) {
					$ret = FALSE;
					aggiungiMessaggioErrore($error, $etichetta, 'non coincide al valore del campo <strong>{0}</strong>', $valore_regola);
				}
			break;

			case 'dateTimeISO':
				if (!empty($valore_campo)) {
					$regEx = '/^(\d{2}|\d{4})(?:\-)?([0]{1}\d{1}|[1]{1}[0-2]{1})(?:\-)?([0-2]{1}\d{1}|[3]{1}[0-1]{1})(?:\s)?([0-1]{1}\d{1}|[2]{1}[0-3]{1})(?::)?([0-5]{1}\d{1})(?::)?([0-5]{1}\d{1})?$/';
					if( !preg_match($regEx, $valore_campo, $matches) ) {
						$ret = FALSE;
						aggiungiMessaggioErrore($error, $etichetta, ' deve essere nel formato aaaa-mm-gg hh:mm:ss');
					}
				}
			break;

			case 'dateISO':
				if (!empty($valore_campo)) {
					$regEx = '/^\d{4}[\-\/\s]?((((0[13578])|(1[02]))[\-\/\s]?(([0-2][0-9])|(3[01])))|(((0[469])|(11))[\-\/\s]?(([0-2][0-9])|(30)))|(02[\-\/\s]?[0-2][0-9]))$/';
					if( !preg_match($regEx, $valore_campo, $matches) ) {
						$ret = FALSE;
						aggiungiMessaggioErrore($error, $etichetta, ' deve essere nel formato aaaa-mm-gg');
					}
				}
			break;

			
			case 'integer':
				/*
				if (!empty($valore_campo)) {
					$regEx = '/^[1-9]+[0-9]*$/';
					if( !preg_match($regEx, $valore_campo, $matches) ) {
						$ret = FALSE;
						aggiungiMessaggioErrore($error, $etichetta, ' deve essere un numero intero');
					}
				}
				*/
				//dump($valore_campo);
				if (trim($valore_campo) !== '' && !is_numeric($valore_campo)) {
					$ret = FALSE;
					aggiungiMessaggioErrore($error, $etichetta, ' deve essere un numero intero');
					//dump('son qui');
				}
			break;
			
			case 'univoco':
				if (!empty($valore_campo)) {
					if ($oOggetto->isValoreCampoPresenteDb($nome_campo, $valore_campo)) {
						$ret = FALSE;
						aggiungiMessaggioErrore($error, $etichetta, ' &grave; già presente nel database');
					}
				}
			break;
			
			case 'requiredIF':
				// se il $valore_regola contiene un = vuol dire che 
				// è richiesto solo se il valore del campo controllore è uguale ad un certo valore
				//dump($nome_campo);
				//dump($valore_regola);
				//dump($valore_campo);
				
				if (stripos($valore_regola, '!=') !== FALSE) {
					//echo '1';
					$a = explode('!=', $valore_regola);
					if (stripos($a[1],'|') !== FALSE) {
						$b = explode('|', $a[1]);
					} else {
						$b = array($a[1]);
					}
					if (!in_array($post[$a[0]], $b) && (strlen(trim($valore_campo)) == 0 || $valore_campo == '0')) {
						$ret = FALSE;
						aggiungiMessaggioErrore($error, $etichetta, ' è obbligatorio');
					}
				} elseif (stripos($valore_regola, '=') !== FALSE) {
					//echo '2';
					$a = explode('=', $valore_regola);
					if (stripos($a[1],'|') !== FALSE) {
						$b = explode('|', $a[1]);
					} else {
						$b = array($a[1]);
					}
					//dump($b);
					//dump($a[0]);
					if (in_array($post[$a[0]], $b) && (strlen(trim($valore_campo)) == 0 || $valore_campo == '0')) {
						$ret = FALSE;
						aggiungiMessaggioErrore($error, $etichetta, ' è obbligatorio');
					}
				} else {
					//echo '3';
					if ((bool)$post[$valore_regola] && (strlen(trim($valore_campo)) == 0 || $valore_campo == '0')) {
						$ret = FALSE;
						aggiungiMessaggioErrore($error, $etichetta, ' è obbligatorio');
					}
				}
				//echo '<hr>';
			break;
			
			case 'notCompilableIF':
				// se il $valore_regola contiene un = vuol dire che 
				// è richiesto solo se il valore del campo controllore è uguale ad un certo valore
				/*
				if (stripos($valore_regola, '!=') !== FALSE) {
					$a = explode('!=', $valore_regola);
					if (stripos($a[1],'|') !== FALSE) {
						$b = explode('|', $a[1]);
					} else {
						$b = array($a[1]);
					}
					if (!in_array($post[$a[0]], $b) && strlen(trim($valore_campo)) != 0) {
						$ret = FALSE;
						aggiungiMessaggioErrore($error, $etichetta, ' non deve essere compilato');
					}
				} elseif (stripos($valore_regola, '=') !== FALSE) {
					$a = explode('=', $valore_regola);
					if (stripos($a[1],'|') !== FALSE) {
						$b = explode('|', $a[1]);
					} else {
						$b = array($a[1]);
					}
					if (in_array($post[$a[0]], $b) && strlen(trim($valore_campo)) != 0) {
						$ret = FALSE;
						aggiungiMessaggioErrore($error, $etichetta, ' non deve essere compilato');
					}
				} else {
					if ((bool)$post[$valore_regola] && strlen(trim($valore_campo)) != 0) {
						$ret = FALSE;
						aggiungiMessaggioErrore($error, $etichetta, ' non deve essere compilato');
					}
				}
				*/
				
			break;

			case 'remote':
				TO_IMPLEMENT('controlla campo x remote'); // TODO: regole validazione
			break;
			
			case 'min':
				TO_IMPLEMENT('controlla campo x min'); // TODO: regole validazione
			break;
			
			case 'max':
				TO_IMPLEMENT('controlla campo x max'); // TODO: regole validazione
			break;
			
			case 'range':
				TO_IMPLEMENT('controlla campo x range'); // TODO: regole validazione
			break;
			
			case 'url':
				/* TODO
				if (!empty($valore_campo)) {
					//$regEx = "/^((&quot;|')[a-z0-9\/\.\?\=\&amp;]*(\.htm|\.asp|\.php|\.jsp)[a-z0-9\/\.\?\=\&amp;]*(&quot;|'))|(href=*?[a-z0-9\/\.\?\=\&amp;&quot;']*)$/";
					$regEx = "/^(?:(?:(?:https?|ftp):)?\/\/)(?:\S+(?::\S*)?@)?(?:(?!(?:10|127)(?:\.\d{1,3}){3})(?!(?:169\.254|192\.168)(?:\.\d{1,3}){2})(?!172\.(?:1[6-9]|2\d|3[0-1])(?:\.\d{1,3}){2})(?:[1-9]\d?|1\d\d|2[01]\d|22[0-3])(?:\.(?:1?\d{1,2}|2[0-4]\d|25[0-5])){2}(?:\.(?:[1-9]\d?|1\d\d|2[0-4]\d|25[0-4]))|(?:(?:[a-z\u00a1-\uffff0-9]-*)*[a-z\u00a1-\uffff0-9]+)(?:\.(?:[a-z\u00a1-\uffff0-9]-*)*[a-z\u00a1-\uffff0-9]+)*(?:\.(?:[a-z\u00a1-\uffff]{2,})).?)(?::\d{2,5})?(?:[/?#]\S*)?$/";
					if( !preg_match($regEx, $valore_campo, $matches) ) {
						$ret = FALSE;
						aggiungiMessaggioErrore($error, $etichetta, ' deve essere un URL valido');
					}
				}
				*/
			break;
			
			case 'date':
				TO_IMPLEMENT('controlla campo x date'); // TODO: regole validazione
			break;
			
			case 'number':
				TO_IMPLEMENT('controlla campo x number'); // TODO: regole validazione
			break;

			case 'decimale':
				if (!empty($valore_campo)) {
					//$regEx = '/^-?(?:\d+|\d{1,3}(?:\.\d{3})+)(?:,\d+)?$/';
					$regEx = '/[0-9,]/';
					if( !preg_match($regEx, $valore_campo, $matches) ) {
						$ret = FALSE;
						aggiungiMessaggioErrore($error, $etichetta, ' deve essere nel formato decimale 000000,00');
					}
				}
			break;
			
			case 'digits':
				if ($valore_campo !== '') {
					if( !ctype_digit($valore_campo) ) {
						$ret = FALSE;
						aggiungiMessaggioErrore($error, $etichetta, ' deve essere formato da soli numeri');
					}
				}
			break;

			case 'creditcard':
				TO_IMPLEMENT('controlla campo x creditcard'); // TODO: regole validazione
			break;
			
			case 'accept':
				TO_IMPLEMENT('controlla campo x accept'); // TODO: regole validazione
			break;
			
			case 'rangelength':
				if ($valore_campo !== '') {
					list($min,$max) = explode(',', $valore_regola);
					if (is_array($valore_campo)) {
						$t = count($valore_campo);
					} else {
						$t = $valore_campo;
					}
					if ($t > $max || $t < $min) {
						$ret = FALSE;
						aggiungiMessaggioErrore($error, $etichetta, ' deve essere compreso tra '.$min.' e '.$max);
					} 
				}
			break;				
			
			case 'maxWords':
				TO_IMPLEMENT('controlla campo x maxWords'); // TODO: regole validazione
			break;				
			
			case 'minWords':
				TO_IMPLEMENT('controlla campo x minWords'); // TODO: regole validazione
			break;				
			
			case 'rangeWords':
				TO_IMPLEMENT('controlla campo x rangeWords'); // TODO: regole validazione
			break;				
			
			case 'letterswithbasicpunc':
				TO_IMPLEMENT('controlla campo x letterswithbasicpunc'); // TODO: regole validazione
			break;				
			
			case 'alphanumeric':
				if (!empty($valore_campo)) {
					$regEx = '/^\w+$/i';
					if( !preg_match($regEx, $valore_campo, $matches) ) {
						$ret = FALSE;
						aggiungiMessaggioErrore($error, $etichetta, ' deve essere composto solo da lettere, numeri e underscore (_)');
					}
				}
			break;				
			
			case 'lettersonly':
				TO_IMPLEMENT('controlla campo x lettersonly'); // TODO: regole validazione
			break;				
			
			case 'nowhitespace':
				if (!empty($valore_campo)) {
					$regEx = '/^\S+$/i';
					if( !preg_match($regEx, $valore_campo, $matches) ) {
						$ret = FALSE;
						aggiungiMessaggioErrore($error, $etichetta, ' non deve contenere spazi bianchi');
					}
				}
			break;				
			
			case 'dateITA':
				if (!empty($valore_campo)) {
					$regEx = '/^(0?[1-9]|[12][0-9]|3[01])[\/\-\.](0?[1-9]|1[012])[\/\-\.](\d{4})$/';
					if( !preg_match($regEx, $valore_campo, $matches) ) {
						$ret = FALSE;
						aggiungiMessaggioErrore($error, $etichetta, ' deve essere nel formato gg-mm-aaaa');
					}
				}
			break;		
			
			case 'dateTimeITA':
				if (!empty($valore_campo)) {
					// se mi interessano i secondi gg-mm-aaaa hh:mm:ss
					//$regEx = '/^(0?[1-9]|[12][0-9]|3[01])[\/\-\.](0?[1-9]|1[012])[\/\-\.](\d{4})[\ ](0?[0-9]|1[0-9]|2[0-4])[\:]([0-5])([0-9])[\:]([0])([0])$/';
					// se NON mi interessano i secondi gg-mm-aaaa hh:mm
					$regEx = '/^(0?[1-9]|[12][0-9]|3[01])[\/\-\.](0?[1-9]|1[012])[\/\-\.](\d{4})[\ ](0?[0-9]|1[0-9]|2[0-4])[\:]([0-5])([0-9])$/';
					if( !preg_match($regEx, $valore_campo, $matches) ) {
						$ret = FALSE;
						aggiungiMessaggioErrore($error, $etichetta, ' deve essere nel formato gg-mm-aaaa hh:mm');
					}
				}
			break;
			
			case 'timeITA':
				if (!empty($valore_campo)) {
					// se mi interessano i secondi gg-mm-aaaa hh:mm:ss
					//$regEx = '/^(0?[1-9]|[12][0-9]|3[01])[\/\-\.](0?[1-9]|1[012])[\/\-\.](\d{4})[\ ](0?[0-9]|1[0-9]|2[0-4])[\:]([0-5])([0-9])[\:]([0])([0])$/';
					// se NON mi interessano i secondi gg-mm-aaaa hh:mm
					$regEx = '/^(0?[0-9]|1[0-9]|2[0-4])[\:]([0-5])([0-9])$/';
					if( !preg_match($regEx, $valore_campo, $matches) ) {
						$ret = FALSE;
						aggiungiMessaggioErrore($error, $etichetta, ' deve essere nel formato hh:mm');
					}
				}
			break;
			
			case 'time':
				TO_IMPLEMENT('controlla campo x time'); // TODO: regole validazione
			break;				
			
			case 'time12h':
				TO_IMPLEMENT('controlla campo x time12h'); // TODO: regole validazione
			break;				
			
			case 'ipv4':
                if (!empty($valore_campo)) {
                    // se mi interessano i secondi gg-mm-aaaa hh:mm:ss
                    //$regEx = '/^(0?[1-9]|[12][0-9]|3[01])[\/\-\.](0?[1-9]|1[012])[\/\-\.](\d{4})[\ ](0?[0-9]|1[0-9]|2[0-4])[\:]([0-5])([0-9])[\:]([0])([0])$/';
                    // se NON mi interessano i secondi gg-mm-aaaa hh:mm
                    $regEx = '/^(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/i';
                    if( !preg_match($regEx, $valore_campo, $matches) ) {
                        $ret = FALSE;
                        aggiungiMessaggioErrore($error, $etichetta, ' deve essere nel formato hh:mm');
                    }
                }
			break;
			
			case 'ipv6':
				TO_IMPLEMENT('controlla campo x ipv6'); // TODO: regole validazione
			break;				
			
			default:
				die('<h1>REGOLA NON ESISTENTE => '.$regola.'</h1>');
			break;
		}
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function aggiungiMessaggioErrore(&$error, $etichetta, $messaggio, $valore_regola = '') {
	$chiave = strtoupper($etichetta);
	$msg = str_replace('{0}', $valore_regola, $messaggio);
	if (!array_key_exists($chiave, $error)) {
		$error[$chiave] = $msg;
	} else {
		$valore = $error[$chiave];
		$error[$chiave] = $valore . ' e' . ((in_array(substr($msg, 0, 1), array('a', 'e', 'i', 'o', 'u', '&')))?'d ':' ') . $msg;
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function troncastringa($stringa, $numero_caratteri, $strip_tags = TRUE, $puntini = TRUE) {
	$stringaOriginale = $stringa;
	if ($strip_tags) {
		$stringa = strip_tags($stringa);
	}
	
	if (strlen($stringa) <= $numero_caratteri) {
		return $stringa;
	} else {
		
		$caratteri = min( strlen($stringa) , $numero_caratteri);
		$stringa = substr($stringa, 0, $caratteri);

		$lastChar       = substr($stringa, $caratteri -1, 1);
		$lastCharPiuUno = substr($stringaOriginale, $caratteri, 1);
		// TODO: se l'ultimo carattere della stringa e' uno spazio, 
		//       oppure il carattere alla posizione strlen($stringa) + 1 eè uno spazio va bene cosi
		$stringa = substr($stringa, 0, strrpos($stringa, ' '));
		
		if ($puntini) $stringa = $stringa . '...'; 
		return $stringa;
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function rsort_assoc_array(&$array) {
	$tmpArray = array();
	foreach ($array as $k => $v) {
		$tmpArray[] = array('chiave' => $k, 'valore' => $v);
	}
	$ret = krsort($tmpArray);
	$array = array();
	foreach($tmpArray as $a) {
		$array[$a['chiave']] = $a['valore'];
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function ordinaArrayRicercaByNome(&$array) {
	$tmpArray = array();
	foreach ($array as $a) {
		$tmpArray[$a['nome']] = $a;
	}
	ksort($tmpArray);
	$array = array();
	foreach($tmpArray as $v) {
		$array[] = $v;
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function ordinaArrayAssociativoByChiave(&$array,$chiave) {
	$tmpArray = array();
	foreach ($array as $a) {
		$tmpArray[$a[$chiave]] = $a;
	}
	ksort($tmpArray);
	$array = array();
	foreach($tmpArray as $v) {
		$array[] = $v;
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function emptyDir($dir){
	$fileList = scandir($dir); 
	foreach ($fileList as $file) {
		if (is_file($dir . '/' . $file)) {
			unlink($dir . '/' . $file);
		}
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function now() {
	return date('Y-m-d H:i:s');
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function oggi() {
	return date('Y-m-d');
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function formatBytes($b,$p = null) {
    /**
     *
     * @author Martin Sweeny
     * @version 2010.0617
     *
     * returns formatted number of bytes.
     * two parameters: the bytes and the precision (optional).
     * if no precision is set, function will determine clean
     * result automatically.
     *
     **/
    $units = array("B","KB","MB","GB","TB","PB","EB","ZB","YB");
    $c=0;
	if (empty($b)) return 'n.d.';
    if(!$p && $p !== 0) {
        foreach($units as $k => $u) {
            if(($b / pow(1024,$k)) >= 1) {
                $r["bytes"] = $b / pow(1024,$k);
                $r["units"] = $u;
                $c++;
            }
        }
        return number_format($r["bytes"],2) . " " . $r["units"];
    } else {
        return number_format($b / pow(1024,$p)) . " " . $units[$p];
    }
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function _isEmailOK($email){
	if (preg_match("^[a-z0-9._-]+\@[a-z0-9._-]+\.[a-z0-9]{2,4}$/i", $email) == 1)
		return true;
	else
		return false;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
function forceDownload($file, $nome) {
	/**
	 * Function forceDownload:
	 *	download any type of file if it exists and is readable
	 * -------------------------------------
	 * @author		Andrea Giammarchi
	 * @date		18/01/2005 [17/05/2006]
	 * @compatibility	PHP >= 4.3.0
	 */
	if(file_exists($file) && is_readable($file)) {
		$filename = basename($file);
		if(strpos(strtoupper($_SERVER['HTTP_USER_AGENT']), 'MSIE') !== false && strpos($filename, '.') !== false) {
			$parsename = explode('.', $filename);
			$last = count($parsename) - 1;
			$filename = implode('%2E', array_slice($parsename, 0, $last));
			$filename .= '.'.$parsename[$last];
		}
		
		$ext = strtolower(pathinfo($filename, PATHINFO_EXTENSION));
		
		switch($ext){
		
			case 'jpg':
			case 'jpeg':
				header('Content-Description: File Transfer');
				header('Content-Type: application/octet-stream');
				header('Content-Disposition: attachment; filename="'.$nome.'"');
				header('Content-Transfer-Encoding: binary');
				header('Expires: 0');
				header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
				header('Pragma: public');
				header('Content-Length: ' . filesize($file));
				ob_clean();
				flush();
				readfile($file);
			break;

			case 'pdf':
				header("Pragma: public"); 
				header('Content-type: application/pdf');
				header('Content-Disposition: attachment; filename="'.$nome.'"');
				header('Content-Transfer-Encoding: binary'); 
				ob_clean();
				flush();
				readfile($file); 
			break;
			
			case 'doc':
				header("Pragma: public"); 
				header('Content-type: application/msword');
				header('Content-Disposition: attachment; filename="'.$nome.'"');
				header('Content-Transfer-Encoding: binary'); 
				ob_clean();
				flush();
				readfile($file);
			break;
			
			case 'docx':
				header("Pragma: public"); 
				header('Content-type: application/vnd.openxmlformats-officedocument.wordprocessingml.document');
				header('Content-Disposition: attachment; filename="'.$nome.'"');
				header('Content-Transfer-Encoding: binary'); 
				ob_clean();
				flush();
				readfile($file); 
			break;
			
			case 'odt':
				header("Pragma: public"); 
				header('Content-type: application/vnd.oasis.opendocument.text');
				header('Content-Disposition: attachment; filename="'.$nome.'"');
				header('Content-Transfer-Encoding: binary'); 
				ob_clean();
				flush();
				readfile($file); 
			break;
			
			case 'xls':
				header("Pragma: public"); 
				header('Content-type: application/vnd.ms-excel');
				header('Content-Disposition: attachment; filename="'.$nome.'"');
				header('Content-Transfer-Encoding: binary'); 
				ob_clean();
				flush();
				readfile($file); 
			break;
			
			case 'xlsx':
				header("Pragma: public"); 
				header('Content-type: application/vnd.openxmlformats-officedocument.spreadsheetml.template');
				header('Content-Disposition: attachment; filename="'.$nome.'"');
				header('Content-Transfer-Encoding: binary'); 
				ob_clean();
				flush();
				readfile($file); 
			break;
			
			default:
				$content_type = 'application/octet-stream';
		}
		
		//echo $content_type;
		
		//die;
		/*
		header('Content-Type: '.$content_type);
		header('Content-Disposition: attachment; filename="'.$nome.'"');
		header('Content-Length:'.filesize($file));
		header('Content-Transfer-Encoding: binary');
		if(@$file = fopen($file, "rb")) {
			while(!feof($file))
				echo fread($file, 8192);
			fclose($file);
		}
		exit(0);
		*/
	}
}
/*********************************************************************************************************/
// METHOD: formatta_float_db($num)
// formatta un numero decimale per essere accettato dal database
/*********************************************************************************************************/
function formatta_float_db($num){
  if (empty($num)){
  	$num = 0;
  }
  $num = str_replace(",", ".", $num);
  $eu = number_format($num, 2, '.', '');
  return $eu ;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function getDataFromCUrl($url) {
	$ch = curl_init();
	$timeout = 5;
	//echo $url.'<br><br>';
	curl_setopt($ch,CURLOPT_URL,$url);
	curl_setopt($ch,CURLOPT_RETURNTRANSFER,1);
	curl_setopt($ch,CURLOPT_CONNECTTIMEOUT,$timeout);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false); //to make it support SSL calls on some servers
	$data = curl_exec($ch);
	curl_close($ch);
	return $data;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function object_to_array($obj) {
	$arr = array();
	$arrObj = is_object($obj) ? get_object_vars($obj) : $obj;
	if (is_array($arrObj)) {
		foreach ($arrObj as $key => $val) {
			$val = (is_array($val) || is_object($val)) ? object_to_array($val) : $val;
			$arr[$key] = $val;
		}
	}
    return $arr;
}  
/*********************************************************************************************************/
/*********************************************************************************************************/
function obj2array($object) {
    $reflectionClass = new ReflectionClass(get_class($object));
    $array = array();
    foreach ($reflectionClass->getProperties() as $property) {
        $property->setAccessible(true);
        $array[$property->getName()] = $property->getValue($object);
        $property->setAccessible(false);
    }
    return $array;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function in_array_recursive($needle, $haystack) {
    $it = new RecursiveIteratorIterator(new RecursiveArrayIterator($haystack));
    foreach($it AS $element) {
        if($element == $needle) {
            return true;
        }
    }
    return false;
} 
/*********************************************************************************************************/
/*********************************************************************************************************/
function uriDaStringa($uri) {
    // elimino caratteri speciali che non servono
    //$caratteri_speciali_da_eliminare = Array('/+/', '/./', '/,/', '/(/', '/)/', '/;/', '/:/', '/?/', '/!/', '/@/', '/#/', '/^/', '/|/', '/"/', '/£/', '/', '/>/', '/°/', '/§/');
    //$caratteri_speciali_da_sostituire = Array('', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '');
    //$uri = preg_replace($caratteri_speciali_da_eliminare, $caratteri_speciali_da_sostituire, $uri);
    // converto i caratteri speciali che possono essere convertiti in parola
    $uri = preg_replace("/&/","e",$uri);
    $uri = preg_replace("/€/","euro",$uri);
    //elimino eventuali spazi all'inizio e alla fine della stringa
    $uri = trim($uri);
    // converto in entità tutti i caratteri (in modo da non avere più accenti)
    $uri = htmlentities(utf8_decode($uri));
    // converto tutti i caratteri accentati i lettere non accentate
    $uri = preg_replace("/&(.)(acute|cedil|circ|ring|tilde|uml|grave|lig);/", "$1", $uri);
    // permetto solo lettere, numeri e -
    $uri = preg_replace("/[^A-Za-z0-9\/]+/", "-",$uri);
    // passo tutto in lowercase
    $uri = strtolower($uri); 
    return $uri;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function array2table($array, $id) {
	if (is_array($array) && !empty($array)) {
	
		echo '<table class="table table-striped responsive table-hover '.STYLE_TABLE_STRIPED.'" id="tabella_'.$id.'">';
		echo '<thead>';
		$chiavi = array_keys($array[0]);
		echo '<tr>';
		echo '<th>#</th>';
		foreach($chiavi as $k2 => $item) {
			echo "<th>".strtoupper(str_replace('_',' ',$item))."</th>";
		}
		echo '</tr>';
		echo '</thead>';
		echo '<tbody>';
		foreach($array as $k => $arrs) {
			echo '<tr>';
			echo '<td>'.($k+1).'</td>';
			foreach($arrs as $k2 => $item) {
				echo "<td>".$item."</td>";
			}
			echo '</tr>';
		}
		echo '</tbody>';
		echo '</table>';
	} else {
		echo 'non &egrave; un array';
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function creaCartella($path) {
	$aDir = explode('/', $path);
	$strDir = '';
	foreach($aDir as $dir) {
		if (!empty($dir)) {
			if (stripos(strtolower(php_uname()),'windows') !== FALSE) {
				$strDir .= $dir.'/'; // SU WINDOWS
			} else {
				$strDir .= '/'.$dir;  // SU LINUX
			}
			if (!is_dir($strDir)) {
				dump($strDir);
				mkdir($strDir, 0777);
				chmod($strDir, 0777);
			}
		}
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function encodaNomeFile($nomeFile) {
	$ext  = strtolower(substr($nomeFile, strrpos($nomeFile, '.')));
	$nome = sha1(date('Y-m-d H:i:s:u').$nomeFile).$ext;
	return array($nome, $ext);
}
/**********************************************************************************
* METHOD: getYoutubeId($ytURL)
* 
***********************************************************************************/
function getYoutubeId($ytURL){  
	$url = parse_url($ytURL, PHP_URL_QUERY);  
	parse_str($url, $arr);  
	return isset($arr['v']) ? $arr['v'] : FALSE;  
}  

/**********************************************************************************
* METHOD: checkYoutubeId($youtubeId)
* 
***********************************************************************************/
function checkYoutubeId($youtubeId){
	if (empty($youtubeId)) return FALSE; 
	
	$checklink = 'http://gdata.youtube.com/feeds/api/videos/' . $youtubeId;

    //** curl the check link ***//
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL,$checklink);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
    curl_setopt($ch, CURLOPT_TIMEOUT, 5);
    $result = curl_exec($ch);
    curl_close($ch);

    if(trim($result)=="Invalid id"){
    	return FALSE;
    }
    else{
    	return TRUE;
    }

}
/*********************************************************************************************************/
/*********************************************************************************************************/
function float2frazione($f) {
  $base = floor($f);
  $out = '0';
  if ($base) {
    $out = $base . ' ';
    $f = $f - $base;
  }
  if ($f != 0) {
    $d = 1;
    while (fmod($f, 1) != 0.0) {
      $f *= 2;
      $d *= 2;
    }
    $n = sprintf('%.0f', $f);
    $d = sprintf('%.0f', $d);
    $out .= $n . '/' . $d;
  }
  return $out;
}
/**********************************************************************************
* FUNCTION: explain($var)
* 
***********************************************************************************/
function explain($var){

	print "<div align='left'><pre align=left>";
	var_dump($var);
	print "</pre></div>";
}
/*******************************************************************************
* FUNCTION: rimuoviUltimoCarattere($str)
* funzione per rimuovere l'ultimo carattere di una stringa
* Input : stringa
*******************************************************************************/
function rimuoviUltimoCarattere($str){
	return substr($str, 0, strlen($str)-1);
} 

/*******************************************************************************
* FUNCTION: rimuoviUltimiCaratteri($str,$n)
* funzione per rimuovere gli ultimi n caratteri di una stringa
* Input : stringa
*******************************************************************************/
function rimuoviUltimiCaratteri($str,$n){
	return substr($str, 0, strlen($str)-$n);
} 


/**********************************************************************************
* FUNCTION: 
* Riceve in ingresso un array di estensioni ammesse e le trasforma in una stringa 
* del tipo '*.jpj,*.gif,*.png'. Questa è la forma che viene data al js dell'uploadfive
***********************************************************************************/
function getStrImmaginiEstensioniAmmesse($aEstensioniAmmesse){
	//explain($aEstensioniAmmesse);
	
	$ret = '';
	if (is_array($aEstensioniAmmesse)){
		foreach ($aEstensioniAmmesse as &$value) {
			$ret .= '*.'.$value.';';
		}
		$ret = rimuoviUltimiCaratteri($ret,1);
		
	}
	   
	return $ret;
}
/*********************************************************************************************************
* FUNCTION: 
* Riceve in ingresso un array di estensioni ammesse e le trasforma in una stringa 
* del tipo '*.jpj,*.gif,*.png'. Questa è la forma che viene data al js dell'uploadfive
/*********************************************************************************************************/
function decodificaCampoBoolean($valore) {
	if(is_null($valore)){
		return '';
	}
	else{
		if(intval($valore) === 1){
			return 'Si';
		}
		else{
			return 'No';
		}
	}
}
/*********************************************************************************************************
* FUNCTION: getGeoByAddress($indirizzo)
* recupera le coodinate geografiche di un indirizzo
/*********************************************************************************************************/
function getGeoByAddress($indirizzo){

	$coordinate = array();

	$base_url = "http://" . MAPS_HOST . "/maps/api/geocode/xml";
			
	$request_url = $base_url . "?address=" . urlencode($indirizzo)."&sensor=false";
	
	$ch = curl_init($request_url);
	curl_setopt($ch, CURLOPT_HEADER, false);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	$xml_raw = curl_exec($ch);
	$xml = simplexml_load_string($xml_raw);
	
	$status = $xml->status;
	
	if (strcmp($status, "OK") == 0) {
		// Successful geocode
		$coordinate[0] = $xml->result->geometry->location->lat;
		$coordinate[1] = $xml->result->geometry->location->lng;
	}
	else{
		$coordinate[0] = '';
		$coordinate[1] = '';
	}
	
	return $coordinate;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function hex2rgb($hex) {
   $hex = str_replace("#", "", $hex);

   if(strlen($hex) == 3) {
      $r = hexdec(substr($hex,0,1).substr($hex,0,1));
      $g = hexdec(substr($hex,1,1).substr($hex,1,1));
      $b = hexdec(substr($hex,2,1).substr($hex,2,1));
   } else {
      $r = hexdec(substr($hex,0,2));
      $g = hexdec(substr($hex,2,2));
      $b = hexdec(substr($hex,4,2));
   }
   $rgb = array($r, $g, $b);
   //return implode(",", $rgb); // returns the rgb values separated by commas
   return $rgb; // returns an array with the rgb values
}
/*******************************************************************************
* FUNCTION: writeHTMLDate($date)
* 
*******************************************************************************/
function writeHTMLDate($date){

	if(!empty($date)){
		if($date != '0000-00-00 00:00:00'){
			$formattedDate = date('d-m-Y',strtotime($date));
		}
		else{
			$formattedDate = '';
		}
	}
	else{
		$formattedDate = '';
	}

	return $formattedDate;
}

/*******************************************************************************
* FUNCTION: writeHTMLDateWithTime($date)
* 
*******************************************************************************/
function writeHTMLDateWithTime($date){

	if(!empty($date)){
		if($date != '0000-00-00 00:00:00'){
			$formattedDate = date('d-m-Y H:i',strtotime($date));
		}
		else{
			$formattedDate = '';
		}
	}
	else{
		$formattedDate = '';
	}

	return $formattedDate;
}

/*******************************************************************************
* FUNCTION: writeHTMLTime($date)
* 
*******************************************************************************/
function writeHTMLTime($date){

	if(!empty($date)){
		if($date != '0000-00-00 00:00:00'){
			$formattedDate = date('H:i',strtotime($date));
		}
		else{
			$formattedDate = '';
		}
	}
	else{
		$formattedDate = '';
	}

	return $formattedDate;
}
/**********************************************************************************
* METHOD: curPageURL()
* 
***********************************************************************************/
function curPageURL() {
	$pageURL = 'http';
	if(isset($_SERVER["HTTPS"])){
		if ($_SERVER["HTTPS"] == "on") {$pageURL .= "s";}
	}
	$pageURL .= "://";
	if ($_SERVER["SERVER_PORT"] != "80") {
	$pageURL .= $_SERVER["SERVER_NAME"].":".$_SERVER["SERVER_PORT"].$_SERVER["REQUEST_URI"];
	} else {
	$pageURL .= $_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];
	}
	return $pageURL;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function getRandomBoolean() {
	return .01 * rand(0, 100) >= .5;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function getIpVisitatore(){
    return $_SERVER['REMOTE_ADDR'];
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function ripulisciStringaXml($str) {
	//per prima cosa ripulisco il titolo da caratteri strani per evitare problemi nel JSON
	$str = trim($str);

	$str = preg_replace("/\s+/", " ", $str);
	
	// elimino tutti i caratteri ASCCI "strani"
	// http://www.oppo.it/tabelle/tabella_ascii.htm
	$str = str_replace ( array(chr(0),chr(1),chr(2),chr(3),chr(4),chr(5),chr(6),chr(7),chr(8),chr(9),chr(10),chr(11),chr(12),chr(13),chr(14),chr(15),chr(16),chr(17),chr(18),chr(19),chr(20),chr(21),chr(22),chr(23),chr(24),chr(25),chr(26),chr(27),chr(28),chr(29),chr(30),chr(31),chr(127),chr(128),chr(145),chr(146),chr(155),chr(157),chr(158),chr(159),chr(166),chr(167),chr(168),chr(169),chr(170),chr(171),chr(172),chr(173),chr(174),chr(175),chr(176),chr(177),chr(178),chr(179),chr(180),chr(184),chr(185),chr(186),chr(187),chr(188),chr(189),chr(190),chr(191),chr(192),chr(193),chr(194),chr(195),chr(196),chr(197),chr(200),chr(201),chr(202),chr(203),chr(204),chr(205),chr(206),chr(207),chr(208),chr(209),chr(213),chr(217),chr(218),chr(219),chr(220),chr(221),chr(222),chr(223),chr(225),chr(230),chr(231),chr(232),chr(236),chr(237),chr(238),chr(239),chr(240),chr(241),chr(242),chr(243),chr(244),chr(245),chr(246),chr(247),chr(249),chr(250),chr(251),chr(252),chr(253),chr(254),chr(255)), '', $str); 
	
	// matches anything in ASCII range 0-31, 128-255 and removes it.
	//$str = preg_replace('/[\x00-\x1F\x80-\xFF]/', '', $str);
	return $str;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function encodaTipologiaImmobilePerGiornale($tipologia) {
	switch (strtolower($tipologia)) {
		case 'appartamento':
		case 'bilocale':
		case 'monolocale':
		case 'trilocale':
		case 'attico':
		case 'maisonette':
		case 'duplex':
			return 'appartamenti';
			break;
			
		case 'rustico':
		case 'terreno industriale':
		case 'terreno agricolo':
		case 'terreno edificabile':
			return 'rustici, terreni edificabili';
			break;
		
		case 'villa':
		case 'villetta a schiera':
		case 'casa a schiera':
		case 'casa singola':
		case 'baita':
			return 'ville e case a schiera';
			break;

		case 'bifamiliare':
		case 'porzioni di casa':
		case 'porzione di bifamiliare':
			return 'porzioni di casa';
			break;

		case 'garage':
			return 'garage';
			break;

		case 'stabile - edificio':
			return 'stabile - edificio';
			break;

		case 'capannone':
		case 'stabile - palazzo':
		case 'laboratorio':
		case 'magazzino':
		case 'negozio':
		case 'ufficio':
		case 'attivita\' commerciale':
		case 'licenza commerciale':
		case 'garage - parcheggio':
		case 'albergo - hotel':
		case 'bar':
		case 'ristorante':
		case 'supermercato':
		case 'azienda agricola':
		case 'stabilimento balneare':
			return 'commerciale';
			break;
			
		default:
			return strtolower($tipologia);
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function getOrdineTipologiaImmobilePerGiornale() {
	return array('appartamenti','rustici, terreni edificabili','ville e case a schiera','porzioni di casa','garage','stabile - edificio','commerciale');
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function getMeseItaliano($mese=''){
	switch($mese){
		case 1 : return 'Gennaio';
		case 2 : return 'Febbraio';
		case 3 : return 'Marzo';
		case 4 : return 'Aprile';
		case 5 : return 'Maggio';
		case 6 : return 'Giugno';
		case 7 : return 'Luglio';
		case 8 : return 'Agosto';
		case 9 : return 'Settembre';
		case 10 : return 'Ottobre';
		case 11 : return 'Novembre';
		case 11 : return 'Dicembre';
		default: return false;
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function trim_value(&$value) { 
    $value = trim($value, " \t\n\r\0\x0B\x00..\x1F"); 
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function de_null(&$value) { 
    if (is_null($value)) $value = '';
    if ($value == 'NULL') $value = '';
	return $value;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function isDataDaSaltare($oDataInizio) {
	$d = $oDataInizio->format('m-d');
	if ($d == '01-01') return TRUE;  // capodanno
	if ($d == '01-06') return TRUE;  // epifania
	if ($d == '04-25') return TRUE;  // 25 aprile
	if ($d == '05-01') return TRUE;  // 1� maggio
	if ($d == '06-02') return TRUE;  // festa della repubblica
	if ($d == '08-15') return TRUE;  // ferragosto
	if ($d == '11-02') return TRUE;  // ognisanti
	if ($d == '12-08') return TRUE;  // immacolata
	if ($d == '12-25') return TRUE;  // Natale
	if ($d == '12-26') return TRUE;  // Santo Stefano
	if (isPasqua($oDataInizio)) return TRUE;  // Pasqua
	//if (isPasquetta($oDataInizio)) return TRUE;  // pasquetta
	
	return FALSE;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function isPasqua($oDataTime) {
    return ($oDataTime->format('Y-m-d') == date('Y-m-d', easter_days($oDataTime->format('Y'))));
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function isPasquetta($oData) {
	$oDataTime = clone $oData;
	$oDataTime->modify('-1 days');	
	dump('****'.$oDataTime->format('Y-m-d'));
    return ($oDataTime->format('Y-m-d') == date('Y-m-d', easter_days($oDataTime->format('Y'))));
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function getIdAnnualitaAttiva(&$oDb) {
	$id = (int)$oDb->eseguiselect('SELECT id_annualita FROM annualita WHERE id_status='.STATUS_ATTIVO.' ORDER BY anno LIMIT 1', CLASS_DB_SELECT_MODE_SINGLE_VALUE);
	return (($id > 0)?$id:FALSE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function getIdCooperativaAttiva(&$oDb) {
	$id = (int)$oDb->eseguiselect('SELECT id_agenzia FROM agenzie WHERE id_agenzia != '.ID_AGENZIA_SEDE_CENTRALE.' AND id_status='.STATUS_ATTIVO.' LIMIT 1', CLASS_DB_SELECT_MODE_SINGLE_VALUE);
	return (($id > 0)?$id:FALSE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function checkControlloNonConformita(&$oApp, $anno) {
	$sql = 'SELECT count(*) FROM appuntamenti AS a INNER JOIN casi AS b ON a.id_caso= b.id_caso WHERE id_tipo_caso='.TIPO_CASO_ADM.' AND a.id_status IN ('.STATUS_NON_CONFORME.','.STATUS_ATTIVO.') AND YEAR(datatime_fine)='.num2Str($anno).' AND datatime_fine < SYSDATE()';
	$n = (int) $oApp->get('oDb')->eseguiselect($sql, CLASS_DB_SELECT_MODE_SINGLE_VALUE);
	return ($n > 0); 	
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function checkReport($anno, $tipo, &$oDb) {
	return ($oDb->eseguiselect('SELECT count(*) FROM budget_dati WHERE tipo='.stripcslashesandquote($tipo).' AND anno='.num2Str($anno), CLASS_DB_SELECT_MODE_SINGLE_VALUE) > 0);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function getTipoAppuntamentoById(&$oApp, $id_tipo) {
	return $oApp->get('oDb')->eseguiselect('SELECT '.$_SESSION['LINGUA_NAVIGAZIONE'].' FROM appuntamenti_tipo WHERE id='.num2Str($id_tipo), CLASS_DB_SELECT_MODE_SINGLE_VALUE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function binaryImages($imgSrc,$width = null,$height = null){
    $img_src = $imgSrc;
    $imgbinary = fread(fopen($img_src, "r"), filesize($img_src));
    $img_str = base64_encode($imgbinary);

    if(isset($height) && isset($width)) {
    	echo '<img src="data:image/jpg;base64,'.$img_str.'" height="'.$height.'" width="'.$width.'"/>';
    } else {
    	echo '<img src="data:image/jpg;base64,'.$img_str.'"/>';
    }
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function prefered_language(array $available_languages, $http_accept_language) {

    $available_languages = array_flip($available_languages);

    $langs;
    preg_match_all('~([\w-]+)(?:[^,\d]+([\d.]+))?~', strtolower($http_accept_language), $matches, PREG_SET_ORDER);
    foreach($matches as $match) {

        list($a, $b) = explode('-', $match[1]) + array('', '');
        $value = isset($match[2]) ? (float) $match[2] : 1.0;

        if(isset($available_languages[$match[1]])) {
            $langs[$match[1]] = $value;
            continue;
        }

        if(isset($available_languages[$a])) {
            $langs[$a] = $value - 0.1;
        }

    }
    arsort($langs);

    return $langs;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function isNotSpider($useragent, &$oDb) {
	$sql = 'SELECT count(*) FROM bot_user_agent_list WHERE user_agent = '.stripcslashesandquote($useragent);
	$isBot = (bool)$oDb->eseguiselect($sql, CLASS_DB_SELECT_MODE_SINGLE_VALUE);
	return !$isBot;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
?>