<?php
/*********************************************************************************************************/
/*********************************************************************************************************/
function _form_field(&$oOggetto, $aCampi, $tipo_form, $nome_form_corrente = FALSE, $stampa_solo_input_senza_label_e_div = FALSE, $spanFieldset = 'col-xl-12', $accodaScript = TRUE) {
	extract($aCampi);
	
	$retVal = '';
	
	//************************************************************************
	if (!isset($enabled)) {
		$enabled = TRUE;
	}
	
	$value = '';
	
	if (!isset($attributo)) {
		$attributo = $nome_campo;
	}
	
	if (!isset($campo_controllo) || !(bool)$campo_controllo) {
		$value = $oOggetto->get($attributo);
	}
	
	$aSelect = array();
	if (!empty($valori_select)) {
		$aSelect = $oOggetto->$valori_select();
	}
	else{
		//CODICE PER EVITARE CHE IN MODIFICA NON SI COMPILINO CORRETTAMENTE LE SELECT COLLEGATE TRA DI LORO
		if ($tipo_form == 'Modifica') {
			if(strpos($attributo, 'id_comune') !== false ){
				$campo_provincia = str_replace('id_comune' , 'id_provincia' , $attributo);
				$value_provincia = $oOggetto->get($campo_provincia);
				if(is_numeric($value_provincia)){
					$aSelect = $oOggetto->getArrayComuniByIdProvincia($value_provincia);
				}
			}
			
			if (stripos($attributo, 'id_zone_blocco') !== FALSE) {
				$campo_comune = str_replace('id_zone_blocco_' , '' , $attributo);
				switch ($campo_comune) {
					case 'uno':
						$campo_comune = 'id_comune1';
						break;
					case 'due':
						$campo_comune = 'id_comune2';
						break;
					case 'tre':
						$campo_comune = 'id_comune3';
						break;
					case 'quattro':
						$campo_comune = 'id_comune4';
						break;
					case 'cinque':
						$campo_comune = 'id_comune5';
						break;
					case 'sei':
						$campo_comune = 'id_comune6';
						break;
				}
				$value_comune = $oOggetto->get($campo_comune);
				if(is_numeric($value_comune)){
					$aSelect = $oOggetto->getArrayZoneByIdComune($value_comune);
				}
			} elseif(strpos($attributo, 'id_zona') !== false ){
				$campo_comune = str_replace('id_zona' , 'id_comune' , $attributo);
				$value_comune = $oOggetto->get($campo_comune);
				if(is_numeric($value_comune)){
					$aSelect = $oOggetto->getArrayZoneByIdComune($value_comune);
				}
			}

			if ($oOggetto instanceof relay) {
                if(strpos($attributo, 'id_dispositivo_origine') !== false ) {
                    $aSelect = $oOggetto->getArrayElencoDispositiviByIdSupervisore($oOggetto->get('id_supervisore_origine'), 'origine');
                }
                if(strpos($attributo, 'id_sotto_tipo_dispositivo_origine') !== false ) {
                    $aSelect = $oOggetto->getArrayElencoSottoTipoDispositiviByIdTipoDispositivo($oOggetto->get('oDispositivoOrigine')->get('id_tipo_dispositivo'));
                }
                if(strpos($attributo, 'id_dispositivo_destinazione') !== false ) {
                    $aSelect = $oOggetto->getArrayElencoDispositiviByIdSupervisore($oOggetto->get('id_supervisore_destinazione'), 'destinazione');
                }
                if(strpos($attributo, 'id_sotto_tipo_dispositivo_destinazione') !== false ) {
                    $aSelect = $oOggetto->getArrayElencoSottoTipoDispositiviByIdTipoDispositivo($oOggetto->get('oDispositivoDestinazione')->get('id_tipo_dispositivo'));
                }
            }
		}
	}
	
	if (!empty($_SESSION['$_POST'])) {
		if (!empty($_SESSION['$_POST'][$nome_campo])) {
			$value = $_SESSION['$_POST'][$nome_campo];
		}
	}
	$req = '';
	
	if (empty($value) && !empty($valore_default) && ($tipo_form == 'Inserisci' || (stripos($nome_form, 'FASE_') !== FALSE))) {
		switch($valore_default){
			case 'data_corrente':
				$value = date('d-m-Y');
			break;
			case 'data_ora_corrente':
				$value = date('d-m-Y H:i');
			break;
			case 'ora_corrente':
				$value = date('H:i');
			break;
			default:
				$value = $valore_default;
		}
	}
	
	if ($nome_campo == 'nome_form') $value = $nome_form_corrente;
	
	//************************************************************************
	// stampo la label
	if ($tipo_campo !== 'hidden' && $etichetta != -1 && !$stampa_solo_input_senza_label_e_div && stripos($style,'no-label') === FALSE ) {
		if (!isset($etichetta) || is_null($etichetta)) {
			$etichetta = strtoupper('FORM - '.$nome_form.' - '.$nome_campo);
		} 
		if ((bool)$val_required && $tipo_form != 'visualizza') $req = '<span class="req">*</span>';
		$etic = $oOggetto->get('oApp')->getEtichetta($etichetta);
		$retVal .=  '<label class="control-label" for="' . $nome_campo . '">'.((!empty($icona))?'<i class="'.$icona.'"></i>':'').$etic.$req.'</label>';
	}
	
	if (!$stampa_solo_input_senza_label_e_div) $retVal .= '<div class="controls'.(($tipo_campo == 'hidden')?' hidden':'').((stripos($style,'no-label') !== FALSE)?' no-label':'').'">';

    if (!is_null($campo_collegato)) {
        $aCampoCollegato = getSingoloCampoDb($oOggetto->get('oDb'), $campo_collegato);
    }

	switch ($tipo_campo) {
		case 'solo_visualizzazione':
			$retVal .= '<strong>'.$value.'</strong>';
		break;
		
		case 'etichetta':
			$retVal .=  '<strong>'.$value.'</strong>';
			$retVal .=  '<input class="hidden-input" type="hidden" name="' . $nome_campo . '" id="' . $nome_campo . '" value="'.$value.'">';
		break;

		case 'etichetta_id':
			$retVal .=  '<strong>'.$value.'</strong>';
			$retVal .=  '<input class="hidden-input" type="hidden" name="' . $nome_campo . '" id="' . $nome_campo . '" value="'.$value.'">';
		break;
		
		case 'hidden':
			$retVal .=  '<input class="hidden-input" type="hidden" name="' . $nome_campo . '" id="' . $nome_campo . '" value="'.$value.'">';
			
			if ($nome_campo == $oOggetto->getNomeAttributoId()) {
				$retVal .=  '<input class="hidden-input" type="hidden" name="' . $nome_campo . '_get_encoded" id="' . $nome_campo . '_get_encoded" value="'.writeGetParam($value).'">';
				$retVal .=  '<input class="hidden-input" type="hidden" name="' . $nome_campo . '_post_encoded" id="' . $nome_campo . '_post_encoded" value="'.writePostParam($value).'">';
				$retVal .=  '<input class="hidden-input" type="hidden" name="id_oggetto_get_encoded" id="id_oggetto_get_encoded" value="'.writeGetParam($value).'">';
				$retVal .=  '<input class="hidden-input" type="hidden" name="id_oggetto_post_encoded" id="id_oggetto_post_encoded" value="'.writePostParam($value).'">';
				$retVal .=  '<input class="hidden-input" type="hidden" name="oggetto" id="oggetto" value="'.$oOggetto->get('classe').'">';
			}
		break;
		
		case 'submit':
			$retVal .=  '<input class="'.$class.'" type="submit" name="' . $nome_campo . '" id="' . $nome_campo . '" value="'.$value.'">';
		break;
		
		case 'button':
			$retVal .=  '<input class="'.$class.'" type="button" name="' . $nome_campo . '" id="' . $nome_campo . '" value="'.$value.'">';
		break;
		
		case 'text':
			$retVal .=  '<input type="text" autocomplete="off" name="' . $nome_campo . '" id="' . $nome_campo . '" value="'; 
			$retVal .=  $value;
			$retVal .=  '" ' . ((!$enabled)?' disabled="disabled"':'') . ((!empty($style))?' class="'.$style.'"':'') . ((is_numeric($val_maxlength))?' maxlength="'.$val_maxlength.'"':'') . '>';
		break;
		
		case 'upload':
			$retVal .=  '<input class="file" name="' . $nome_campo . '" id="' . $nome_campo . '" type="file"'.(($upload_multiple)?' multiple':'').' />'; 
			
			ob_start();
			if ($oOggetto->get('classe') == 'fase') {
				if (in_array($nome_campo, unserialize(CAMPI_ALLEGATI_FASI))) {
					$eN = $oOggetto->caricaPerCampo($nome_campo);
					if (!$eN->isEmpty()) {
						$eN->setNomeElenco('elenco_documenti');
						$aCampi = array();
						//$aCampi[] = 'titolo';
						$aCampi[] = 'nome_file_originale';
						$aCampi[] = 'dimensione_file_formattato';
						$aCampi[] = 'nominativo_utente_proprietario';
						$aCampi[] = 'data_creazione_ita';
						$aCampi[] = 'preview';
						if (!$oOggetto->getOCandidatura()->isBloccata() && !$oOggetto->getOCandidatura()->isConclusa() && !$oOggetto->getOCandidatura()->isEliminata()) $aCampi[] = 'elimina';
						$eN->setCampiInteresse($aCampi);
						$eN->stampa('tabella', STYLE_TABLE_HOVER);
					} 
				}
			}
			$retVal .= ob_get_contents();
			ob_end_clean();
			//$retVal .=  '<div class="space"></div>';
			//$retVal .=  '<input class="file-no-style" id="fileInput2" type="file" />';
		break;
		
		case 'datepicker':
			/*
			if ((empty($value) || $value == '0000-00-00' || $value == '0000-00-00 00:00:00' || $value == '00-00-0000') && !is_null($valore_default)) {
				$value = $valore_default;
			} elseif (empty($value)) {
				$value = date('Y-m-d');
			}
			*/
			if ((empty($value) || $value == '0000-00-00' || $value == '0000-00-00 00:00:00' || $value == '00-00-0000' || $value == '0000-00-00 00:00')) {
				$value = '';
			}

			/*
			$retVal .=  '<div class="input-append date datepicker'.(($nome_campo=='anno')?'-year':'').(($nome_campo=='data_nascita')?'-born-date':'').'-js '.$style.' '.$nome_campo.'" id="div_'.$nome_campo.'" data-date="'.$value.'" data-date-format="'.(($nome_campo=='anno')?'yyyy':'dd-mm-yyyy').'">';
			$retVal .=  '<input class="datepicker-input" type="text" id="'.$nome_campo.'" name="'.$nome_campo.'" value="'.$value.'" placeholder="'.$oOggetto->get('oApp')->getEtichetta('PLACEHOLDER_DATEPICKER').'" />';
			$retVal .=  '<span class="add-on"><i class="icon-remove"></i></span>';
			$retVal .=  '<span class="add-on"><i class="icon-th"></i></span>';
			$retVal .=  '</div>';
			*/

            $retVal .=  '<div class="input-group date datepicker-js" id="datetimepicker-'.$nome_campo.'" data-target-input="nearest">';
            $retVal .=  '<input type="text" class="form-control datetimepicker-input" name="'.$nome_campo.'"  data-target="#datetimepicker-'.$nome_campo.'" value="'.$value.'" placeholder="'.$oOggetto->get('oApp')->getEtichetta('PLACEHOLDER_DATEPICKER').'"/>';
            $retVal .=  '<div class="input-group-append" data-target="#datetimepicker-'.$nome_campo.'" data-toggle="datetimepicker">';
            $retVal .=  '<div class="input-group-text"><i class="fa fa-calendar"></i></div>';
            $retVal .=  '</div>';
            $retVal .=  '</div>';

            //$retVal .=  '<input type="text" class="form-control datetimepicker-input" id="datetimepicker-'.$nome_campo.'" data-toggle="datetimepicker" data-target="#datetimepicker-'.$nome_campo.'" data-format="DD-MM-YYYY"/>';

            break;

		case 'datetimepicker':
			if ((empty($value) || $value == '0000-00-00' || $value == '0000-00-00 00:00:00' || $value == '00-00-0000 00:00' || $value == '00-00-0000' || $value == '0000-00-00 00:00') && !is_null($valore_default)) {
				$value = '';
			}

			$retVal .=  '<div class="input-append date datetimepicker-js '.$style.' '.$nome_campo.'" id="div_'.$nome_campo.'" data-date="'.$value.'" data-date-format="dd-mm-yyyy hh:ii">';
			$retVal .=  '<input type="text" id="'.$nome_campo.'" name="'.$nome_campo.'" value="'.$value.'" placeholder="'.$oOggetto->get('oApp')->getEtichetta('PLACEHOLDER_DATEPICKER').'" />';
			$retVal .=  '<span class="add-on"><i class="icon-remove"></i></span>';
			$retVal .=  '<span class="add-on"><i class="icon-th"></i></span>';
			$retVal .=  '</div>';


		break;
		
		case 'timepicker':
			if ((empty($value) || $value == '00:00:00' || $value == '00:00')) {
				$value = '';
			}
			
			$retVal .=  '<div class="input-append bootstrap-timepicker-component '.$style.' '.$nome_campo.'">';
			$retVal .=  '<input id="'.$nome_campo.'" name="'.$nome_campo.'" type="text" class="timepicker-input timepicker-input-js" value="'.substr($value,0,5).'" placeholder="'.$oOggetto->get('oApp')->getEtichetta('PLACEHOLDER_TIMEPICKER').'" />';
			$retVal .=  '<span class="add-on"><i class="cus-clock"></i></span>';
			$retVal .=  '</div>';
		break;
		
		case 'bootstrapTimePicker':
			if ((empty($value)/* || $value == '00:00:00' || $value == '00:00'*/)) {
				$value = '';
			}
			
			$retVal .=  '<div class="input-append bootstrap-timepicker-component '.$style.' '.$nome_campo.'">';
			$retVal .=  '<input id="'.$nome_campo.'" name="'.$nome_campo.'" type="time" value="'.$value.'" placeholder="'.$oOggetto->get('oApp')->getEtichetta('PLACEHOLDER_TIMEPICKER').'" style="width: 100%; border: none; outline: none;" />';
			$retVal .=  '<span class="add-on"><i class="cus-clock"></i></span>';
			$retVal .=  '</div>';
		break;

		case 'textarea':
			$retVal .=  '<textarea rows="6" name="' . $nome_campo . '" id="' . $nome_campo . '" ' . ((!$enabled)?' disabled="disabled"':'') . ((!empty($style))?' class="'.$style.'"':'') . '>'; 
			$retVal .=  $value;
			$retVal .=  '</textarea>';
		break;
		
		case 'radio':
			$contatore_radio = 0;
			foreach ($aSelect as $k => $v) {
				$id = $nome_campo . '_' . $k;
				$contatore_radio++;
				if ($etichetta != -1) {
					$retVal .=  '<label class="radio'.((empty($numero_colonne))?' inline':' col-xl-'.floor(12/$numero_colonne)).'" for="'.$id.'" id="label_'.$id.'">';
				}
				$retVal .=  '<input type="radio" name="'.$nome_campo.'" id="'.$id.'" value="'.$k.'"' . ((!empty($style))?' class="'.$style.'"':'') . ( ((!is_null($value) && $value == $k) || (empty($value) && $contatore_radio == 1) )?' checked="checked"':'') . '>';
				if ($etichetta != -1) {
					$retVal .=  $oOggetto->get('oApp')->getEtichetta($v); 
					$retVal .=  '</label>';
				}				
			}
		break;

		case 'radio_db':
			foreach ($aSelect as $i => $aRec) {
				$k = $aRec['id'];
				$v = $aRec['descrizione'];
				$id = $nome_campo . '_' . $k;
                $retVal .=  '<div class="form-check form-check-inline">';
				if ($etichetta != -1) {
					$retVal .=  '<label class="form-check-label '.((empty($numero_colonne))?' inline':' col-xl-'.floor(12/$numero_colonne)).' '.$nome_campo.'" for="'.$id.'" id="label_'.$id.'">';
				}
				$retVal .=  '<input type="radio" name="'.$nome_campo.'" id="'.$id.'" value="'.$k.'"' . ((!$enabled)?' disabled="disabled"':'').' class="form-check-input" '.((!empty($style))?' '.$style.' ':'').'"'.(((!empty($value) || $value === '0') && ((is_string($value) && $k == $value) || (is_array($value) && in_array($k,$value))))?' checked="checked"':'') . '>';
				if ($etichetta != -1) {
					$retVal .=  $v; 
					$retVal .=  '</label>';
				}
                $retVal .=  '</div>';
			}
		break;
		
		case 'checkbox':
			foreach ($aSelect as $k => $v) {
				$id = $nome_campo . '_' . $k;
				if ($etichetta != -1) {
					$retVal .=  '<label class="checkbox'.((empty($numero_colonne))?' inline':' col-xl-'.floor(12/$numero_colonne)).'" for="'.$id.'" id="label_'.$id.'">';
				}
				$retVal .=  '<input type="checkbox" name="'.$nome_campo.'[]" id="'.$id.'" value="'.$k.'"' . ((!empty($style))?' class="'.$style.'"':'') . ((!empty($value) && in_array($k,$value))?' checked="checked"':'') . '>';
				if ($etichetta != -1) {
					$retVal .=  $oOggetto->get('oApp')->getEtichetta($v); 
					$retVal .=  '</label>';
				}				
			}
		break;
		
		case 'checkbox_db':
			if (!empty($numero_colonne)) $retVal .= '<div class="row in_colonna">';
			foreach ($aSelect as $i => $aRec) {
				$k = $aRec['id'];
				$v = $aRec['descrizione'];
				$id = $nome_campo . '_' . $k;
				if ($etichetta != -1) {
					$retVal .=  '<label class="checkbox'.((empty($numero_colonne))?' inline':' col-xl-'.floor(12/$numero_colonne)).' '.$nome_campo.'" for="'.$id.'" id="label_'.$id.'">';
				}
				$retVal .=  '<input type="checkbox" name="'.$nome_campo.'[]" id="'.$id.'" value="'.$k.'"' . ((!empty($style))?' class="'.$style.'"':'') . ((!empty($value) && in_array($k,$value))?' checked="checked"':'') . '>';
				if ($etichetta != -1) {
					$retVal .=  $v; 
					$retVal .=  '</label>';
				}
				if ($i != 0 && !empty($numero_colonne) && (($i+1) % $numero_colonne) == 0) {
					$retVal .= '</div><div class="row-fluid">';
				}
			}
			if (!empty($numero_colonne)) $retVal .= '</div>';
		break;
		
		case 'boolean':
			$retVal .=  '<label class="checkbox'.((empty($numero_colonne))?' inline':' col-xl-'.floor(12/$numero_colonne)).'" for="'.$nome_campo.'">';
			$retVal .=  '<input type="checkbox" name="' . $nome_campo . '" id="' . $nome_campo . '" value="1" ' . ((!$enabled)?' disabled="disabled"':'') . ((!empty($style))?' class="'.$style.'"':'') . (($value == 1)?' checked="checked"':'') . '>';
			if (!is_null($etichetta_testo_esplicativo) && !$stampa_solo_input_senza_label_e_div) {
				$retVal .= ' '.$oOggetto->get('oApp')->getEtichetta($etichetta_testo_esplicativo);
			}
			$retVal .=  '</label>';
		break;
		
		case 'password':
			$retVal .=  '<input type="password" name="' . $nome_campo . '" id="' . $nome_campo . '" value="'; 
			$retVal .=  $value;
			$retVal .=  '" ' . ((!$enabled)?' disabled="disabled"':'') . ((!empty($style))?' class="'.$style.'"':'') . '>';
		break;
		
		case 'select':
			$retVal .=  '<select name="' . $nome_campo . '" id="' . $nome_campo . '"'.((!$enabled)?' disabled="disabled"':''). ((!empty($style))?' class="'.$style.'"':'') . '>';
			if (!(bool)$select_multipla) $retVal .=  '<option value="">--- '.($_SESSION['LINGUA_NAVIGAZIONE'] == 'it_IT' ? 'seleziona' : 'select' ) .' ---</option>';
			
			foreach ($aSelect as $option) {
				$retVal .=  '<option value="'.$option.'"'.(($value == $option)?' selected="selected"':'').'>'.$option.'</option>';
			}
			
			$retVal .=  '</select>';
		break;
		
		case 'select_db':
			$retVal .=  '<select name="' . $nome_campo.(((bool)$select_multipla)?'[]':'').'" '.(((bool)$select_multipla)?'multiple="multiple"':'').' id="' . $nome_campo . '"'.((!$enabled)?' disabled="disabled"':''). ((!empty($style))?' class="'.$style.'"':'') . '>';
			if (!(bool)$select_multipla) $retVal .=  '<option value="">--- '.($_SESSION['LINGUA_NAVIGAZIONE'] == 'it_IT' ? 'seleziona' : 'select' ) .' ---</option>';
			
			//dump($value);
			foreach ($aSelect as $option) {
				
				//dump('value = '.$value);
				//dump('$option[\'id\'] = '.$option['id']);
				//echo '<hr>';
				

				if ((bool)$select_multipla) {
					if (is_array($value)) {
						$isSelected = in_array($option['id'], $value);
					}
					if (is_string($value)) {
						$isSelected = ($option['id'] == $value);
					}
				} else {
					$isSelected = ($value == $option['id']);
				}
				
				$retVal .=  '<option value="'.$option['id'].'"'.(($isSelected)?' selected="selected"':'').'>'.$option['descrizione'].'</option>';
			}
			
			$retVal .=  '</select>';

		 	if (!empty($select_collegata) && is_numeric($select_collegata) && isPrimaRelatedSelects($id_form, $oOggetto)) {
				$strSelect = '"'.$nome_campo.'"';
				$strOrdineSelect = $nome_campo;
				$valoricorrelati = $value;
                $aCampoCollegato = array();
				getElencoSelectCollegate($strSelect, $strOrdineSelect, $select_collegata, $oOggetto, $valoricorrelati, $campo_controllo, $aCampoCollegato);
                $htmlJscript  = $oOggetto->get('oApp')->get('htmlJscript');
				$script  = '<script type="text/javascript">'.NL;
					$script .= TAB.'$(document).ready(function () {'.NL;
							$script .= TAB.TAB.'$("form").relatedSelects({'.NL;
							    /*
                                if (!is_null($aCampoCollegato)) {
                                   // $script .= TAB.TAB.TAB.'"id_dispositivo_origine": {onChange: '.$aCampoCollegato['callback_custom_field'].'()},';
                                }
							    */
								$script .= TAB.TAB.TAB.'onChangeLoad: "'.URL_AZIONI_BACKEND.'getRelatedSelects.php?ordineSelect='.$strOrdineSelect.'&nome='.$nome_campo.'&valoricorrelati='.$valoricorrelati.((strtoupper($nome_form_corrente) == 'ASSEGNA_AD_AGENZIA')?'&esclusiva=1':'').'",'.NL;
 								$script .= TAB.TAB.TAB.'dataType: "html",'.NL;
 								$script .= TAB.TAB.TAB.'selects: ['.$strSelect.']'.NL;
							$script .= TAB.TAB.'});'.NL;
					$script .= TAB.'});'.NL;
				$script .= '</script>';
				if ($accodaScript) {
					$oOggetto->get('oApp')->set('htmlJscript', $htmlJscript.$script);
				} else {
					$retVal .= $script;
				}
			}
			
		break;
		
		case 'select_array':
			$retVal .=  '<select name="' . $nome_campo . '" id="' . $nome_campo . '"'.((!$enabled)?' disabled="disabled"':''). ((!empty($style))?' class="'.$style.'"':'') . '>';
			if (!(bool)$select_multipla) $retVal .=  '<option value="">--- seleziona ---</option>';
			
			foreach ($aSelect as $chiave=>$valore) {
				$retVal .=  '<option value="'.$chiave.'"'.(($value == $chiave)?' selected="selected"':'').'>'.$valore.'</option>';
			}
			
			$retVal .=  '</select>';
		break;
		
		case 'slider':
            $retVal .=  '<input type="text" name="'.$nome_campo.'" id="'.$nome_campo.'" readonly style="border:0; margin-bottom: .2rem; font-weight:bold;"><div class="'.$nome_campo.'-range"></div>';

        case 'custom':
            $retVal .=  '<div id="form_'.strtolower($nome_form_corrente).'_custom_'.strtolower($nome_campo).'"></div>';
		break;

	}

	if (!is_null($campo_collegato)) {
		$retVal .=  _form_field($oOggetto, $aCampoCollegato, $tipo_form, $nome_form_corrente, TRUE);
	}
	
	if (!is_null($etichetta_testo_esplicativo) && !$stampa_solo_input_senza_label_e_div && $tipo_campo != 'checkbox' && $tipo_campo != 'boolean') {
		$retVal .= '<span class="help-inline">';
		$retVal .= $oOggetto->get('oApp')->getEtichetta($etichetta_testo_esplicativo);
		$retVal .= '</span>';
	}
	if (!$stampa_solo_input_senza_label_e_div) $retVal .= ((!empty($icona))?'<i class="'.$icona.' field-icon"></i>':'').'</div>';
	
	if ($tipo_campo !== 'hidden' && !$stampa_solo_input_senza_label_e_div) $retVal = '<div class="form-group '.$spanFieldset.'">'.$retVal.'</div>';
	return $retVal;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function _form_field_dizionario(&$oOggetto, $aCampi, $tipo_form, $spanFieldset = 'span12') {
	extract($aCampi);
	
	$retVal = '';
	
	if (!empty($_SESSION['$_POST'])) {
		if (!empty($_SESSION['$_POST'][$nome_campo])) {
			if (in_array($tipo_campo, array('select', 'select_db', 'radio'))) {
				$valore_default = $_SESSION['$_POST'][$nome_campo];
			} else {
				$value = $_SESSION['$_POST'][$nome_campo];
			}
		}
	}
	$req = '';
	
	//************************************************************************
	// stampo la label
	if ($tipo_campo !== 'hidden' && $etichetta != -1) {
		if (!isset($etichetta) || is_null($etichetta)) {
			$etichetta = strtoupper('FORM - '.$nome_form.' - '.$nome_campo);
		} 
	}
	
	
	
	switch ($tipo_campo) {
		case TIPO_DIZIONARIO_STRINGA:
			$lingue = unserialize(LINGUE_ATTIVE);
			//if (count($lingue) > 1) { 
				if (strtolower($tipo_form) !== 'inserisci') {
					$retVal .=  '<input class="hidden-input" type="hidden" name="' . $nome_campo . '" id="' . $nome_campo . '" value="'.$oOggetto->get($nome_campo).'">';
				}
				$retVal .=  '<ul class="nav nav-tabs default-tabs">';
					$primoGiro = TRUE;
					foreach($lingue as $l) {
						$nome = encodaNomeCampoDizionario($tipo_campo, $nome_campo, $l);
						$retVal .=  '<li'.(($primoGiro)?' class="active"':'').'>';
						$retVal .=  '<a href="#tab_'.$nome.'" data-toggle="tab"><i class="flag flag-'.strtolower(substr($l, 3, 2)).'">&nbsp;</i></a>';
						$retVal .=  '</li>';
						$primoGiro = FALSE;
					}
				$retVal .=  '</ul>';
				$retVal .=  '<div id="myTabContent2" class="tab-content">';
				$primoGiro = TRUE;
				foreach($lingue as $l) {
					if ((!isset($campo_controllo) || !(bool)$campo_controllo) && strtolower($tipo_form) !== 'inserisci') {
						$oDizionario = $oOggetto->get('o'.str_replace(' ','',ucwords(str_replace('_',' ',str_replace('id_','',$nome_campo)))));
						$value = $oDizionario->getValore($l);
					} else {
						$value = '';
					}
					
					$nome = encodaNomeCampoDizionario($tipo_campo, $nome_campo, $l);
					$retVal .= '<div class="tab-pane fade'.(($primoGiro)?' in active':'').'" id="tab_'.$nome.'">';
					if ((bool)$val_required) $req = '<span class="req">*</span>';
					$retVal .=  '<label class="control-label" for="' . $nome . '">'.$oOggetto->get('oApp')->getEtichetta($etichetta).' ('.$GLOBALS['LINGUE_NOMI'][$l].')'.$req.'</label>';
					$retVal .= '<div class="controls">';
					$retVal .= '<input type="text" name="' . $nome . '" id="' . $nome . '" value="'; 
					$retVal .= $value;
					$retVal .= '" ' . ((!$enabled)?' disabled="disabled"':'') . ((!empty($style))?' class="'.$style.'"':'') . '>';
					$retVal .= '</div>';
					$retVal .= '</div>';
					$primoGiro = FALSE;					
				}
				$retVal .= '</div>';
			//}
		break;	
		
		/*
		case TIPO_DIZIONARIO_EDITOR:
			$lingue = unserialize(LINGUE_ATTIVE);
			$jsString1 = '';
			//$jsString2 = '';
			//if (count($lingue) > 1) { 
				if (strtolower($tipo_form) !== 'inserisci') {
					$retVal .=  '<input class="hidden-input" type="hidden" name="' . $nome_campo . '" id="' . $nome_campo . '" value="'.$oOggetto->get($nome_campo).'">';
				}
				
				$retVal .=  '<ul class="nav nav-tabs default-tabs">';
					$primoGiro = TRUE;
					foreach($lingue as $l) {
						$nome = encodaNomeCampoDizionario($tipo_campo, $nome_campo, $l);
						$retVal .=  '<li'.(($primoGiro)?' class="active"':'').'>';
						$retVal .=  '<a href="#tab_'.$nome.'" data-toggle="tab"><i class="flag flag-'.strtolower(substr($l, 3, 2)).'">&nbsp;</i></a>';
						$retVal .=  '</li>';
						$primoGiro = FALSE;
					}
				$retVal .=  '</ul>';
				$retVal .=  '<div id="myTabContent2" class="tab-content">';
				$primoGiro = TRUE;
				foreach($lingue as $l) {
					if ((!isset($campo_controllo) || !(bool)$campo_controllo) && strtolower($tipo_form) !== 'inserisci') {
						$oDizionario = $oOggetto->get('o'.str_replace(' ','',ucwords(str_replace('_',' ',str_replace('id_','',$nome_campo)))));
						$value = $oDizionario->getValore($l);
					} else {
						$value = '';
					}
				
					$nome = encodaNomeCampoDizionario($tipo_campo, $nome_campo, $l);
					$retVal .= '<div class="tab-pane fade'.(($primoGiro)?' in active':'').'" id="tab_'.$nome.'">';
					if ((bool)$val_required) $req = '<span class="req">*</span>';
					$retVal .=  '<label class="control-label" for="' . $nome . '">'.$oOggetto->get('oApp')->getEtichetta($etichetta).' ('.$GLOBALS['LINGUE_NOMI'][$l].')'.$req.'</label>';
					$retVal .= '<div class="controls">';

					// input di "appoggio" in cui viene ricopiato l'html dell'editor
					//$retVal .=  '<input class="span12 hidden-input" type="text" name="html-'.$nome.'" id="html-'.$nome.'" value="html_'.$nome.'">';

					// html dell'editor
					$retVal .= '<div>';
					$retVal .= '<div class="jarviswidget-editbox">';
					$retVal .= '<div>';
					$retVal .= '<label>Title:</label>';
					$retVal .= '<input type="text" />';
					$retVal .= '</div>';
					$retVal .= '<div>';
					$retVal .= '<label>Styles:</label>';
					$retVal .= '<span data-widget-setstyle="purple" class="purple-btn"></span>';
					$retVal .= '<span data-widget-setstyle="navyblue" class="navyblue-btn"></span>';
					$retVal .= '<span data-widget-setstyle="green" class="green-btn"></span>';
					$retVal .= '<span data-widget-setstyle="yellow" class="yellow-btn"></span>';
					$retVal .= '<span data-widget-setstyle="orange" class="orange-btn"></span>';
					$retVal .= '<span data-widget-setstyle="pink" class="pink-btn"></span>';
					$retVal .= '<span data-widget-setstyle="red" class="red-btn"></span>';
					$retVal .= '<span data-widget-setstyle="darkgrey" class="darkgrey-btn"></span>';
					$retVal .= '<span data-widget-setstyle="black" class="black-btn"></span>';
					$retVal .= '</div>';
					$retVal .= '</div>';
					$retVal .= '<div class="inner-spacer wysihtml5-widget"> ';
					$retVal .= '<textarea class="wysihtml5" id="'.$nome.'" name="'.$nome.'" class="'.$style.'" style="height: 150px">'.$value.'</textarea>';
					$retVal .= '</div>';
					$retVal .= '</div>';
					
					$retVal .= '</div>';
					$retVal .= '</div>';
					
					// JS inizializzare l'editor e per gestire il testo inserito
					$jsString1 .= '$("#'.$nome.'").wysihtml5({"font-styles": false, "link": false, "image": false, "color": false});'.NL;
					//$jsString2 .= '$("#html-'.$nome.'").val($("#'.$nome.'").val());'.NL; 
					
					/*
					$("#myform").submit(function() {
					   // Retrieve the HTML from the plugin
					   var html = $('#content').val();
					   // Put this in the hidden field
					   $("#html").val(html);
					});
					*** /
					
					$primoGiro = FALSE;					
				}
				$retVal .= '</div>';
				
				
				$htmlJscript  = $oOggetto->get('oApp')->get('htmlJscript');
				
				$htmlValidate  = '<script type="text/javascript">'.NL;
					$htmlValidate .= TAB.'$(document).ready(function () {'.NL;
							$htmlValidate .= TAB.TAB.$jsString1.NL;
							/*
							$htmlValidate .= '$("form").submit(function() {'.NL;
								$htmlValidate .= $jsString2.NL;
							$htmlValidate .= '});'.NL;
							*** /
					$htmlValidate .= TAB.'});'.NL;
				$htmlValidate .= '</script>';
				
				$oOggetto->get('oApp')->set('htmlJscript', $htmlJscript.$htmlValidate);

			//}
		break;
		*/
		
		case TIPO_DIZIONARIO_EDITOR:
			$lingue = unserialize(LINGUE_ATTIVE);
			$jsString1 = '';
			$jsString2 = '';
			//if (count($lingue) > 1) { 
				if (strtolower($tipo_form) !== 'inserisci') {
					$retVal .=  '<input class="hidden-input" type="hidden" name="' . $nome_campo . '" id="' . $nome_campo . '" value="'.$oOggetto->get($nome_campo).'">';
				}
				$retVal .=  '<ul class="nav nav-tabs default-tabs">';
					$primoGiro = TRUE;
					foreach($lingue as $l) {
						$nome = encodaNomeCampoDizionario($tipo_campo, $nome_campo, $l);
						$retVal .=  '<li'.(($primoGiro)?' class="active"':'').'>';
						$retVal .=  '<a href="#tab_'.$nome.'" data-toggle="tab"><i class="flag flag-'.strtolower(substr($l, 3, 2)).'">&nbsp;</i></a>';
						$retVal .=  '</li>';
						$primoGiro = FALSE;
					}
				$retVal .=  '</ul>';
				$retVal .=  '<div id="myTabContent2" class="tab-content">';
				$primoGiro = TRUE;
				foreach($lingue as $l) {
					if ((!isset($campo_controllo) || !(bool)$campo_controllo) && strtolower($tipo_form) !== 'inserisci') {
						$oDizionario = $oOggetto->get('o'.str_replace(' ','',ucwords(str_replace('_',' ',str_replace('id_','',$nome_campo)))));
						$value = $oDizionario->getValore($l);
					} else {
						$value = '';
					}
					
					$nome = encodaNomeCampoDizionario($tipo_campo, $nome_campo, $l);
					$retVal .= '<div class="tab-pane fade'.(($primoGiro)?' in active':'').'" id="tab_'.$nome.'">';
					if ((bool)$val_required) $req = '<span class="req">*</span>';
					$retVal .=  '<label class="control-label" for="' . $nome . '">'.$oOggetto->get('oApp')->getEtichetta($etichetta).' ('.$GLOBALS['LINGUE_NOMI'][$l].')'.$req.'</label>';
					$retVal .= '<div class="controls">';

					$retVal .= '<textarea class="textareaDizionarioEditor" id="'.$nome.'" name="'.$nome.'" class="'.$style.'" style="height: 150px">'.$value.'</textarea>';
					
					$retVal .= '</div>';
					$retVal .= '</div>';
					
					$primoGiro = FALSE;					
				}
				$retVal .= '</div>';
				/*
				$retVal .='<script type="text/javascript">
         //<![CDATA[
      
          // Replace the <textarea id="$nome"> with an CKEditor
          // instance, using default configurations.
          CKEDITOR.replace( "'.$nome.'",
           {
            width: "80%",
            toolbar :
            [
             ["Bold","Italic","Underline","-","NumberedList","BulletedList","-","Link","Unlink"]
            ]
           });
      
         //]]>
         </script>';
		 */
			//}		
		break;
		
		case TIPO_DIZIONARIO_DESCRIZIONE:
			$lingue = unserialize(LINGUE_ATTIVE);
			$jsString1 = '';
			$jsString2 = '';
			//if (count($lingue) > 1) { 
				if (strtolower($tipo_form) !== 'inserisci') {
					$retVal .=  '<input class="hidden-input" type="hidden" name="' . $nome_campo . '" id="' . $nome_campo . '" value="'.$oOggetto->get($nome_campo).'">';
				}
				$retVal .=  '<ul class="nav nav-tabs default-tabs">';
					$primoGiro = TRUE;
					foreach($lingue as $l) {
						$nome = encodaNomeCampoDizionario($tipo_campo, $nome_campo, $l);
						$retVal .=  '<li'.(($primoGiro)?' class="active"':'').'>';
						$retVal .=  '<a href="#tab_'.$nome.'" data-toggle="tab"><i class="flag flag-'.strtolower(substr($l, 3, 2)).'">&nbsp;</i></a>';
						$retVal .=  '</li>';
						$primoGiro = FALSE;
					}
				$retVal .=  '</ul>';
				$retVal .=  '<div id="myTabContent2" class="tab-content">';
				$primoGiro = TRUE;
				foreach($lingue as $l) {
					if ((!isset($campo_controllo) || !(bool)$campo_controllo) && strtolower($tipo_form) !== 'inserisci') {
						$oDizionario = $oOggetto->get('o'.str_replace(' ','',ucwords(str_replace('_',' ',str_replace('id_','',$nome_campo)))));
						$value = $oDizionario->getValore($l);
					} else {
						$value = '';
					}
					
					$nome = encodaNomeCampoDizionario($tipo_campo, $nome_campo, $l);
					$retVal .= '<div class="tab-pane fade'.(($primoGiro)?' in active':'').'" id="tab_'.$nome.'">';
					if ((bool)$val_required) $req = '<span class="req">*</span>';
					$retVal .=  '<label class="control-label" for="' . $nome . '">'.$oOggetto->get('oApp')->getEtichetta($etichetta).' ('.$GLOBALS['LINGUE_NOMI'][$l].')'.$req.'</label>';
					$retVal .= '<div class="controls">';

					$retVal .= '<textarea class="" id="'.$nome.'" name="'.$nome.'" class="'.$style.'" style="height: 150px">'.$value.'</textarea>';
					
					$retVal .= '</div>';
					$retVal .= '</div>';
					
					$primoGiro = FALSE;					
				}
				$retVal .= '</div>';
				
			//}
		break;
		/*
		case 'textarea':
			$retVal .= '<div class="controls">';
			$retVal .=  '<textarea name="' . $nome_campo . '" id="' . $nome_campo . '" ' . ((!$enabled)?' disabled="disabled"':'') . ((!empty($style))?' class="'.$style.'"':'') . '>'; 
			$retVal .=  $value;
			$retVal .=  '</textarea>';
		$retVal .= '</div>';
		break;
		*/
		
	}
	
	
	if ($tipo_campo !== 'hidden') $retVal = '<div class="control-group '.$spanFieldset.'">'.$retVal.'</div>';
	return $retVal;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function _form_hidden_field($campo, $valore) {
	return '<div class="controls"><input class="hidden-input" type="hidden" name="'.$campo.'" id="'.$campo.'" value="'.$valore.'"></div>';
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function _get_select_from_db($nomeSelect, $etichetta, $dbConn, $sql, $defaultValue = null, $etichettaBefore = FALSE) {
	$rows = $dbConn->eseguiselect($sql);

	$retVal = '';
	if (count($rows) > 0) {
		$retVal .=  '<label class="control-label" for="' . $nomeSelect . '">';
		
		if ($etichettaBefore) $retVal .=  $etichetta;
		
		$retVal .=  '<select name="' . $nomeSelect . '" id="' . $nomeSelect . '">';
		$retVal .=  '<option value="">--- seleziona ---</option>';
		foreach ($rows as $row) {
			$retVal .=  '<option value="'.$row['valore'].'"'.(($defaultValue == $row['valore'])?' selected="selected"':'').'>'.$row['etichetta'].'</option>';
		}
		$retVal .=  '</select>';

		if (!$etichettaBefore) $retVal .=  $etichetta;
		
		$retVal .=  '</label>';
	}

	return $retVal;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function comprimi_output($stringa) {
	/* remove comments */
	$stringa = preg_replace('!/\*[^*]*\*+([^/][^*]*\*+)*/!', '', $stringa);
	/* remove tabs, spaces, newlines, etc. */
	$stringa = str_replace(array("\r\n", "\r", "\n", "\t", '  ', '    ', '    '), '', $stringa);
	return $stringa;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function encodaNomeCampoDizionario($tipo_campo, $nome_campo, $lingua) {
	return 'DIZ-'.$tipo_campo.'-'.$lingua.'-'.$nome_campo;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function getElencoSelectCollegate(&$strSelect, &$strOrdineSelect, $id_form, $oObj, &$valoricorrelati, $campo_controllo, &$aCampoCollegato) {
	$aSelect = $oObj->get('oDb')->eseguiselect('SELECT * FROM form WHERE id_form='.num2str($id_form), CLASS_DB_SELECT_MODE_SINGLE_ROW);
	$strSelect .= ',"'.$aSelect['nome_campo'].(((bool)$aSelect['select_multipla'])?'[]':'').'"';
	$strOrdineSelect .= '|'.$aSelect['nome_campo'].(((bool)$aSelect['select_multipla'])?'[]':'');
	
	if (!$campo_controllo) {
		if (!empty($valoricorrelati)) $valoricorrelati .= '-';
		//dump($aSelect['nome_campo']);
		$v = $oObj->get($aSelect['nome_campo']);
		//dump($v);	
		if (is_array($v)) $v = implode('#',array_filter($v)); 
		//if (is_array($v)) $v = $v[0]; 
		$valoricorrelati .= $v;
	}
	
	if (!empty($_SESSION['$_POST'])) {
		if (!empty($_SESSION['$_POST'][$aSelect['nome_campo']])) {
			$valoricorrelati .= $_SESSION['$_POST'][$aSelect['nome_campo']];
		}
	}

    if (!empty($aSelect['campo_collegato'])) {
        $aCampoCollegato = getSingoloCampoDb($oObj->get('oDb'), $aSelect['campo_collegato']);
    }
	
	if (!empty($aSelect['select_collegata']) && is_numeric($aSelect['select_collegata'])) {
		getElencoSelectCollegate($strSelect, $strOrdineSelect, $aSelect['select_collegata'], $oObj, $valoricorrelati, $campo_controllo, $aCampoCollegato);
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function getSingoloCampoDb($oDb, $id_form) {
	return $oDb->eseguiselect('SELECT * FROM form WHERE id_form='.num2str($id_form), CLASS_DB_SELECT_MODE_SINGLE_ROW);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function isPrimaRelatedSelects($id_form, $oObj) {
	return !$oObj->get('oDb')->eseguiselect('SELECT count(*) FROM form WHERE select_collegata='.num2str($id_form), CLASS_DB_SELECT_MODE_SINGLE_VALUE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
?>