<?php
require_once(realpath($_SERVER['DOCUMENT_ROOT']).'/v2/include/include.php');

$action = @$_GET['a'];
$filter = @$_GET['f'];
$deviceTypeId = @$_GET['t'];

//$_SESSION['LINGUA_NAVIGAZIONE']

if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    $req = $_REQUEST;

    /*
        Array
        (
            [id_supervisore_origine] => 3
            [id_origin_device_loop] => 2-3
            [id_origin_item_number] => 7
            [id_supervisore_destinazione] => 2
            [id_destination_device_type] => 20014-14
            [id_destination_device_sub_type] => 29
            [id_destination_device_value] => *
            [data_creazione] => 2018-10-30 12:18:36
            [data_ultima_modifica] => 2018-10-30 12:18:36
            [id_utente_creatore] => 1
            [id_utente_ultima_modifica] => 1
            [id_utente_proprietario] => 1
            [nome_form] => RELAY_ABBINAMENTO
        )

        CREATE TABLE `relay` (
    `id_relay` int(10) NOT NULL AUTO_INCREMENT,
    `ip_supervisore_origine` varchar(15) NOT NULL,
    `codice_dispositivo_origine` int(11) NOT NULL,
    `codice_sotto_tipo_origine` varchar(255) NOT NULL,
    `evento_origine` varchar(255) NOT NULL,
    `ip_supervisore_destinazione` varchar(15) NOT NULL,
    `codice_dispositivo_destinazione` int(11) NOT NULL,
    `codice_sotto_tipo_destinazione` varchar(255) NOT NULL,
    `comando_destinazione` varchar(255) NOT NULL,
    `id_supervisore_origine` varchar(15) NOT NULL,
    `id_dispositivo_origine` bigint(21) NOT NULL,
    `id_sotto_tipo_dispositivo_origine` int(11) NOT NULL,
    `id_supervisore_destinazione` varchar(15) NOT NULL,
    `id_dispositivo_destinazione` bigint(21) NOT NULL,
    `id_sotto_tipo_dispositivo_destinazione` int(11) NOT NULL,
    `data_creazione` datetime NOT NULL,
    `data_ultima_modifica` datetime NOT NULL,
    `id_utente_creatore` bigint(20) NOT NULL,
    `id_utente_ultima_modifica` bigint(20) NOT NULL,
    `id_utente_proprietario` bigint(20) NOT NULL,
    `id_status` int(11) NOT NULL,
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8;


    */    

    if(@$req['id_supervisore_origine'] !== "" && @$req['id_supervisore_destinazione'] !== ""){

        $supOrig = $rows = $db->execSelect('select * from supervisore where id_supervisore = ' . $req['id_supervisore_origine']);
        $supDest = $rows = $db->execSelect('select * from supervisore where id_supervisore = ' . $req['id_supervisore_destinazione']);
        $faSrcDest = $rows = $db->execSelect('select * from dispositivo where id_supervisore = ' . $req['id_supervisore_origine'] . ' and id_tipo_dispositivo in (16) order by descrizione;');
        $alpDevDest = $rows = $db->execSelect('select * from dispositivo where id_supervisore = ' . $req['id_supervisore_destinazione'] . ' and id_tipo_dispositivo in (14) order by descrizione;');
    
        if(@$supOrig[0]['ip'] && @$supDest[0]['ip']) {
            //Both supervisors found
    
            $supOrig = $supOrig[0];
            $supDest = $supDest[0];
            $alpDevDest = $alpDevDest[0];
            $faSrcDest = $faSrcDest[0];

            $potentialConflictingRules = $rows = $db->execSelect("select * from relay where codice_sotto_tipo_origine = 'FA' and id_supervisore_destinazione = " . $req['id_supervisore_destinazione']);

            $hasConflict = false;

            $newRuleTriplet = explode("-", $req["id_origin_device_loop"] .  "-" . $req["id_origin_item_number"]);

            foreach($potentialConflictingRules as $potentialConflictingRule) {
                $oldRuleTriplet = explode("-", $potentialConflictingRule['evento_origine']);

                $p1m = @$newRuleTriplet[0] == @$oldRuleTriplet[0] || @$newRuleTriplet[0] == '*' || @$oldRuleTriplet[0] == '*';
                $p2m = @$newRuleTriplet[1] == @$oldRuleTriplet[1] || @$newRuleTriplet[1] == '*' || @$oldRuleTriplet[1] == '*';
                $p3m = @$newRuleTriplet[2] == @$oldRuleTriplet[2] || @$newRuleTriplet[2] == '*' || @$oldRuleTriplet[2] == '*';

                if($p1m && $p2m && $p3m) {
                    $hasConflict = true;
                }
            }

            if(!$hasConflict) {

                $qry = "
                    INSERT INTO `ave_rsa`.`relay` (
                        `ip_supervisore_origine`, `codice_dispositivo_origine`, `codice_sotto_tipo_origine`, `evento_origine`, 
                        `ip_supervisore_destinazione`, `codice_dispositivo_destinazione`, `codice_sotto_tipo_destinazione`, `comando_destinazione`, 
                        `id_supervisore_origine`, `id_dispositivo_origine`, `id_sotto_tipo_dispositivo_origine`, `id_supervisore_destinazione`, 
                        `id_dispositivo_destinazione`, `id_sotto_tipo_dispositivo_destinazione`, `id_status`
                    ) VALUES (
                        '" . $supOrig['ip'] . "', 254, 'FA', '" . $req["id_origin_device_loop"] .  "-" . $req["id_origin_item_number"] .  "',
                        '" . $supDest['ip'] . "', 0, '<FALP>', '" . (@$req["destination_message"] ? $req["destination_message"] : '*') . "',
                        " . $req['id_supervisore_origine'] . ", " . $faSrcDest["id_dispositivo"] . ", 31,
                        " . $req['id_supervisore_destinazione'] . ", " . $alpDevDest['id_dispositivo'] . ", 29, 
                        1
                    ); ";
        
                $rows = $db->runSql($qry);

                serverReloadRelayRules();
                header("Location: /backend/relay/antincendio.php?success=save_ok");
                die;

            } else {
                header("Location: /backend/relay/antincendio.php?error=has_conflicts");
                die;

            }
    
        } else  {
            header("Location: /backend/relay/antincendio.php?error=bad_supervisors");
            die;
        }


    } else {
        header("Location: /backend/relay/antincendio.php?error=select_supervisors");
        die;
    }

}
    

header("Location: /backend/relay/antincendio.php?error=general");
die;






