
USE `ave_rsa`;

UPDATE `ave_rsa`.`dispositivo_tipo_dispositivo` SET `icona`='fa fa-fw  fa-fire' WHERE  `id_tipo_dispositivo`=16;

REPLACE INTO `ave_rsa`.`dispositivo_sotto_tipo_dispositivo` (`id_sotto_tipo_dispositivo`, `id_tipo_dispositivo`, `ordine`, `tipo_messaggio`, `is_allarme`, `codice_sotto_tipo_dispositivo`, `it_IT`, `en_UK`, `accetta_origine`, `accetta_destinazione`, `min`, `max`, `step`, `asterisco`, `negazione`) VALUES ('31', '16', '1', 'digitale', '0', 'FA', 'allarme antincendio', 'fire alarm', '1', '0', '0', '1', '1', '1', '1');

UPDATE `ave_rsa`.`dispositivo_tipo_dispositivo` SET `usabile_come_origine`='1' WHERE `id_tipo_dispositivo`='16';

CREATE 
     OR REPLACE ALGORITHM = UNDEFINED 
    DEFINER = `root`@`%` 
    SQL SECURITY DEFINER
VIEW `dispositivo_ext` AS
    (SELECT 
        `d`.`id_dispositivo` AS `id_dispositivo`,
        `d2`.`id_supervisore` AS `id_supervisore`,
        `d2`.`id_tipo_dispositivo` AS `id_tipo_dispositivo`,
        `d2`.`descrizione` AS `descrizione`,
        `d2`.`codice_dispositivo` AS `codice_dispositivo`,
        `d2`.`indirizzo_bus` AS `indirizzo_bus`,
        `d2`.`mappe` AS `mappe`,
        `d2`.`data_creazione` AS `data_creazione`,
        `d2`.`data_ultima_modifica` AS `data_ultima_modifica`,
        `d2`.`id_utente_creatore` AS `id_utente_creatore`,
        `d2`.`id_utente_ultima_modifica` AS `id_utente_ultima_modifica`,
        `d2`.`id_utente_proprietario` AS `id_utente_proprietario`,
        `d2`.`id_status` AS `id_status`
    FROM
        (`dispositivo` `d`
        JOIN `dispositivo` `d2` ON (((`d2`.`id_supervisore` = `d`.`id_supervisore`)
            AND (`d2`.`id_tipo_dispositivo` = `d`.`id_tipo_dispositivo`))))
    WHERE
        ((`d`.`codice_dispositivo` = 0)
            AND (`d2`.`codice_dispositivo` > 0))) UNION (SELECT 
        `dispositivo`.`id_dispositivo` AS `id_dispositivo`,
        `dispositivo`.`id_supervisore` AS `id_supervisore`,
        `dispositivo`.`id_tipo_dispositivo` AS `id_tipo_dispositivo`,
        `dispositivo`.`descrizione` AS `descrizione`,
        `dispositivo`.`codice_dispositivo` AS `codice_dispositivo`,
        `dispositivo`.`indirizzo_bus` AS `indirizzo_bus`,
        `dispositivo`.`mappe` AS `mappe`,
        `dispositivo`.`data_creazione` AS `data_creazione`,
        `dispositivo`.`data_ultima_modifica` AS `data_ultima_modifica`,
        `dispositivo`.`id_utente_creatore` AS `id_utente_creatore`,
        `dispositivo`.`id_utente_ultima_modifica` AS `id_utente_ultima_modifica`,
        `dispositivo`.`id_utente_proprietario` AS `id_utente_proprietario`,
        `dispositivo`.`id_status` AS `id_status`
    FROM
        `dispositivo`
    WHERE
        ((`dispositivo`.`codice_dispositivo` > 0)
            OR (`dispositivo`.`id_tipo_dispositivo` = 14) OR (`dispositivo`.`id_tipo_dispositivo` = 16)));


UPDATE `ave_rsa`.`form` SET `valori_select`='getArrayElencoSupervisoriAttiviNonSpeciali' WHERE `id_form`='1292';

UPDATE `ave_rsa`.`form` SET `valori_select`='getArrayElencoSupervisoriAttiviNonSpeciali' WHERE `id_form`='1293';

