<?php
require_once(realpath($_SERVER['DOCUMENT_ROOT']).'/include/config.php');
require_once(DIR_CLS . 'class.app.php');

$oApp = new app(TRUE);
$oApp->esegui();
/*********************************************************************************************************/
function backend_relay_ajax_carica_form_dispositivo(&$oApp) {
    $id_sotto_tipo_dispositivo = readPostParam('id_sotto_tipo_dispositivo');
    $id_relay = readPostParam('id_relay');
    $tipo = strtolower(readPostParam('tipo'));

    $oO = new sottotipodispositivo($oApp, $id_sotto_tipo_dispositivo);
    $oO->set('posizione_dato', $tipo);

    $min = $oO->get('min');
    $max = $oO->get('max');

    if ($id_relay != -1) {
        $oRelay = new relay($oApp, $id_relay);
        if ($tipo == 'origine') $oRelay->decodaEventoOrigineInSottoTipoDispositivo($oO);
        if ($tipo == 'destinazione') $oRelay->decodaComandoDestinazioneInSottoTipoDispositivo($oO);
        $min = $oO->get('min_impostato_'.$tipo);
        $max = $oO->get('max_impostato_'.$tipo);
    }


    $m = 'getFormSottoTipoDispositivo'.ucfirst($tipo);
    echo $oO->$m();
    ?>
    <script>
        $(function() {
            if ($("#digitale_<?=$tipo?>").length > 0) {
                //alert('$("#digitale_<?=$tipo?>").rules( "add", {required:true});');
                $("#digitale_<?=$tipo?>").rules( "add", {required:true});
            }
            if ($("#slider_<?=$tipo?>").length > 0) {
                //alert('$("#slider_<?=$tipo?>").rules( "add", {required:true});');
                $("#slider_<?=$tipo?>").rules( "add", {required:true});
                $("div.slider_<?=$tipo?>-range").slider({
                    range: true,
                    min: <?=$oO->get('min')?>,
                    max: <?=$oO->get('max')?>,
                    step: <?=$oO->get('step')?>,
                    values: [ <?=$min?>, <?=$max?> ],
                    slide: function (event, ui) {
                        $("#slider_<?=$tipo?>").val( ui.values[0]+' - '+ui.values[1]);
                    }
                });
                $("#slider_<?=$tipo?>").val("<?=$min?> - <?=$max?>");
            }
            if ($("#valore_discreto_<?=$tipo?>").length > 0) {
                //alert('$("#valore_discreto_<?=$tipo?>").rules( "add", {required:true});');
                $("#valore_discreto_<?=$tipo?>").rules( "add", {required:true});
            }
        });
    </script>
    <?php
}
?>