<?php
require_once(realpath($_SERVER['DOCUMENT_ROOT']).'/include/config.php');
require_once(DIR_CLS . 'class.app.php');

$oApp = new app(TRUE);
$oApp->esegui();

/*********************************************************************************************************/
function backend_relay_azioni_abbinamento(&$oApp) {
    $oO = new relay($oApp);
    $redirect = URL_BACKEND.$oO->get('class_url').'abbinamento.php';
    $ret = $oO->isFormValido($_POST, 'inserisci', 'RELAY_ABBINAMENTO');
    if ($ret === TRUE) {

        $_POST['evento_origine'] = $_POST['comando_destinazione'] = '*';

        $oSupOrigine = new supervisore($oApp, $_POST['id_supervisore_origine']);
        $_POST['ip_supervisore_origine'] = $oSupOrigine->get('ip');

        $oDispOrigine = $oSupOrigine->getDispositivoVirtualeTuttiAllarmi('origine');
        $_POST['id_dispositivo_origine'] = $oDispOrigine->getId();
        $_POST['codice_dispositivo_origine'] = $oDispOrigine->get('codice_dispositivo');

        $oSottoTipoDispositivoOrigine = new sottotipodispositivo($oApp, SOTTO_TIPO_DISPOSITIVO_VIRTUAL_ALL_ID);
        $_POST['id_sotto_tipo_dispositivo_origine'] = $oSottoTipoDispositivoOrigine->getId();
        $_POST['codice_sotto_tipo_origine'] = $oSottoTipoDispositivoOrigine->get('codice_sotto_tipo_dispositivo');


        $oSupDestinazione = new supervisore($oApp, $_POST['id_supervisore_destinazione']);
        $_POST['ip_supervisore_destinazione'] = $oSupDestinazione->get('ip');

        $oDispDestinazione = $oSupDestinazione->getDispositivoVirtualeTuttiAllarmi('destinazione');
        $_POST['id_dispositivo_destinazione'] = $oDispDestinazione->getId();
        $_POST['codice_dispositivo_destinazione'] = $oDispDestinazione->get('codice_dispositivo');

        $oSottoTipoDispositivoDestinazione = new sottotipodispositivo($oApp, SOTTO_TIPO_DISPOSITIVO_VIRTUAL_INOLTRO_ID);
        $_POST['id_sotto_tipo_dispositivo_destinazione'] = $oSottoTipoDispositivoDestinazione->getId();
        $_POST['codice_sotto_tipo_destinazione'] = $oSottoTipoDispositivoDestinazione->get('codice_sotto_tipo_dispositivo');

        $oO->initByRecord($_POST);
        $ret = $oO->inserisci();
        if ($ret === TRUE) {

            $sql = "insert into log_allarmi (data, allarme_sistema, id_supervisore, id_dispositivo, tipo_allarme) values (CURRENT_TIMESTAMP, 1, " . $oDispOrigine->getId() . ", 0, 'SYSTEM:PAIRING_RULE_CREATED') ; ";
            $oApp->oDb->eseguiInsert($sql);

            $oApp->redirect($redirect, $oApp->getMsgSuccesso('INSERIMENTO_OK'), MESSAGGIO_SUCCESSO);
        } else {
            $oApp->redirect($redirect, $oApp->getMsgErrore('INSERIMENTO_ERRORE'), MESSAGGIO_ERRORE);
        }
    } else {
        $oApp->redirect($redirect, $ret, MESSAGGIO_ERRORE);
    }

}
?>


