<?php
require_once(realpath($_SERVER['DOCUMENT_ROOT']).'/include/config.php');
require_once(DIR_CLS . 'class.app.php');
	
$oApp = new app(TRUE);
$oApp->esegui();

/*********************************************************************************************************/
function backend_relay_azioni_inserisci(&$oApp) {
    unset($_POST['evento_origine']);
    unset($_POST['comando_destinazione']);

    $oO = new relay($oApp);
    $redirect = URL_BACKEND.$oO->get('class_url');

    $oSottoTipoDispositivoOrigine = new sottotipodispositivo($oApp, readPostParam('id_sotto_tipo_dispositivo_origine'));
    $oSottoTipoDispositivoOrigine->set('posizione_dato', 'origine');
    $ret = $oSottoTipoDispositivoOrigine->isFormValido($_POST, 'inserisci');
    if ($ret === TRUE) {
        $oSottoTipoDispositivoDestinazione = new sottotipodispositivo($oApp, readPostParam('id_sotto_tipo_dispositivo_destinazione'));
        $oSottoTipoDispositivoDestinazione->set('posizione_dato', 'destinazione');
        $ret = $oSottoTipoDispositivoDestinazione->isFormValido($_POST, 'inserisci');
        if ($ret === TRUE) {
            $oSottoTipoDispositivoOrigine->initByRecord($_POST);
            $oSottoTipoDispositivoDestinazione->initByRecord($_POST);
            $_POST['evento_origine'] = $oO->encodaEventoOrigineBySottoTipoDispositivo($oSottoTipoDispositivoOrigine);
            $_POST['comando_destinazione'] = $oO->encodaComandoDestinazioneBySottoTipoDispositivo($oSottoTipoDispositivoDestinazione);

            $ret = $oO->isFormValido($_POST, 'inserisci');
            if ($ret === TRUE) {
                $oO->initByRecord($_POST);
                $ret = $oO->inserisci();
                if ($ret === TRUE) {
                    $sql = "insert into log_allarmi (data, allarme_sistema, id_supervisore, id_dispositivo, tipo_allarme) values (CURRENT_TIMESTAMP, 1, " . $oDispOrigine->getId() . ", 0, 'SYSTEM:RELAY_RULE_CREATED') ; ";
                    $oApp->oDb->eseguiInsert($sql);
                    
                    $oApp->redirect($redirect, $oApp->getMsgSuccesso('INSERIMENTO_OK'), MESSAGGIO_SUCCESSO);
                } else {
                    $oApp->redirect($redirect, $oApp->getMsgErrore('INSERIMENTO_ERRORE'), MESSAGGIO_ERRORE);
                }
            } else {
                $oApp->redirect($redirect.'inserisci.php', $ret, MESSAGGIO_ERRORE);
            }
        } else {
            $oApp->redirect($redirect.'inserisci.php', $ret, MESSAGGIO_ERRORE);
        }
    } else {
        $oApp->redirect($redirect.'inserisci.php', $ret, MESSAGGIO_ERRORE);
    }
}
?>


