<?php
require_once(realpath($_SERVER['DOCUMENT_ROOT']).'/include/config.php');
require_once(DIR_CLS . 'class.app.php');

$oApp = new app(TRUE);
$oApp->sezione(SEZIONE_STATISTICHE);
$oApp->disegna(TEMPLATE_STANDARD);

/*********************************************************************************************************/
function backend_statistiche_segnalazioni_complete(&$oApp) {
    $oApp->apriWidget('statistiche', $oApp->getEtichetta('FILTRA_STATISTICHE_TUTTE_SEGNALAZIONI'), FALSE, FALSE, FALSE, FALSE);
    $oLogAllarme = new logallarme($oApp);
    if (array_key_exists('p', $_GET) && empty($_POST)) {
        $_POST['filtro_data_da'] = date('d-m-Y', strtotime('-3 day'));
        $_POST['filtro_data_a'] = date('d-m-Y');
    }
    $oLogAllarme->initByRecord($_POST);
    $oLogAllarme->getFormFiltro();
    $oApp->chiudiWidget();

    $oApp->apriWidget('statistiche', $oApp->getEtichetta('TABELLA_STATISTICHE_TUTTE_SEGNALAZIONI'), FALSE, FALSE, FALSE, FALSE);

    $oElencoAllarmi = new elencologallarme($oApp);
    $oElencoAllarmi->caricaTutti($_POST);

    $aCampi = array();
    $aCampi[] = 'data_ordinabile';
    $aCampi[] = 'denominazione_supervisore';
    $aCampi[] = 'denominazione_dispositivo';
    $aCampi[] = 'tipo_allarme_decoded';
    $aCampi[] = 'risolto_decoded';

    $oElencoAllarmi->setCampiInteresse($aCampi);
    $oElencoAllarmi->stampa('tabella', STYLE_DATATABLE_BASIC);

    $oApp->chiudiWidget();

    $htmlJs = $oApp->get('htmlJscript');
    $htmlJs = $htmlJs . "<script>$(function () {
            $('#datetimepicker-filtro_data_da').datetimepicker({format: 'DD-MM-YYYY'});
            $('#datetimepicker-filtro_data_a').datetimepicker({format: 'DD-MM-YYYY'});
        });</script>";
    $oApp->set('htmlJscript', $htmlJs);
}
?>