<?php
require_once(realpath($_SERVER['DOCUMENT_ROOT']).'/include/config.php');
require_once(DIR_CLS . 'class.app.php');
	
$oApp = new app(TRUE);
$oApp->sezione(SEZIONE_UTENTI);
$oApp->titolo('MODIFICA_UTENTE');
$oApp->disegna(TEMPLATE_STANDARD);

/*********************************************************************************************************/
function backend_utenti_utenti_modifica(&$oApp) {
	$oUtente = new utente($oApp, readGetParam('id_oggetto', TRUE));
	if ($oUtente->get("is_modificabile")) {
		if($oApp->getIdTipoUtenteLoggato() == UTENTE_TIPO_ID_UTENTE && $oUtente->getId() != $oApp->getIdUtenteLoggato()){
			 $oApp->redirect(URL_BACKEND.$oUtente->get('class_url'), $oApp->getMsgErrore('OPERAZIONE_NON_PERMESSA'), MESSAGGIO_ERRORE);
			 die;
		}
    } else {
        $oApp->redirect(URL_BACKEND.$oUtente->get('class_url'), $oApp->getMsgErrore('OPERAZIONE_NON_PERMESSA'), MESSAGGIO_ERRORE);
        die;
	}
	$titolo = str_replace('##nominativo##', strtoupper($oUtente->get('nome').' '.$oUtente->get('cognome')), $oApp->getEtichetta('UTENTI_MODIFICA'));

	$oApp->apriWidget('utente_modifica', $titolo, FALSE, FALSE, FALSE, FALSE);
	$oUtente->getFormModifica();
	$oApp->chiudiWidget();
}
?>