<?php 
	session_start();
	
	require_once "../yassintegration.php";
	checkLoginAndRedirect();

	//if (!isSet($_SESSION["logged"])) header("location: index.php"); 
	//echo "session_logged: ".$_SESSION["logged"];
?>

<!DOCTYPE html>
<html>
<head>
  <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">     
  <meta name="apple-mobile-web-app-capable" content="yes" />
  <meta name="apple-mobile-web-app-status-bar-style" content="black" />
  <link rel="apple-touch-icon" href="../public/images/logo-ave.png" />
  <title>Domina Plus &ndash; HOTEL</title>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
  <link rel="stylesheet" href="../bootstrap-3.3.7-dist/css/bootstrap.min.css">
  <!--<link rel="stylesheet" type="text/css" href="../js/w2ui-1.5.rc1.min.css" />-->
  
  <script type="text/javascript" src="../js/jquery-3.1.1.min.js"></script>
  
  <style type="text/css">
  	body {background: url("../images/sf_body.jpg"); font-family: arial; margin: 0; text-align: center; margin-top: 10px;}  	  	
	.navbar-brand img {margin:-18px 0 0; height: 60px; }
	h1 { color: #fff; }
	.box-languages {left: auto; position: absolute; right: 7px; text-align: center; top: 13px; width: auto; }
	.box-languages img {height: 20px; margin: 0 3px; width: 30px; cursor: pointer; }
	.version {color: #b1b1b1; font-size: 11px; margin: 30px 0 0; text-align: center; width: 100%; }


	.navbar-toggle {margin-right: 90px; }
  </style>
  <?php 
	ini_set('display_errors', 1);
	ini_set('display_startup_errors', 1);
	error_reporting(E_ALL);
	//phpinfo();

	if(isset($_GET["adminlang"])) 
	{
		setcookie("adminlang", $_GET["adminlang"], time() + (86400 * 30 * 180), "/");
		$adminlang = $_GET["adminlang"];
	}
	else
	{
		if(!isset($_COOKIE["adminlang"])) 
			{setcookie("adminlang", "en", time() + (86400 * 30 * 180), "/"); $adminlang = "en";}
		else
			{$adminlang = $_COOKIE["adminlang"];}
	}

	$incf="";
	if (isset($_GET["incf"])) {$incf=$_GET["incf"];}

	$showHotelInfo=true;

	$doc_root  = preg_replace("!${_SERVER['SCRIPT_NAME']}$!", '', $_SERVER['SCRIPT_FILENAME']); # ex: /var/www;
	$string = file_get_contents($doc_root."/hotel/json/settings.json");

	if ($string!=null)
	{ 
		$json_a=json_decode($string,true);
		if ($json_a[2]["value"]=="OFF") $showHotelInfo=false;
	}


   ?>
</head>
<body>
	<div class="container">
	  <div class="row">
	    <div class="col-md-12">
	      <nav class="navbar navbar-default">
		  <div class="container-fluid">
		    <!-- Brand and toggle get grouped for better mobile display -->
		    <div class="navbar-header">
		      <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#bs-example-navbar-collapse-1" aria-expanded="false">
		        <span class="sr-only">Toggle navigation</span>
		        <span class="icon-bar"></span>
		        <span class="icon-bar"></span>
		        <span class="icon-bar"></span>
		      </button>
		      <a class="navbar-brand" href="#"><img src="../images/logo-ave-color.png"></a>
		    </div>

		    <!-- Collect the nav links, forms, and other content for toggling -->
		    <div class="collapse navbar-collapse" id="bs-example-navbar-collapse-1">
		      <ul class="nav navbar-nav">
		        <li><a rel="RoomsManagement" href="main.php?incf=rooms-configurator.php">Rooms Management</a></li>
		        <?php if ($showHotelInfo) { ?><li><a rel="HotelInfoManagement" href="main.php?incf=hotelinfo-configurator.php">Hotel info</a></li><?php } ?>
		        <li><a rel="Settings" href="main.php?incf=settings-configurator.php">Settings</a></li>
		        <li><a rel="Exit" href="index.php?cmd=logout">Esci</a></li>	
						<li><a id="timeContainer" href="javascript:void(0);" style="cursor: default; font-weight: bold; "> </a></li>		        
		      </ul>		      
		    </div><!-- /.navbar-collapse -->


		  </div><!-- /.container-fluid -->
		  <div class="box-languages">		  	
		  	<img onclick="javascript: window.location = 'main.php?incf=<?php echo $incf."&adminlang=en"; ?>';" src="../images/en.png" class="btn-en">
		  	<img onclick="javascript: window.location = 'main.php?incf=<?php echo $incf."&adminlang=it"; ?>';" src="../images/it.gif" class="btn-it">			
		</div>
		</nav>
	    </div>
	  </div>
	</div>
    <?php 
    	if ($incf!="")
    	{
    ?>
		<div class="container">
		    <div class="row">
		        <div class="col-md-12">
				<?php include ($incf); ?>            
		        </div>	    
	        </div>
	        <div class="version">Ver. <?php require("../ver.txt"); ?></div>
	    </div>

    <?php 
    	}
    ?>

</div>

<!-- Modal popup for alert -->
<div class="modal fade" id="myModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
        <h4 class="modal-title" id="myModalLabel">Modal title</h4>
      </div>
      <div class="modal-body"></div>
      <div class="modal-footer">
        <button type="button" class="btn btn-default center-block" data-dismiss="modal">OK</button>        
      </div>
    </div>
  </div>
</div>
</body>
</html>
<script type="text/javascript" src="../bootstrap-3.3.7-dist/js/bootstrap.min.js"></script>
<!--<script type="text/javascript" src="../js/w2ui-1.5.rc1.min.js"></script>-->
<script type="text/javascript">

	$(function(){
		setInterval(function(){
			$("#timeContainer").load("/azioni/time.php");

		}, 1000);
	});

	function setMenuLabel(lang)
	{		
		if (lang=="it")
		{
			RoomsManagement="Gestione Stanze";
			HotelInfoManagement="Hotel Info";
			Settings="Impostazioni";
			Exit="Esci";			
		}
		else
		{
			RoomsManagement="Rooms Management";
			HotelInfoManagement="Hotel Info";
			Settings="Settings";
			Exit="Exit";			
		}

		$("a[rel=RoomsManagement]").html(RoomsManagement);
		$("a[rel=HotelInfoManagement]").html(HotelInfoManagement);
		$("a[rel=Settings]").html(Settings);
		$("a[rel=Exit]").html(Exit);
	}
	setMenuLabel("<?php echo $adminlang; ?>");
</script>

