<?php 
	if (session_status() == PHP_SESSION_NONE) {session_start();}

	require_once "../yassintegration.php";
	checkLoginAndRedirect();

	//if (!isSet($_SESSION["logged"])) header("location: index.php"); 
?>

  <style type="text/css">
  .btn-primary { background-color: #333; }


	.h3, h3 {clear: left; display: inline-block; float: left; font-size: 17px; margin: 30px 0 10px; text-align: left; }
  	.h2, h2 {background: #333 none repeat scroll 0 0; border-radius: 22px 22px 0 0; color: #fff; left: 0; padding: 30px 0; position: absolute; top: -20px; width: 100%; }
  	.box-roomnumber {background: #fff none repeat scroll 0 0; border: 3px solid #fff; border-radius: 25px; box-sizing: border-box; left: 3%; margin: 0; padding: 100px 20px 20px; position: relative; top: 20px; width: 94%; }
  	.box-roomnumber-number {font-size: 20px; font-weight: bold; width: 90px; text-align: center; }
	.btn {font-size: 16px; font-weight: normal; line-height: 16px; padding: 6px 10px 4px; text-transform: uppercase; }
	.alertmsg {position: absolute; top: 0; left: 0; bottom: 0; right: 0; background: rgba(0, 0, 0, 0.90); color: #fff;  }
	.alertmsg span {display: inline-block; font-size: 20px; width: 200px; top: 50%; position: absolute ; left: 50%; margin: -20px 0 0 -100px; }

	
	.new-tr td {background: #d4ffbe none repeat scroll 0 0; display: none; }

	#setDateTimeCountaner,
	#loadUpdateContainer,
	#setIpContainer {
		margin-top: 12px;
		border: 1px solid #e4e4e4;
		padding: 12px 30px;
		text-align: center;
	}

	#setIpContainer table {
		margin: auto;
	}

	.set-date-title,
	.load-update-title,
	.set-ip-title {
		text-align: left;
		font-size: 16px;
		margin: 27px 0 0 0;
		font-weight: bold;


	}

  </style>

  <div class="box-roomnumber">
  	<h2></h2>
  	<h3></h3>
  	<div id="tbl1"></div>
	  <div id="tbl2"></div>
	  <div id="actions"></div>
	  
	  <div class="set-ip-title"></div>
	  <div id="setIpContainer">
	  
	  		<?php

                $raw = shell_exec("/sbin/ifconfig eth0 | grep \"inet addr:\"");
                $raw = str_replace("inet addr", "IpAddr", $raw);

                $raw = explode(" ", $raw);
                $ipData = [];

                foreach($raw as $idx => $item) {
                    $item = explode(":", $item);
                    if(@$item[0]) {
                        $ipData[trim(strtolower($item[0]))] = trim($item[1]);
                    }
                }

                $raw = shell_exec("ip route show | grep default");
                $raw = explode(" ", trim($raw));

                $ipData['gateway'] = $raw[2];
                $ipData['dns'] = shell_exec("cat /etc/resolv.conf |  awk {'print $2'}");
                $ipData['mode'] = (trim(shell_exec("cat /etc/network/interfaces | grep 'eth0 inet' | awk {'print $4'}")) == 'static' ? 'static' : 'dhcp');


            ?>
            <table>
                <tr>
                    <td style="text-align: right">Mode </td>
                    <td style="padding: 0px 24px 0px 24px; ">
                        <select class="form-control" id="setMode" name="setMode">
                            <option value="dhcp" <?=$ipData['mode'] == 'dhcp' ? 'selected' : ''?> >DHCP</option>
                            <option value="static" <?=$ipData['mode'] == 'static' ? 'selected' : ''?> >STATIC</option>
                        </select>
                    </td>
                </tr>
                <tr>
                    <td style="text-align: right">IP </td>
                    <td style="padding: 0px 24px 0px 24px; "><input value="<?=$ipData['ipaddr']?>" class="form-control" id="setIp" name="setIp"></td>
                </tr>
                <tr>
                    <td style="text-align: right">Network Mask </td>
                    <td style="padding: 0px 24px 0px 24px; "><input value="<?=$ipData['mask']?>" class="form-control" id="setMask" name="setMask"></td>
                </tr>
                <tr>
                    <td style="text-align: right">Gateway </td>
                    <td style="padding: 0px 24px 0px 24px; "><input value="<?=$ipData['gateway']?>" class="form-control" id="setGateway" name="setGateway"></td>
                </tr>
                <tr>
                    <td style="text-align: right">DNS </td>
                    <td style="padding: 0px 24px 0px 24px; "><input value="<?=$ipData['dns']?>" class="form-control" id="setDNS" name="setDNS"></td>
                </tr>
                <tr>
                <td style="text-align: right"> </td>
                <td style="text-align: right">
                    <center>
                        <button id="setIpButton" class="btn btn-warning">Set</button>
                        <div id="assignIpResult"></div>
                    </center>
                </td>
                </tr>

            </table>


	  	</div>


		<div class="set-date-title"></div>

		<div id="setDateTimeCountaner" class="col">
			<div class="row text-center" style="text-align: center;">
				<form method="post" action="/azioni/datetime.php" style="margin: auto;">
					<table class="table">
						<?php
							$today = getdate();
						?>
						<tr>
							<th>Anno</th> <th></th>
							<th>Mese</th> <th></th>
							<th>Giorno</th> <th></th>
							<th>Ore</th> <th></th>
							<th>Minuti</th> <th></th>
							<th>Secondi</th>
						</tr>
						<tr>
							<td>
								<select id="fieldSetYear"  name="setYear" class="form-control">
									<?php for ($i = 2000; $i < 2100; $i++) { ?> <option <?=$today['year'] == $i ? 'selected' : '' ?>><?=$i?></option> <?php } ?>
								</select>
							</td>
							<td class="date-sep-col">/</td>
							<td>
								<select id="fieldSetMonth" name="setMonth" class="form-control">
									<?php for ($i = 1; $i <= 12; $i++) {   ?> <option <?=$today['mon'] == $i ? 'selected' : '' ?>><?=$i?></option> <?php } ?>
								</select>
							</td>
							<td class="date-sep-col">/</td>
							<td>
								<select id="fieldSetDay" name="setDay" class="form-control">
									<?php for ($i = 1; $i <= 31; $i++) { ?> <option <?=$today['mday'] == $i ? 'selected' : '' ?>><?=$i?></option> <?php } ?>
								</select>
							</td>
							<td class="date-sep-col">&nbsp;&nbsp;&nbsp;&nbsp;</td>
							<td>
								<select id="fieldSetHours" name="setHours" class="form-control">
									<?php for ($i = 0; $i <= 23; $i++) { ?> <option <?=$today['hours'] == $i ? 'selected' : '' ?>><?=$i?></option> <?php } ?>
								</select>
							</td>
							<td class="date-sep-col">:</td>
							<td>
								<select id="fieldSetMinutes" name="setMinutes" class="form-control">
									<?php for ($i = 0; $i <= 59; $i++) {   ?> <option <?=$today['minutes'] == $i ? 'selected' : '' ?>><?=$i?></option> <?php } ?>
								</select>
							</td>
							<td class="date-sep-col">:</td>
							<td>
								<select id="fieldSetSeconds" name="setSeconds" class="form-control">
									<?php for ($i = 0; $i <= 59; $i++) { ?> <option <?=$today['seconds'] == $i ? 'selected' : '' ?>><?=$i?></option> <?php } ?>
								</select>
							</td>
						</tr>
			
					</table>
					<button class="btn btn-success" id="btnSetDateTime" type="submit">Imposta</button>
					<button class="btn btn-primary" id="btnReadDateTimeFromComputer" >Leggi da questo PC</button>

					<script>
						jQuery('#btnReadDateTimeFromComputer').click(function(ev){
							ev.preventDefault()
							var dt = new Date();
							jQuery('#fieldSetYear').val(dt.getFullYear());
							jQuery('#fieldSetMonth').val(dt.getMonth() + 1);
							jQuery('#fieldSetDay').val(dt.getDate());
							jQuery('#fieldSetHours').val(dt.getHours());
							jQuery('#fieldSetMinutes').val(dt.getMinutes());
							jQuery('#fieldSetSeconds').val(dt.getSeconds());
						});	

						jQuery('#btnSetDateTime').click(function(ev){
							ev.preventDefault()
							
							setDateTimeUrl = "/azioni/datetime.php?isAjax=1" +
								"&setDay=" + jQuery("#fieldSetDay").val() + 
								"&setMonth=" + jQuery("#fieldSetMonth").val() + 
								"&setYear=" + jQuery("#fieldSetYear").val() + 
								"&setHours=" + jQuery("#fieldSetHours").val() + 
								"&setMinutes=" + jQuery("#fieldSetMinutes").val() + 
								"&setSeconds=" + jQuery("#fieldSetMinutes").val();

							$.ajax({
								url: setDateTimeUrl,
								error: function(){
									alert("Errore, riprovare più tardi");
								},
								success: function(data){
									data = data.trim();
									
									if(data == 'OK') {
										alert("Data e ora impostata correttamente");
									} else {
										alert("Errore nell'impostazione di data e ora, riprovare più tardi");
									}
								},
								timeout: 10000 //in milliseconds
							});
						});				
					
					</script>

					
					<?php
						
					?>
				</form>
			</div>
		</div>

	  <div class="load-update-title"></div>
      <div id="loadUpdateContainer">

				
	  		<form id="fileUploadForm" action="/azioni/carica_software.php" method="post" enctype="multipart/form-data" style="margin: auto;">
				
				<table>
					<tr>
						<td>Seleziona aggiornamento da caricare</td>
						<td style="padding: 0px 24px 0px 24px; "><input class=" " type="file" id="softwareUploadField" name="softwareUploadField"></td>
						<td><span id="fileUploadLoadingSpinner"></span> <button id="fileUploadButton" class="btn btn-warning" >Carica</button></td>
					</tr>
					<tr>
						<td style="padding: 24px; font-weight: bold; " id="fileUploadErrorMessage" colspan="3" style="text-align: center; ">
						
						</td>
					</tr>
				</table>
			</form>
		

	  </div>
	  
  </div>

<script type="text/javascript" src="../js/jquery.tabledit.min.js"></script>
<script type="text/javascript" src="/js/lib/jquery-fileupload.js"></script>


<script type="text/javascript">
	var doRedirect=false;

	var tit1;
	var tit2;
	var titChangeMode;
	var accedi;
	var col1;
	var col2;	
	var titIpSetup;
	var titLoadUpdate;
	var setDateTitle;
	var currentlang="<?php echo $adminlang; ?>";

	function setLabel(lang)
	{		
		if (lang=="it")
		{
			tit1="Configurazione impostazioni";
			tit2="Gestione parametri generali";
			titIpSetup="Impostazioni IP";
			titLoadUpdate="Caricamento aggiornamento software";
			titChangeMode="Cambia modo operativo";
			accedi="salva";
			col1="Parametro";
			col2="Valore";	
			setDateTitle="Imposta data e ora";		
		}
		else
		{
			tit1="Settings configuration";
			tit2="General settings management";
			titIpSetup="IP settings";
			titLoadUpdate="Upload software update";
			titChangeMode="Change mode";
			accedi="save";
			col1="Parametrer";
			col2="Value";
			setDateTitle="Set date and time";	
		}

		$(".box-roomnumber h2").html(tit1);
		$(".box-roomnumber h3").html("<b>" + tit2 + "</b>");		
		$(".set-ip-title").html(titIpSetup);
		$(".load-update-title").html(titLoadUpdate);
		
		$(".set-date-title").html(setDateTitle);
		
	}

	document.addEventListener("DOMContentLoaded", function() { 
		

		function resetFileUploadForm() {
			jQuery('#fileUploadLoadingSpinner').html('');
			jQuery('#fileUploadButton').show();
		}

		function fleUploadFormPleaseWait() {
			jQuery('#fileUploadLoadingSpinner').html('<i class="fa fa-spinner fa-pulse fa-2x"></i>');
			jQuery('#fileUploadButton').hide();
		}


		$("#fileUploadForm").fileUpload({
			//uploadData    : { 'extra_data' : 'blah' }, // Append POST data to the upload
			//submitData    : { 'moar_extra_data' : 'blah' }, // Append POST data to the form submit
			//uploadOptions : { dataType : 'json' }, // Customise the parameters passed to the $.ajax() call on uploads. You can use any of the normal $.ajax() params
			//submitOptions : { dataType : 'json' }, // Customise the parameters passed to the $.ajax() call on the form submit. You can use any of the normal $.ajax() params
			before	      : function(){
				jQuery('#fileUploadErrorMessage').html('<p class="text-primary">Carica aggiornamento software</p>');
				fleUploadFormPleaseWait()
			},  
			beforeSubmit  : function(uploadData){ 
				if(uploadData['status'] == 'file_upload_post' && uploadData['saved_files'] == 1 && uploadData['error_files'] == 0) {
					jQuery('#fileUploadErrorMessage').html('<p class="text-success">Caricamento riuscito!</p>');
				} else {
					jQuery('#fileUploadErrorMessage').html('<p class="text-danger">Errore nel caricamento</p>');
				}

				resetFileUploadForm();
				return false; 
			}, 
			success       : function(data, textStatus, jqXHR){ 
				resetFileUploadForm();
			}, 
			error 	      : function(jqXHR, textStatus, errorThrown){ 
				resetFileUploadForm();
			}, 
			complete      : function(jqXHR, textStatus){ 
				
				resetFileUploadForm();
			} 
		});		

		$('#setIpButton').click(function(ev) {
			ev.preventDefault();
			
			if(confirm("Sicuro di voler procedere?")) {
				
				dhcpMode = jQuery("#setMode").val() == 'static' ? '0' : '1';
				setIpUrl = "/azioni/setip.php?dhcp=" + dhcpMode + "&ip=" + jQuery("#setIp").val() + "&mask=" + jQuery("#setMask").val() + "&gw=" + jQuery("#setGateway").val() + "&dns=" + jQuery("#setDNS").val();

				jQuery("#assignIpResult").html("Attendere <i class=\"fa fa-spinner fa-spin\"></i> ");
				
				$.ajax({
					url: setIpUrl,
					error: function(){
						jQuery("#assignIpResult").html("Parametri di rete inviati corettamente, premi <a href=\"http://" + jQuery("#setIp").val() + "\">qui</a> per ricaricare la pagina. ");
						jQuery("#assignIpResult").attr("class", "text-success font-weight-bold");
					},
					success: function(data){
						data = data.trim();
						
						if(data == 'OK') {
							jQuery("#assignIpResult").html("Parametri di rete inviati corettamente, premi <a href=\"http://" + jQuery("#setIp").val() + "\">qui</a> per ricaricare la pagina. ");
							jQuery("#assignIpResult").attr("class", "text-success font-weight-bold");
						} 
						if(data.substring(0, 2) == 'KO') {
							jQuery("#assignIpResult").attr("class", "text-danger font-weight-bold");
						}
						
						if(data == 'KO1') { jQuery("#assignIpResult").html("Errore: parametri non riconosciuti. "); }
						if(data == 'KO2') { jQuery("#assignIpResult").html("Errore: parametri mancanti per l'indirizzo statico. "); }
						if(data == 'KO3') { jQuery("#assignIpResult").html("Errore: parametro modo statico/dhcp non definito. "); }
					},
					timeout: 10000 //in milliseconds
				});
			}

		});

	});

	var xxx;
	$(document).ready(function() {
		

		setLabel(currentlang);
		var x = $('#tbl1');
		x.append("<table class=\"table table-striped table-bordered\"><thead><tr><td>#</td><td class=\"col1\">"+col1+"</td><td class=\"col2\">"+col2+"</td></tr></thead><tbody></tbody></table>");

		var x2 = $('#tbl2');
		x2.append("<table class=\"table table-striped table-bordered\"><thead><tr><td>#</td><td class=\"col1\">"+col1+"</td><td class=\"col2\">"+col2+"</td></tr></thead><tbody></tbody></table>");
		
		$('#actions').html('<center><a class="btn btn-primary" href="/backend/sistema/modo.php">' + titChangeMode + '</a></center>');

		$.ajaxSetup({ cache: false });	
		$.getJSON( "../json/settings.json", function( data ) {
			$(data).each(function(index, el) {
				var lab_col1=el.label_en;
				if (currentlang=="it") lab_col1=el.label_it;
				console.log("el.value_type: "+el.value_type);
				if (el.value_type=="text")
					x.find("tbody").append("<tr><td>"+el.id+"</td><td>"+lab_col1+"</td><td>"+el.value+"</td></tr>");
				if (el.value_type=="boolean")
					x2.find("tbody").append("<tr><td>"+el.id+"</td><td>"+lab_col1+"</td><td>"+el.value+"</td></tr>");
			});		
			
			$('#tbl1 table').Tabledit({
			    url: 'settings-save.php',
			    columns: {
			        identifier: [0, 'id'],
			        editable: [[2, col2]]
			    },
			    deleteButton: false, 
			    onSuccess: function(data, textStatus, jqXHR) {
			        console.log('onSuccess(data, textStatus, jqXHR)');
			        console.log(data);
			        console.log(data.val);

			    },
			    onFail: function(jqXHR, textStatus, errorThrown) {
			        console.log('onFail(jqXHR, textStatus, errorThrown)');
			        console.log(jqXHR);
			        console.log(textStatus);
			        console.log(errorThrown);
			        $('#myModal .modal-title').html("Error");
			        $('#myModal .modal-body').html(jqXHR.responseText);
			        $('#myModal').modal('show');
			    },
			    onAjax: function(action, serialize) {
			        console.log('onAjax(action, serialize)');
			        console.log(action);
			        console.log(serialize);
			    }
			});

			$('#tbl2 table').Tabledit({
			    url: 'settings-save.php',
			    columns: {
			        identifier: [0, 'id'],
			        editable: [[2, col2,'{"ON": "ON", "OFF": "OFF"}']]
			    },
			    deleteButton: false, 
			    onSuccess: function(data, textStatus, jqXHR) {
			        console.log('onSuccess(data, textStatus, jqXHR)');
			        console.log(data);
			        console.log(data.val);			        
			        if (data.val=="add" || data.val=="delete") window.location.reload();
			        //console.log(textStatus);
			        //console.log(jqXHR);

			    },
			    onFail: function(jqXHR, textStatus, errorThrown) {
			        console.log('onFail(jqXHR, textStatus, errorThrown)');
			        console.log(jqXHR);
			        console.log(textStatus);
			        console.log(errorThrown);
			        $('#myModal .modal-title').html("Error");
			        $('#myModal .modal-body').html(jqXHR.responseText);
			        $('#myModal').modal('show');
			    },
			    onAjax: function(action, serialize) {
			        console.log('onAjax(action, serialize)');
			        console.log(action);
			        console.log(serialize);
			    }
			});
			

		});
		

		

	});
</script>