<?php
class dispositivo extends oggetto {

    protected $id_dispositivo;
	protected $id_supervisore;
	protected $id_tipo_dispositivo;
	protected $tipo_dispositivo;
	protected $descrizione;
	protected $codice_dispositivo;
	protected $codice_tipo_dispositivo;
	protected $indirizzo_bus;
	protected $mappe;
	protected $virtuale;
	protected $icona;
	protected $mostra_in_dashboard;

	protected $oElencoSottoTipoDispositivo = FALSE;

    protected $class_action_url = '---';
	protected $class_url = '---';
	protected $nome_tabella = 'dispositivo';
	protected $classe = 'dispositivo';

/*********************************************************************************************************/
public function inserisci() {
    TO_NOT_IMPLEMENT(__METHOD__);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function modifica() {
    TO_NOT_IMPLEMENT(__METHOD__);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getDenominazioneTabella() {
    return $this->descrizione.BR.'<small>('.$this->codice_dispositivo.'/'.$this->indirizzo_bus.')</small>';
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function haSottoTipoDispositivo() {
    if ($this->oElencoSottoTipoDispositivo == FALSE) $this->estraiSottoTipoDispositivo();
    return (!$this->oElencoSottoTipoDispositivo->isEmpty());
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getElencoSottoTipoDispositivo() {
    if ($this->oElencoSottoTipoDispositivo == FALSE) $this->estraiSottoTipoDispositivo();
    return $this->oElencoSottoTipoDispositivo;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
private function estraiSottoTipoDispositivo() {
    $aElencoSottoTipoDispositivoCompletoByIdTipoDispositivo = $this->oApp->get('aElencoSottoTipoDispositivoCompletoByIdTipoDispositivo');
    if (!empty($aElencoSottoTipoDispositivoCompletoByIdTipoDispositivo)) {
        if (array_key_exists($this->id_tipo_dispositivo, $aElencoSottoTipoDispositivoCompletoByIdTipoDispositivo)) {
            $this->oElencoSottoTipoDispositivo = $aElencoSottoTipoDispositivoCompletoByIdTipoDispositivo[$this->id_tipo_dispositivo];
        }
    } else {
        $this->oElencoSottoTipoDispositivo = new elencosottotipodispositivo($this->oApp, FALSE, ' ORDER BY ordine DESC');
        $this->oElencoSottoTipoDispositivo->caricaPerDispositivo($this);
    }
}
/*********************************************************************************************************/
/*********************************************************************************************************/





/*********************************************************************************************************/
/*********************************************************************************************************/
}
?>