<?php
class elencomappa extends elenco {
	
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getSqlToLoad($completo = TRUE, $elencoId = FALSE, $id = FALSE, $whereClauses = FALSE) {
	$sql = 'SELECT a.*,
	               b.descrizione AS status
	          FROM mappa AS a
	    INNER JOIN status AS b ON a.id_status = b.id_status
	          WHERE b.id_status != '.STATUS_ELIMINATO;
	
	if ($elencoId !== FALSE) $sql .= ((stripos($sql, 'WHERE') !== FALSE)?' AND ':' WHERE ') . 'id_mappa IN (' . implode(',', $elencoId).')';
	if ($id !== FALSE) $sql .= ((stripos($sql, 'WHERE') !== FALSE)?' AND ':' WHERE ') . 'id_mappa = ' . num2Str($id);
	if ($whereClauses !== FALSE) $sql .= ((stripos($sql, 'WHERE') !== FALSE)?' AND ':' WHERE ') . $whereClauses;
	
	return $sql;   
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function caricaPerSupervisore($oSupervisore) {
    instance_of($oSupervisore, 'supervisore');
    parent::carica(' a.id_supervisore = '.num2Str($oSupervisore->getId()), TRUE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
}
?>