<?php
class elencosupervisore extends elenco {
	
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getSqlToLoad($completo = TRUE, $elencoId = FALSE, $id = FALSE, $whereClauses = FALSE) {
	$sql = 'SELECT 
					a.id_supervisore,
					if(a.id_tipo_dispositivo = -1, a.ip_remoto, a.ip) as ip,
					a.ip_remoto,
					a.descrizione,
					a.id_tipo_dispositivo,
					a.id_tipo_visualizzazione,
					a.totale_mappe_da_campo,
					a.totale_dispositivi_da_campo,
					a.totale_mappe_da_db,
					a.totale_dispositivi_fisici_da_db,
					a.totale_dispositivi_virtuali_da_db,
					a.stato_connessione,
					a.ordine,
					a.data_creazione,
					a.data_ultima_modifica,
					a.last_connected,
					a.last_disconnected,
					a.id_utente_creatore,
					a.id_utente_ultima_modifica,
					a.id_utente_proprietario,
					a.id_status,

	               b.descrizione AS status,
	               c.'.$_SESSION['LINGUA_NAVIGAZIONE'].' AS tipo_dispositivo,
	               d.'.$_SESSION['LINGUA_NAVIGAZIONE'].' AS tipo_visualizzazione
	          FROM supervisore AS a
	    INNER JOIN status AS b ON a.id_status = b.id_status
	    INNER JOIN supervisore_tipo_dispositivo AS c ON a.id_tipo_dispositivo = c.id
	    INNER JOIN supervisore_tipo_visualizzazione AS d ON a.id_tipo_visualizzazione = d.id
	          WHERE b.id_status != '.STATUS_ELIMINATO;
	
	if ($elencoId !== FALSE) $sql .= ((stripos($sql, 'WHERE') !== FALSE)?' AND ':' WHERE ') . 'id_supervisore IN (' . implode(',', $elencoId).')';
	if ($id !== FALSE) $sql .= ((stripos($sql, 'WHERE') !== FALSE)?' AND ':' WHERE ') . 'id_supervisore = ' . num2Str($id);
	if ($whereClauses !== FALSE) $sql .= ((stripos($sql, 'WHERE') !== FALSE)?' AND ':' WHERE ') . $whereClauses;
	
	return $sql;   
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function caricaSoloAttivi() {
    parent::carica(' b.id_status = '.STATUS_ATTIVO, TRUE);
}
public function caricaSoloAttiviENonSpeciali() {
    parent::carica(' a.id_tipo_dispositivo >= 0 AND b.id_status = '.STATUS_ATTIVO, TRUE);
}

/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
}
?>