<?php
class permesso extends oggetto {
	protected $id_permesso;
	protected $permesso;
	protected $descrizione;
	protected $gestibile;
	protected $tipo;
	protected $sezione;
	protected $azione;

	protected $class_action_url = 'utenti/permessi/azioni/';
	protected $class_url = 'utenti/permessi/';
	protected $nome_tabella = 'permessi';
	protected $classe = 'permesso';
	protected $haStatus = FALSE;
	
/*********************************************************************************************************/
/*********************************************************************************************************/
public function inserisci() {
	// NON IMPLEMENTARE
	die;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function modifica() {
	$sql = 'UPDATE permessi 
	           SET descrizione = '.stripcslashesandquote($this->descrizione).'
             WHERE id_permesso = ' . num2Str($this->id_permesso);
	return (($this->oDb->eseguiupdate($sql))?TRUE:FALSE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function elimina() {
	// NON IMPLEMENTARE
	die;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function assegnaAdUtente($id_utente) {
	$sql = 'REPLACE INTO utenti_permessi (id_utente, 
	                                      id_permesso,
	                                      '.$this->getSqlCampiBase().'
	                                     ) VALUES (
	                           	          '.num2Str($id_utente).',
	                           	          '.num2Str($this->id_permesso).',
	                           	          '.$this->getValoriCampiBase().'
	                           	         )';
	return $this->oDb->eseguiinsert($sql);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function assegnaARuoloEUtenti($id_utente_tipo) {
	$ret = TRUE;
	// Modifico i permessi del tipo utente.
	$sql = 'REPLACE INTO utenti_tipi_permessi (id_utente_tipo, 
		                                       id_permesso,
		                                       '.$this->getSqlCampiBase().'
		                                      ) VALUES (
		                           	           '.num2Str($id_utente_tipo).',
		                           	           '.num2Str($this->getId()).',
		                           	           '.$this->getValoriCampiBase().'
	                           	              )';
	$ret = $ret && $this->oDb->eseguiinsert($sql);
	
	// Riassegno i permessi agli utenti con il corretto tipo utente
	$sql = 'REPLACE INTO utenti_permessi (id_utente, 
                                         id_permesso,
		                                 '.$this->getSqlCampiBase().')
		      SELECT id_utente, 
		             '.num2Str($this->getId()).' AS id_permesso,                           
	              	 '.stripcslashesandquote($this->data_creazione).' AS data_creazione,
					 '.stripcslashesandquote($this->data_ultima_modifica).' AS data_ultima_modifica,
		             '.num2Str($this->id_utente_creatore).' AS id_utente_creatore,
		             '.num2Str($this->id_utente_ultima_modifica).' AS id_utente_ultima_modifica,
		             '.num2Str($this->oApp->getIdUtenteLoggato()).' AS id_utente_proprietario,
		             '.STATUS_ATTIVO.' AS id_status
		        FROM utenti
	           WHERE id_utente_tipo = '.num2Str($id_utente_tipo);
	$ret = $ret && $this->oDb->eseguiinsert($sql);
	return $ret;	
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getModifica() {
	if ((bool)$this->gestibile) {
		return parent::getModifica();
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getPermessoDecoded() {
    return $this->sezione.' - '.$this->azione.' - '.$this->tipo. ' <small>('.$this->permesso.')</small>';
}
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
}
?>