<footer class="sticky-footer text-white">
    <div class="container-fluid">
        <div class="row">
            <div class="col col-5 text-right ml-5">
                <span style="font-size: 18px;" id="pageSubTitle"></span>
            </div>
            <div class="col text-center">
                <script>
                    document.addEventListener("DOMContentLoaded", function() {
                        jQuery(function(){
                            var timestampOffset = 0;

                            function getTimestamp(){
                                return Math.round(jQuery.now() / 1000);
                            }

                            function updateTimeStampOffset() {
                                jQuery.getJSON("/time.php", function(data) {
                                    myTimeStamp = getTimestamp();
                                    serverTimeStamp = data.serverTimestamp;
                                    timestampOffset = serverTimeStamp - myTimeStamp;
                                });
                            }

                            function formatDate(d) 
                            {
                                function pad(value) {
                                    return (value.toString().length < 2) ? '0' + value : value;
                                }
                                d = new Date(d * 1000);
                                return '<small>' + pad(d.getDate()) + '/' + pad(d.getMonth() + 1) + '/' + d.getFullYear() + '</small><br>' + pad(d.getHours()) + ":" + pad(d.getMinutes()) + ":" + pad(d.getSeconds());
                            }

                            setInterval(function(){
                                jQuery("#serverDateTime").html(formatDate(getTimestamp() + timestampOffset));
                            }, 1000);


                            setInterval(function(){
                                updateTimeStampOffset();
                            }, 10000);

                            updateTimeStampOffset();

                        });
                    });
                
                </script>



                <!--<small>Copyright &copy; Ave S.p.a.</small>-->
            </div>
            <div class="col">
                <a href="/azioni/lang.php?l=en_UK">
                    <img src="/img/en_UK.png" style="height: 16px;" />
                </a>
                <a href="/azioni/lang.php?l=it_IT">
                    <img src="/img/it_IT.png" style="height: 16px;" />
                </a>
            </div>
            <div class="col">
                <?php
                    $ver = getVersion();
                    
                    if($ver['summary']) {
                        ?> <b class="text-success">Ver. <?=$ver['summary']?></b> <?php
                    } else {
                        ?> <b class="text-danger">Unknown Version</b> <?php
                    }


                    print "(" . $ver['full'] . ")";
                ?>
            </div>
            <?php
           
            if (PAGE_NAME == 'dashboard') {
                ?>
                    <div class="col col-1 text-right mr-5" style="margin-right: -5px !important; margin-top: -1px;">
                        <a href="javascript:void(0)" id="supervisorsCollapse" class="pull-right" >
                            <i id="supervisorsCollapseIcon" class="fa fa-angle-right"></i>
                        </a>
                    </div>
                <?php
            }
            ?>
        </div>

    </div>
</footer>

