<?php
$oElencoAllarmi = new elencologallarme($oApp, FALSE, ' ORDER BY data DESC');
$oElencoAllarmi->caricaSoloAllarmiTecniciAttivi();

$testo_alert_allarmi = '<i class="fa fa-fw fa-bell"></i><span class="span_numero_allarmi">0</span>'; // str_replace('##NUMERO_ALLARMI##',$oElencoAllarmi->getTotaleElenco(),$oApp->getEtichetta('MENU_NUMERO_ALERT'));
$testo_alert_fire = '<i class="fa fa-fw fa-fire"></i><span class="span_numero_allarmi">0</span>'; // str_replace('##NUMERO_ALLARMI##',$oElencoAllarmi->getTotaleElenco(),$oApp->getEtichetta('MENU_NUMERO_ALERT'));
?>

<nav class="navbar navbar-expand-lg navbar-dark bg-dark fixed-top" id="mainNav">
    <i class="navbar-brand" ><img src="<?=URL_IMG?>dominaplus.png" height="40"></i>
    <div class="d-lg-none d-none block-alert-allarmi">
        <ul class="navbar-nav ml-auto">
            <li class="nav-item dropdown">
                <a class="nav-link mr-lg-2" href="#">
                    <span class=" ">
                        <span class="badge badge-pill badge-danger badge-numero-allarmi"><?=$testo_alert_allarmi?></span>
                    </span>
                </a>
            </li>
        </ul>
    </div>
    <button class="navbar-toggler navbar-toggler-right" type="button" data-toggle="collapse" data-target="#navbarResponsive" aria-controls="navbarResponsive" aria-expanded="false" aria-label="Toggle navigation">
        <span class="navbar-toggler-icon"></span>
    </button>
    <div class="collapse navbar-collapse" id="navbarResponsive">
        <b class="nav-link pull-left" style="color: white; font-size: 22px;" id="pageTitle"></b>
        <div id="serverDateTime"></div>
        <?php
        if (PAGE_NAME == 'dashboard') {
            ?>
            <div id="report-supervisori" class="d-none text-white">
                <div class="row">
                    <div class="col-2" id="allarme-a"><img src="<?=URL_IMG?>allarme-a.png">&nbsp;<span></span></div>
                    <div class="col-2" id="allarme-cs1"><img src="<?=URL_IMG?>allarme-cs1.png">&nbsp;<span></span></div>
                    <div class="col-2" id="allarme-cs2"><img src="<?=URL_IMG?>allarme-cs2.png">&nbsp;<span></span></div>
                    <div class="col-2" id="allarme-cs3"><img src="<?=URL_IMG?>allarme-cs3.png">&nbsp;<span></span></div>
                </div>
            </div>
            <?php
        }
        ?>
        <?=$oApp->menuBackend('MENU_PRINCIPALE')?>
        <ul class="navbar-nav sidenav-toggler" style="overflow: hidden; height: 58px; background-color: black; border-top: 2px solid #333; border-bottom: 1px solid #333;">
            <li class="nav-item">
                <a class="nav-link text-center" id="sidenavToggler">
                    <i class="fa fa-fw fa-angle-left"></i>
                </a>
            </li>
        </ul>
        <ul class="navbar-nav ml-auto">
            <li class="nav-item dropdown d-none block-alert-fire">
                <a class="nav-link dropdown-toggle mr-lg-6" id="fireAlertsDropdown" href="#" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                    <span>
                        <span class="badge badge-pill badge-danger badge-numero-fire"><?=$testo_alert_fire?></span>
                    </span>
                </a>
                <div class="dropdown-menu dropdown-menu-right" aria-labelledby="fireAlertsDropdown" id="div-dropdown-elenco-fire">
                    
                </div>
            </li>
            <li class="nav-item dropdown d-none block-alert-allarmi">
                <a class="nav-link dropdown-toggle mr-lg-6" id="alertsDropdown" href="#" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                    <span>
                        <span class="badge badge-pill badge-danger badge-numero-allarmi"><?=$testo_alert_allarmi?></span>
                    </span>
                </a>
                <div class="dropdown-menu dropdown-menu-right" aria-labelledby="alertsDropdown" id="div-dropdown-elenco-allarmi">
                    <?php
                    if(!$oElencoAllarmi->isEmpty() && false) {
                        
                        foreach ($oElencoAllarmi->getElenco() as $k=>$oLogAllarme) {
                            ?>
                            <div class="alert-div">
                                <a class="dropdown-item" href="javascript:void(0);" style="cursor: default;">
                                    <span class="text-danger">
                                        <strong><i class="fa fa-fw fa-exclamation"></i><?=$oLogAllarme->get('Supervisore@@getoggetto+descrizione')?></strong>
                                    </span>
                                    <span class="small float-left text-muted"><?=$oLogAllarme->get('data_ordinabile')?></span>
                                    <div class="dropdown-message small">&nbsp;</div>
                                </a>
                                <div class="dropdown-divider"></div>
                            </div>
                            <?php
                            if ($k+1 >= ELENCO_ALLARMI_MENU_MAX_ALLARMI) {
                                break;
                            }
                        }
                        ?>
                        <div class="vedi-tutti-div">
                            <a class="dropdown-item" href="<?=URL_BACKEND?>statistiche/allarmi.php?type=all">
                                <span class="text-dark">
                                    <strong><?=$oApp->getEtichetta('ALLARMI_VEDI_TUTTI')?></strong>
                                </span>
                            </a>
                        </div>
                        <?php
                    }
                    ?>
                </div>
            </li>

            <li class="nav-item">
                <a style="color: white; " class="nav-link" data-toggle="modal" data-target="#exampleModal">
                    <i class="fa fa-fw fa-sign-out"></i>
                </a>
            </li>
        </ul>
    </div>
    <div class="text-white">
        <i class="fa fa-fw <?=$oApp->get('oUtente')->getIconaLivello()?> fa-2x"></i>
    </div>
    <div class="ml-1">
        <img src="<?=URL_IMG?>logoAVEnoScritte.jpg" height="40">
    </div>
</nav>


