<?php
/*********************************************************************************************************/
/*********************************************************************************************************/
function siamoNoi() {
	return ($_SERVER['REMOTE_ADDR'] == IP_DEBUG);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function issetconst($nome_costante) {
	if (!defined($nome_costante)) {
		die('ATTENZIONE: non &egrave; definita la costante <strong>' . $nome_costante . '</strong>');
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function instance_of($obj, $istanza) {
	if (is_string($istanza)) {
		if (!is_a($obj, $istanza)) {
			die('ATTENZIONE: $obj non &egrave; un oggetto di tipo ' . strtoupper($istanza) . ' ma &egrave; ' . get_class($obj));
		}
	} else {
			echo '<br /><hr /><br />';
			echo 'Errore in : ' . __FUNCTION__ . '<br /><br />';
			DUMP($obj);
			die();
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function verificaParametro($condizione, $messaggio) {
	if (($condizione) && APP_SVILUPPO) die($messaggio);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function controlla_attributo($obj, $attributo) {
	$valore = $obj->get($attributo);
	if (empty($valore)) {
		die("ATTENZIONE: nell'inserimento di <strong>".get_class($obj) ."</strong> l'attributo <strong>$attributo</strong> &egrave; vuoto");
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function loggaFunzione($classe, $metodo) {
	echo '$'.$classe.'->'.$metodo.'()<br/>';
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function contatempo() {
    list($usec, $sec) = explode(" ",microtime());
    return ((float)$usec + (float)$sec);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function stampaContatempo($t, $str) {
    $tt = number_format(contatempo()-$t,20, ',', '.');
	echo '<!--'.$str.$tt.'-->';
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function debugContatempo($t, $str, $file) {
	stampasufile(DIR_LOG.'applicazione/'.$file.'.txt', $str.')'.number_format((contatempo()-$t),20, ',', '.'));
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function logsql($sql) {
	
	$sql = str_replace("\r\n", "", $sql);
	$sql = str_replace("\t", "", $sql);
	$sql = eliminaDoppiSpazi($sql);

	stampasufile(DIR_LOG_MYSQL . date('Y-m-d').'_log_sql.txt', $sql);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function eliminaDoppiSpazi($str) {
	while (stripos($str, '  ') !== FALSE) {
		$str = str_replace('  ', ' ', $str);
	}
	return $str;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function debug($txt) {
	stampasufile(DIR_LOG.'applicazione/debug.txt', $txt);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function DUMP($valore_da_var_dump) {
	echo '<pre>';
	var_dump($valore_da_var_dump);
	echo '</pre>';
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function PRINTR($array_da_print_r) {
	echo '<pre>';
	print_r($array_da_print_r);
	echo '</pre>';
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function TO_IMPLEMENT($metodo) {
	die('*** ' . $metodo . ' DA IMPLEMENTARE ***');
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function TO_NOT_IMPLEMENT($metodo) {
    die('***ATTENZIONE: ' . $metodo . ' DA NON IMPLEMENTARE ***');
}
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
function stampaCursoreInTabella($cursore) {
	$primoGiro = TRUE;
	while ($r = mysql_fetch_assoc($cursore)) {
		if ($primoGiro) {
			echo '<table>';
			echo '<tr>';
			foreach($r as $campo => $valore) {
				echo '<th>'.$campo.'</th>'; 
			}
			echo '</tr>';
			$primoGiro = FALSE;
		}
		echo '<tr>';
		foreach($r as $campo => $valore) {
			echo '<td>'.$valore . '</td>';
					
		}
		echo '</tr>';
	}
	echo '</table>';
	
}
/*********************************************************************************************************/
/*********************************************************************************************************/
?>