<?php
/*********************************************************************************************************/
/*********************************************************************************************************/
function stampa_albero_categorie_OLD($oApp, &$oCat, $target, $recursive = TRUE) {
	instance_of($oApp, 'app');
	$subCatList = $oCat->getSottoCategorie();
	if ($subCatList->getTotaleElenco() > 0) {
		echo '<ul>';
		foreach ($subCatList->getElenco() as $subCat) {
			echo '<li>';
			$url = URL_LANG.$target.'?idcat='.writeGetParam($subCat->get('id_categoria'));
			echo '<a href="'.$url.'">'.$subCat->get('nome'.LANGDB).'</a>';
			if ($recursive) {
				$subCatList2 = $subCat->getSottoCategorie();
				if ($subCatList2->getTotaleElenco() > 0) {
					stampaAlberoCategorie($oApp, $subCat); 
				}
			}
			echo '</li>';
		}
		echo '</ul>';
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function stampaColoriAgenda($oApp) {
	$sql = 'SELECT * FROM appuntamenti_tipo WHERE ordine <> 999 ORDER BY ordine';	
	$row = $oApp->get('oDb')->eseguiselect($sql);
	if (!empty($row)) {
        echo '<h2 id="page-header">'.$oApp->getEtichetta('LEGENDA').'</h2>';
		echo '<table style="width:100%; margin-left: 0px; padding-top: 15px;">';
		foreach($row as $key => $value){
			echo '<tr>
			      	<td style="width:100%; background-color:#'.$value['codice_colore'].';color:#000;padding:5px;">'.$value['it_IT'].'</td>
				 </tr>';
		}
		echo '</table>';
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function __bottone_OLD($azione, $oggetto, $classe = 'pulsante') {
	$target = URL_BACKEND.$oggetto->get('class_url').$azione.'.php';
	$etichetta = ucfirst($azione).' '.$oggetto->get('classe');
	return '<p><a href="'.$target.'" class="'.$classe.'">'.$etichetta.'</a></p>';
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function __linkAzione_OLD($azione, $oggetto, $azioneDiretta) {
	$url = URL_BACKEND.$oggetto->get('class_url'); 
	if ($azioneDiretta) {
		$url = URL_BACKEND.$oggetto->get('class_action_url'); 
	}
	$classe = $oggetto->get('classe');
	$id = $oggetto->getId();
	return '<a href="'.$url.$azione.'.php?id='.writeGetParam($id).'" class="'.$azione.'" id="'.$azione.ucfirst($classe).'" rel="'.writeGetParam($id).'"  title="'.ucfirst($azione).' '.$classe.'">
	        	<img src="'.URL_IMG.$azione.'.gif" alt="'.ucfirst($azione).' '.$classe.'" />
	        </a>';
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function __URLAzione_OLD($azione, $oggetto) {
	$url = URL_BACKEND.$oggetto->get('class_action_url'); 
	$classe = $oggetto->get('classe');
	$id = $oggetto->getId();
	return '<a href="'.$url.$azione.'.php?id='.writeGetParam($id).'" class="'.$azione.'" id="'.$azione.ucfirst($classe).'" rel="'.writeGetParam($id).'"  title="'.ucfirst($azione).' '.$classe.'">
	        	<img src="'.URL_IMG.$azione.'.gif" alt="'.ucfirst($azione).' '.$classe.'" />
	        </a>';
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function bottone($oApp, $etichetta, $id, $oOggetto = FALSE, $parametriExtra = FALSE, $visualizza_etichetta = TRUE, $stringa = NULL, $baseUrl = URL_BACKEND) {
	if ($oApp->get('oUtente')->haPermesso($etichetta)) {
		$bottone = $oApp->get('oDb')->eseguiselect('SELECT * FROM bottoni WHERE menu = '.stripcslashesandquote($etichetta).' ORDER BY ordine', CLASS_DB_SELECT_MODE_SINGLE_ROW);
		extract($bottone);
		$extra = '';
		if ($oOggetto !== FALSE) {
			//$extra = ' oggetto="'.$oOggetto->get('classe').'" id_oggetto="'.writeGetParam($oOggetto->getId()).'"';
			$extra = ' oggetto="'.$oOggetto->get('classe').'" id_oggetto="'.writeGetParam($oOggetto->getId()).'" id_oggetto_get_encoded="'.writeGetParam($oOggetto->getId()).'" id_oggetto_post_encoded="'.writePostParam($oOggetto->getId()).'"';
		}
		
		if (!empty($pagina)) {
			if ($parametriExtra !== FALSE) {
				if (stripos($pagina, '?') !== FALSE) {
					$pagina .= '&';
				} else {
					$pagina .= '?';
				}
				$pagina .= $parametriExtra;
			}
			
			if ($oOggetto !== FALSE) {
				if (stripos($pagina, '?') !== FALSE) {
					$pagina .= '&';
				} else {
					$pagina .= '?';
				}
				$pagina .= 'oggetto='.urlencode($oOggetto->get('classe')).'&id_oggetto='.urlencode(writeGetParam($oOggetto->getId()));
			}
			$url = $baseUrl.$pagina;
		} else {
			$url = 'javascript:void(0);';
		}
		
		$testo = '';
		if($visualizza_etichetta){
			$testo = '&nbsp;'.$oApp->getEtichettaBottone($etichetta);
		}
		if (!is_null($stringa)) {
			$testo = '&nbsp;'.$stringa;
		} 

		$str  = '<a href="'.$url.((stripos($url,'?') === FALSE)?'?':'&').'page_name='.PAGE_NAME.'" class="btn '.$style.' '.$id.'" id="'.$id.'" title="'.$testo.'"'.$extra.((!empty($target_blank))?' target="_blank"':'').'>';
		if (!empty($classe_icona)) $str .= '<i class="'.$classe_icona.((stripos($classe_icona, 'cus-') !== FALSE)?'':' icon-white').'"></i>';
		$str .= $testo;
		$str .= '</a>';
		
		return $str;
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function menu_dropdown($oApp, $aBottoni, $id, $oOggetto = FALSE, $parametriExtra = FALSE, $esploso = FALSE, $up = FALSE, $etichetta_menu = 'DROPDOWN_AZIONI', $tabella_etichette = NULL, $campo_etichette = NULL) {
	printr($aBottoni);
    array_walk($aBottoni, 'stripcslashesandquote');
    printr($aBottoni);
    $sql = 'SELECT * FROM bottoni WHERE menu IN ('.implode(',', $aBottoni).') ORDER BY ordine';
    dump($sql);
    $rows = $oApp->get('oDb')->eseguiselect($sql);
	$strLi = '';
	if($up){
		$strDropdown = '<div class="btn-group dropup">';
	}
	else{
		$strDropdown = '<div class="btn-group">';
	}
		$strDropdown .= '<button class="btn btn-small btn-primary">'.$oApp->getEtichettaBottone($etichetta_menu).'</button>';
		$strDropdown .= '<button class="btn btn-small btn-primary dropdown-toggle" data-toggle="dropdown"><span class="caret"></span></button>';
		$strDropdown .= '<ul class="dropdown-menu">';
		
		$oUtente = $oApp->get('oUtente');
		
		foreach($rows as $r) {
			extract($r);
			
			if ($oApp->is(UTENTE_TIPO_ID_UTENTE) && strtoupper($menu) == 'MENU_CANDIDATURA_CREA_DROPDOWN' && strtoupper($etichetta) == 'CANDIDATURA_CREA_SEGNALA_LOCALE' && isset($_GET['sezione']) && readGetParam('sezione') == SEZIONE_FRANCHISEE) continue; 
			
			$abilitato = FALSE;
			
			
			$abilitato = FALSE;
			$c1 = ($oUtente !== FALSE);
			$c2 = ($oUtente->haPermesso('MENU_'.$etichetta));
			$c3 = TRUE;
			//$c3 = (stripos(strtolower($etichetta), 'residenziale') === FALSE || $oUtente->gestisceResidenziale());
			$c4 = TRUE;
			//$c4 = (stripos(strtolower($etichetta), 'commerciale') === FALSE || $oUtente->gestisceCommerciale());
			
			/*
			dump(stripos(strtolower($etichetta), 'residenziale'));
			dump($oUtente->gestisceResidenziale());
			dump(stripos(strtolower($etichetta), 'commerciale'));
			dump($oUtente->gestisceCommerciale());
			*/
			
			if ($c1 && $c2 && $c3 && $c4) {
			//if ($oUtente !== FALSE && $oUtente->haPermesso('MENU_'.$etichetta)) {
				$abilitato = TRUE;
			}
		
			/*
			$aPermessi = explode(',', $permesso);
			$abilitato = FALSE;
			foreach ($aPermessi as $p) {
				if ($oUtente->haPermesso(constant($p))) {
					$abilitato = TRUE;
					break;					
				}
			}
			*/
			
			if ($abilitato) {
				$extra = '';
				if ($parametriExtra !== FALSE) {
					if (stripos($pagina, '?') !== FALSE) {
						$pagina .= '&';
					} else {
						$pagina .= '?';
					}
					$pagina .= $parametriExtra;
				}
				
				if (!empty($tabella_etichette) && !empty($campo_etichette)) {
					$where = substr($pagina, stripos($pagina,'?')+1);
				}
				
				if ($oOggetto !== FALSE) {
					$extra = ' oggetto="'.$oOggetto->get('classe').'" id_oggetto="'.writeGetParam($oOggetto->getId()).'"';
					if (stripos($pagina, '?') !== FALSE) {
						$pagina .= '&';
					} else {
						$pagina .= '?';
					}
					$pagina .= 'oggetto='.urlencode($oOggetto->get('classe')).'&id_oggetto='.urlencode(writeGetParam($oOggetto->getId()));
				}
				
				if ($esploso === TRUE) {
					$strLi .= '<a href="'.URL_BACKEND.$pagina.'" class="btn '.$style.'" id="'.$id.'_'.$id_menu.'" title="'.$oApp->getEtichettaBottone($etichetta).'"'.((!empty($target_blank))?' target="_blank"':'').'>';
					if (!empty($classe_icona)) $strLi .= '<i class="'.$classe_icona.' icon-white"></i>&nbsp;';
					if (!empty($tabella_etichette) && !empty($campo_etichette)) {
						$sql = 'SELECT '.$campo_etichette.' FROM '.$tabella_etichette.' WHERE '.$where;
						$strLi .= $oApp->get('oDb')->eseguiselect($sql, CLASS_DB_SELECT_MODE_SINGLE_VALUE);
					} else {
						$strLi .= $oApp->getEtichettaBottone($etichetta);
					}
					$strLi .= '</a>';
				} else {
					if (!empty($strLi)) $strLi .= '<li class="divider"></li>';
					$strLi .= '<li>';
					$strLi .= '<a href="'.URL_BACKEND.$pagina.'" id="'.$id.'_'.$id_menu.'" title="'.$oApp->getEtichettaBottone($etichetta).'"'.((!empty($target_blank))?' target="_blank"':'').'>'.$oApp->getEtichettaBottone($etichetta).'</a>';
					$strLi .= '</li>';
				}
			}
		}
		$strDropdown .= $strLi;
		$strDropdown .= '</ul>';
	$strDropdown .= '</div>';
	
	if ($esploso === TRUE) {
		$str = $strLi; 
	} else {
		$str = $strDropdown; 
	}
	
	return $str;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function setupElementiComuniJs() {
	return '<script>setup_elementi_comuni();</script>';
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function alert_block(&$oApp, $etichetta_titolo, $etichetta_testo = '', $style = '', $etichetta_bottone = '', $oggetto_bottone = FALSE) {
	$str  = '';
	$str .= '<div class="alert '.$style.' adjusted alert-block">';
	$str .= '<a class="close">×</a>';
	$str .= '<h4 class="alert-heading">'.$oApp->getEtichetta($etichetta_titolo).'</h4>';
	if (!empty($etichetta_testo)) $str .= '<p>'.$oApp->getEtichetta($etichetta_testo).'</p>';
	if (!empty($etichetta_bottone)) $str .= bottone($oApp, strtoupper($etichetta_bottone), strtolower($etichetta_bottone), $oggetto_bottone);
	$str .= '</div>';
	
	return $str;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function etichettaND($stringa) {
	if(empty($stringa)){
		return 'N.D.';
	}
	else{
		return $stringa;
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function stampaRigaStatistica($etichetta, $valore) {
	echo '<div class="row-fluid"><div class="span4">'.$etichetta.':</div><div class="span8">'.$valore.'</div></div>';
}
/*********************************************************************************************************/
/*********************************************************************************************************/
function stampa_privacy_frontend() {
?>

     <div class="control-group">
	   <p>Informativa ai sensi dell'art. 13 del D.Lgs. n. 196/2003 in materia di protezione dei dati personali (Privacy). </p>
	   <div class="controls" style="overflow: auto; height: 80px; font-size: 9px;">
	        
		Il D.Lgs. 30 Giugno 2003 n. 196 (CODICE IN MATERIA DI PROTEZIONE 
		DEI DATI PERSONALI) prevede la tutela delle persone e di altri 
		soggetti rispetto al trattamento dei dati personali.  Secondo la 
		normativa indicata, tale trattamento sar&agrave; improntato ai 
		principi di correttezza, liceit&agrave; e trasparenza e di tutela 
		della Sua riservatezza e dei Suoi diritti. Ai sensi dell'articolo 13 
		del D.lgs. n.196/2003, pertanto, Le forniamo le seguenti informazioni:<br />
		<br />
		1. RACCOLTA DEI DATI<br />
		La raccolta dei dati avviene mediante il sito primacasa.it di 
		titolarit&agrave; di Primacasa S.p.A.. In ogni caso, come sar&agrave; 
		in seguito specificato, Titolare del trattamento dei Suoi dati &egrave; 
		l'Impresa Affiliata alla Rete in Franchising di Primacasa S.p.A. 
		corrispondente alla zona prescelta, al quale i Suoi dati sono direttamente 
		inviati, a mezzo di interfacce web, al momento della compilazione 
		da parte Sua del modulo visualizzato sul sito primacasa.it, nella 
		sezione Richiesta di un Immobile. Primacasa S.p.A, pertanto, svolge 
		solamente un servizio telematico di comunicazione e invio di dati ai 
		quali non pu&ograve; accedere e che non pu&ograve; visualizzare e/o 
		memorizzare. Si specifica che tali Imprese Affiliate sono soggetti 
		giuridicamente ed amministrativamente autonomi. La raccolta riguarda 
		soltanto dati comuni che saranno oggetto di trattamento nei limiti 
		strettamente pertinenti agli obblighi, ai compiti ed alle finalit&agrave; 
		del Trattamento di seguito specificate.<br />
		<br />
		2. FINALITA' DELLA RACCOLTA DEI DATI<br />
		La raccolta e il trattamento dei dati personali sono finalizzati:<br />
		1. ad adempiere alla richiesta dell'interessato di ricerca di un 
		immobile secondo le caratteristiche indicate, ai fini di un eventuale 
		acquisto/vendita/valutazione/affitto/permuta nella provincia selezionata.<br />
		2.  all'invio del materiale pubblicitario o per il compimento di ricerche 
		di mercato o di comunicazione commerciale. <br />
		<br />
		3. CONFERIMENTO DEI DATI<br />
		Il conferimento dei dati personali da parte dell'interessato, per le 
		finalit&agrave; di cui sopra, &egrave; facoltativo, ma un eventuale 
		rifiuto a fornirli determina l'impossibilit&agrave; di contattare l'interessato 
		al fine di comunicare l'esito della ricerca. <br />
		<br />
		4. COMUNICAZIONE DEI DATI<br />
		I dati forniti saranno trattati direttamente dalle Imprese Affiliate alla Rete 
		in Franchising di Primacasa S.p.A. della zona selezionata ai soli fini sopra 
		indicati e potranno essere comunicati ai dipendenti e collaboratori delle 
		medesime imprese affiliate alla rete in franchising di Primacasa S.p.A. per 
		l’adempimento della richiesta, a soggetti interessati alla vendita/affitto/permuta 
		di immobili, a soggetti terzi incaricati di effettuare la ricerca di immobili 
		nella provincia/zona selezionata, ad Altre Imprese Affiliate alla Rete in 
		Franchising di Primacasa S.p.A. che hanno competenza sulla zona prescelta. 
		Si specifica che tali Imprese Affiliate sono soggetti giuridicamente ed 
		amministrativamente autonomi.<br />
		<br />
		5. MODALITA' DEL TRATTAMENTO<br />
		Il trattamento dei dati si svolger&agrave; in conformit&agrave; con quanto 
		previsto dal D.Lgs. n. 196/2003 e sar&agrave; effettuato sia manualmente sia 
		con l'ausilio di mezzi informatici e telematici presso la sede dell'Impresa 
		Affiliata a Primacasa a cui sono stati comunicati. L'Impresa Affiliata a 
		Primacasa custodisce e gestisce i dati personali oggetto del trattamento 
		in modo da ridurre al minimo i rischi di distruzione o perdita, anche 
		accidentale, nonch&eacute; di accesso non autorizzato o di trattamento 
		non consentito o non conforme alle finalit&agrave; di raccolta. Si specifica 
		che tali Imprese Affiliate sono soggetti giuridicamente ed amministrativamente 
		autonomi.<br />
		<br />
		6. DIRITTI DELL'INTERESSATO<br />
		Come previsto dall'art. 7 del D. LGS. N. 196/2003, l'interessato potr&agrave; 
		ottenere in qualsiasi momento la rettifica, l'aggiornamento, l'integrazione, 
		la cancellazione, la trasformazione in forma anonima o il blocco dei dati 
		trattati in violazione di legge; l'attestazione che tutte le suddette operazioni 
		sono state portate a conoscenza di coloro ai quali i dati sono stati comunicati 
		nei limiti dell'art 7 comma 3 lettera c) del D. Lgs. 196/2003; di opporsi 
		legittimamente al trattamento dei dati che la riguardano o quelli che sono 
		trattati al fine dell'invio del materiale pubblicitario o per il compimento di 
		ricerche di mercato o di comunicazione commerciale scrivendo all'Impresa Affiliata 
		a Primacasa corrispondente alla zona scelta al momento della richiesta, il cui 
		nominativo e indirizzo &egrave; reperibile al sito primacasa.it (sezione: punti 
		vendita). Si specifica che tali Imprese Affiliate sono soggetti giuridicamente 
		ed amministrativamente autonomi.<br />
		<br />
		TITOLARE DEL TRATTAMENTO<br />
		Il titolare del trattamento &egrave; l'Impresa Affiliata a Primacasa presente 
		nella provincia scelta al momento della richiesta alla quale potete rivolgerVi 
		per esercitare i diritti previsti dall'art. 7 del D. Lgs. 196/2003 il cui 
		nominativo e indirizzo &egrave; reperibile al sito primacasa.it (sezione: punti 
		vendita). Si specifica che tali Imprese Affiliate sono soggetti giuridicamente ed 
		amministrativamente autonomi.<br />
		<br />
		MANIFESTAZIONE DI CONSENSO <br />
		Con la compilazione del Modulo "Richiesta di un immobile" dichiaro di aver preso 
		conoscenza dell'informativa ed esprimo il mio consenso alla comunicazione dei dati 
		personali ed al trattamento degli stessi, per le finalit&agrave; e dai soggetti 
		indicati nell'informativa stessa, consapevole che in difetto del consenso, non si 
		potr&agrave; completare utilmente il processo di selezione.<br />
     
		</div><!-- /.controls -->
        
         <p>Il/La sottoscritto/a, acquisite le informazioni fornite dal titolare del trattamento ai sensi dell'articolo 13 del D.Lgs. 196/2003, presta il suo consenso al trattamento dei dati personali per i fini indicati nella suddetta informativa e con le modalità indicate nella stessa.</p>
         
	</div><!-- /.control-group -->  

  
<?php
}
/*********************************************************************************************************/
/*********************************************************************************************************/
?>