#!/bin/bash

# NOME=`cat /usr/local/dominaplus/launcher/tsconf.xml | grep monitoringname | sed s/">"/" "/g | sed s/"<"/" "/g | awk {'print $2'}`

MEMTOTALE=`free | grep Mem | awk '{print $2}'`
MEMUSATA=`free | grep Mem | awk '{print $3}'`
MEMLIBERA=`free | grep Mem | awk '{print $4}'`
PERCUSATA=`echo "scale=2;"$MEMUSATA"*100/"$MEMTOTALE | bc`
DISCOUSATO=`df | grep "root" | awk '{print $5" "$4}'`
UPTIME=`uptime | sed s/' '/'#'/g | sed s/','/' '/g | awk {'print $1'} | sed s/"#up"/' '/g |  awk {'print $2'} | sed s/'#'/' '/g`

PIDYASS=`pstree -p | grep "\-yass3client(" | sed s/-yass3client/'#'/ | tail -n 1 | sed s/-+-{/'#'/ | awk 'BEGIN { FS = "#" };{print $2 }' | sed s/'('/' '/ | sed s/')'/' '/ | sed s/' '/''/g`

THYASS=`pstree -p | grep "yass3client" | wc -l`
VMYASS=`pmap -x ${PIDYASS} | tail -n 1 | awk '{print $3}'`
VERYASS=`/root/yass3client --version | grep VER: | sed s/' '/"#"/g | sed s/":"/' '/g | awk {'print $2'} | sed s/"#"/' '/g`
LIFEYASS=`ps aux | grep $PIDYASS | grep yass3client | awk {'print $9'}`
MACADDRESS=`/sbin/ifconfig eth0 | grep HWaddr | awk {'print $5'}`

IPPRIVATO=`/sbin/ifconfig eth0 | grep "inet addr" | awk {'print $2'} | sed s/:/' '/g | awk {'print $2'}`
SUBNET=`ifconfig eth0 | grep Mask | awk {'print $4'} | sed s/':'/' '/ | awk {'print $2'}`
GATEWAY=`/sbin/route -n | grep UG | awk {'print $2'}`

ORA=`/bin/date`

echo "pid="$PIDYASS
echo "ipaddress="$IPPRIVATO
echo "subnet="$SUBNET
echo "gateway="$GATEWAY
echo "uptime="$UPTIME
echo "memory / total="$MEMUSATA" / "$MEMTOTALE
echo "flash="$DISCOUSATO
echo "virtual memory="$VMYASS
echo "threads="$THYASS
echo "service start datetime="$LIFEYASS
echo "server version="$VERYASS